/*
 *Classe que implementa o comando Abrir Garra
 * @author Gabriel Balestrin
 */

package Commands;

public class InstrCG extends AbstractInstruction {


    public InstrCG(int line){
        this.line = line;
    }


    public Instruction execute(BlockContext inThisContext) {
		System.out.println("Executing CG...");

                /* If Scene is null*/
                if(inThisContext.getScene() == null){
                    inThisContext.informError(ErrorMessages.ERROR_SCENE,line,"");
                }else{
                    /* execute command that close virbot griper*/
                    inThisContext.getScene().abrirFecharGarra(5);
                }
                /* Sleep a time while virbot move*/
                try {
                  Thread.sleep(400);
                } catch (InterruptedException e) {
                  System.out.println(e.getMessage());
                  /* Stop compiler cause something is wrong*/
                  inThisContext.stop();
                }
		return nextInstruction;
	}


}
