/*
 * @author Gabriel Balestrin
 */
package Commands;

import virbot4u.JanelaDigital;

public class InstrII extends AbstractInstruction {

    private Nodo iiToken;
    private String toLabel;
    private boolean onOff;

        public InstrII(Nodo iiToken, boolean onOff, String toLabel, int line){
            this.iiToken = iiToken;
            this.toLabel = toLabel;
            this.onOff = onOff;
            this.line = line;
        }

	public Instruction execute(BlockContext inThisContext) {
		System.out.println("II "+toLabel);
                float cond = iiToken.value(inThisContext, line);

                /* Inputs 1...8 */
                if(JanelaDigital.getInput((int)cond, onOff) == null){
                    inThisContext.informError(ErrorMessages.ERROR_INPUT,line,""+cond);
                }
                else{
                    if(JanelaDigital.getInput((int)cond, onOff).isSelected() == true){
                        return nextInstruction;
                    }
                }
                //JU or CS

		return inThisContext.getInstrForLabel(toLabel);

	}
}
