/*
 * @author Gabriel Balestrin
 */
package Commands;


public class InstrJA extends AbstractInstruction {

    private Nodo value;

    public InstrJA(Nodo value, int line){
        this.line = line;
        this.value = value;
    }

    public Instruction execute(BlockContext inThisContext) {
		System.out.println("Executing CG...");

                if(inThisContext.getScene() == null){
                    inThisContext.informError(ErrorMessages.ERROR_SCENE,line,"");
                }
                else{
                    if(value.value(inThisContext, line)!= 0) //Open Gripper
                        inThisContext.getScene().abrirFecharGarra(4);
                    else // Close Gripper
                        inThisContext.getScene().abrirFecharGarra(5);
                }
                
                try {
                  Thread.sleep(400);
                } catch (InterruptedException e) {
                  System.out.println(e.getMessage());
                  inThisContext.stop();
                }
		return nextInstruction;
	}


}
