/*
 * @author Gabriel Balestrin
 */
package Commands;

public class InstrJU extends AbstractInstruction {
	private String toLabel;
        
	public InstrJU(String toLabel, int line) {
		this.toLabel = toLabel;
                this.line = line;
        }

	public void setNext(Instruction next) {
		// do nothing, ignore next
	}
	public Instruction execute(BlockContext inThisContext) {
                this.nextInstruction = inThisContext.getInstrForLabel(toLabel);

                if(this.nextInstruction == null){
                    inThisContext.informError(ErrorMessages.ERROR_LABEL,line,toLabel);
                }
                                
		return this.nextInstruction;
	}

}
