/*
 * @author Gabriel Balestrin
 */
package Commands;



public class InstrWT extends AbstractInstruction {

        private int time;

	public InstrWT(String time, int line) {
		this.time = Integer.parseInt(time);
                this.line = line;
        }

	public Instruction execute(BlockContext inThisContext) {
            System.out.println("Executing WT "+time+"...");

            try {
                Thread.sleep(time);
            } catch (InterruptedException e) {
                inThisContext.stop();
            }
            
            return nextInstruction;
	}

}
