/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ELearning;

import virbot4u.CenaX3D;
import javax.swing.*;
import java.awt.*;
import java.io.*;
import java.util.Date;
import java.text.SimpleDateFormat;
/**
 *
 * @author Cleber
 */
public class Metricas{
    public Tarefa tarefa;
    public String dt;
    public String hr;
    Cronometro cron;
    public Metricas(Tarefa tarefa){
        this.tarefa = tarefa;
    }
    public void iniMetricas(int metricas[],CenaX3D cena){
        if(metricas[6]==1){
            //abilita obter colisão para depois por no arquivo.. na tarefa e depois dela ***********
            System.out.println("Número de colisões durante o desenvolvimento da solução");
            cena.contacolisao=0;
        }
        if(metricas[8]==1){
            //movimento de camera... ante e depois *********************
            System.out.println("Dificuldade de visualização");
        }
        Date data = new Date();
        SimpleDateFormat formatador = new SimpleDateFormat("dd/MM/yyyy");
        dt = (""+formatador.format( data ));
        hr = (""+data.getHours()+":"+data.getMinutes()+":"+data.getSeconds());
    }
    public void arquivoFinal(int metricas[],CenaX3D cena, String nome,String descri, String posi,String ori,String deit, String fposi,String fori,String nomeUsuario){
        File f = new File("ELR\\"+nome+"-"+nomeUsuario+".elr");
        try {
            FileOutputStream arq = new FileOutputStream(f);
            // estabelece o arquivo físico
            DataOutputStream entrada = new DataOutputStream(arq);
            // associa o arquivo lógico ao arquivo físico
            entrada.writeBytes("Nome da tarefa: "+nome+"\n\n");
            entrada.writeBytes("Descrição: "+descri+"\n");
            entrada.writeBytes("Data: "+dt+"\n\n");
            entrada.writeBytes("Nome do aluno: "+nomeUsuario+"\n\n");
            entrada.writeBytes("Hora de início: "+hr+"\n\n");
            cena.jp.getsalvaArquivo().salvaPrograma(new JTextField(nome+"-"+nomeUsuario));
            cena.jp.getsalvaArquivo().salvaPontos(new JTextField(nome+"-"+nomeUsuario));
            cena.jp.getsalvaArquivo().salvaObjetos(new JTextField(nome+"-"+nomeUsuario));
            if(metricas[0]==1){
                //pegar tempo do cronometro... final da tarefa
                entrada.writeBytes("Tempo para desenvolver: "+tarefa.cronometro.tempo()+"\n\n");
            }
            if(metricas[1]==1){
                //executar e pegar o tempo até parar... final da tarefa
                if(cena.jp.getJanelaProg()!=null){
                    Date data2 = new Date();
                    cena.jp.getJanelaProg().executarPrograma();
                    Date data3 = new Date();
                    entrada.writeBytes("Tempo para execução da tarefa: "+((data3.getTime()-data2.getTime())/1000)+" seg\n\n");
                }
                else entrada.writeBytes("Tempo para execução da tarefa: - \n\n");
            }
            if(metricas[2]==1){
                //pego pelo codigo do usuario... final da tarefa
                if(cena.jp.getJanelaProg().getTxtProgSave()!=null)
                    entrada.writeBytes("Caminho percorrido pelo robô: "+cena.jp.getJanelaProg().getTxtProgSave().getText()+"\n\n");
                else
                    entrada.writeBytes("Caminho percorrido pelo robô: -\n\n");
            }
            if(metricas[3]==1){
                //pegar da janela de pontos... final da tarefa
                if(cena.jp.getJanelaPonto()!=null)
                   entrada.writeBytes("Número de pontos: "+cena.jp.getJanelaPonto().numPonto+"\n\n");
                else
                   entrada.writeBytes("Número de pontos: 0\n\n");
            }
            if(metricas[4]==1){
                //compara dado com feito... final da tarefa
                int cont=1;
                String parte="";
                String valor = "";
                entrada.writeBytes("Precisão no posicionamento:");
                while(cont+1<posi.length()){
                    parte = parte + posi.substring(cont,cont+1);
                    if(posi.substring(cont,cont+1).equals(".")){
                        parte=parte.substring(0, parte.length()-1);
                        cont++;
                        int i=0;
                        while(i<cena.jp.getJanelaObj().getNObjetos()){ //quantidade de objetos 
                            if(cena.partManager.getListaNomesObj()[i].equals(parte)){ //nome do objeto for igual a parte
                                double x,y,z =0;
                                while(!posi.substring(cont,cont+1).equals(",")){
                                    valor = valor+posi.substring(cont,cont+1);
                                    cont++;
                                }
                                entrada.writeBytes(" "+parte+"(x="+(Double.parseDouble(valor)-(cena.partManager.getListaQuadrante().getObbTreePos(i).getRoot().getCentro()[0])*640));  //escreve no arquivo: xo-xe
                                x=(Double.parseDouble(valor)-(cena.partManager.getListaQuadrante().getObbTreePos(i).getRoot().getCentro()[0])*640);
                                valor="";
                                cont++;
                                while(!posi.substring(cont,cont+1).equals(",")){
                                    valor = valor+posi.substring(cont,cont+1);
                                    cont++;
                                }
                                entrada.writeBytes(",y="+(Double.parseDouble(valor)-(cena.partManager.getListaQuadrante().getObbTreePos(i).getRoot().getCentro()[1]+0.48)*640));  //escreve no arquivo: yo-ye
                                y=(Double.parseDouble(valor)-(cena.partManager.getListaQuadrante().getObbTreePos(i).getRoot().getCentro()[1]+0.48)*640);
                                valor="";
                                cont++;
                                while(!posi.substring(cont,cont+1).equals(" ")){
                                    valor = valor+posi.substring(cont,cont+1);
                                    cont++;
                                    if(cont+1>=posi.length()) break;
                                }
                                entrada.writeBytes(",z="+(Double.parseDouble(valor)-(cena.partManager.getListaQuadrante().getObbTreePos(i).getRoot().getCentro()[2])*640));  //escreve no arquivo: zo-ze
                                z=(Double.parseDouble(valor)-(cena.partManager.getListaQuadrante().getObbTreePos(i).getRoot().getCentro()[2])*640);
                                System.out.println("x: "+x+" y: "+y+" z: "+z+" t: "+(x*x + y*y + z*z)+" m: "+Math.sqrt(x*x + y*y + z*z));
                                entrada.writeBytes(",distancia= "+String.format("%.2f",Math.sqrt(x*x + y*y + z*z))+") ");
                                valor="";
                                i=cena.jp.getJanelaObj().getNObjetos();
                            }
                            i++;
                        }
                        parte="";
                    }
                    cont++;
                }
                entrada.writeBytes("\n\n");
            }
            if(metricas[5]==1){
                //compara dado com feito... final da tarefa
                int cont=1;
                String parte="";
                String valor = "";
                double valor2;
                entrada.writeBytes("Orientação dos objetos:");
                while(cont+1<ori.length()){
                    parte = parte + ori.substring(cont,cont+1);
                    if(ori.substring(cont,cont+1).equals(".")){
                        parte=parte.substring(0, parte.length()-1);
                        cont++;
                        int i=0;
                        while(i<cena.jp.getJanelaObj().getNObjetos()){ //quantidade de objetos
                            if(cena.partManager.getListaNomesObj()[i].equals(parte)){ //nome do objeto for igual a parte
                                while(!ori.substring(cont,cont+1).equals(" ")){
                                    valor = valor+ori.substring(cont,cont+1);
                                    cont++;
                                    if(cont+1>=ori.length()) break;
                                }
                                if(cena.partManager.getListaQuadrante().tipoComponente(i).equals(("class Objetos.Cilindro")))
                                {
                                    if(cena.partManager.getListaQuadrante().getComponenteCilindro(i).getAnguloX()==1.57){
                                        valor2 = (cena.partManager.getListaQuadrante().getComponenteCilindro(i).getAnguloY()*57.32484);
                                        while(valor2>90) valor2=valor2-90;
                                        while(valor2<-90) valor2=valor2+90;
                                        entrada.writeBytes(" "+parte+"="+(Double.parseDouble(valor)-valor2+" "));  //escreve no arquivo: zo-ze
                                    }
                                    else{
                                        entrada.writeBytes(" "+parte+"=0.0 ");
                                    }
                                }
                                if(cena.partManager.getListaQuadrante().tipoComponente(i).equals(("class Objetos.Paralelepipedo")))
                                {
                                    valor2 = (cena.partManager.getListaQuadrante().getComponenteParalelepipedo(i).getAngulo()*57.32484);
                                    while(valor2>90) valor2=valor2-90;
                                    while(valor2<-90) valor2=valor2+90;
                                    entrada.writeBytes(" "+parte+"="+(Double.parseDouble(valor)-valor2)+" ");  //escreve no arquivo: zo-ze
                                }
                                valor="";
                                valor2=0;
                                i=cena.jp.getJanelaObj().getNObjetos();
                            }
                            i++;
                        }
                        parte="";
                    }
                    cont++;
                }
                entrada.writeBytes("\n\n");
            }
            if(metricas[6]==1){
                //abilita obter colisão para depois por no arquivo.. na tarefa e depois dela ***********
                entrada.writeBytes("Número de colisões: "+cena.contacolisao+"\n\n");
            }
            if(metricas[7]==1){
                //programa... final da tarefa
                if(cena.jp.getJanelaProg().getTxtProgSave()!=null)
                   entrada.writeBytes("Economia de movimentos: "+cena.jp.getJanelaProg().getTxtProgSave().getText()+"\n\n");
                else
                   entrada.writeBytes("Economia de movimentos: -\n\n");
            }
            if(metricas[8]==1){
                //movimento de camera... ante e depois *********************
                entrada.writeBytes("Dificuldade de visualização\n\n");
            }
            if(metricas[9]==1){
                //testo... add fdt
                //entrada.writeBytes("Capacidade de especificar\n\n");
            }
            if(metricas[10]==1){
                //verificar folga com obtido... depois da tarefa
                entrada.writeBytes("Conclusão da tarefa:");
                int cont=1;
                String parte="";
                String valor = "";
                int termino = 1;
                while(cont+1<posi.length()){
                    parte = parte + posi.substring(cont,cont+1);
                    if(posi.substring(cont,cont+1).equals(".")){
                        parte=parte.substring(0, parte.length()-1);
                        cont++;
                        int i=0;
                        while(i<cena.jp.getJanelaObj().getNObjetos()){ //quantidade de objetos
                            if(cena.partManager.getListaNomesObj()[i].equals(parte)){ //nome do objeto for igual a parte
                                while(!posi.substring(cont,cont+1).equals(",")){
                                    valor = valor+posi.substring(cont,cont+1);
                                    cont++;
                                }
                                if((Double.parseDouble(valor)+Double.parseDouble(fposi))>((cena.partManager.getListaQuadrante().getObbTreePos(i).getRoot().getCentro()[0])*640) && (Double.parseDouble(valor)-Double.parseDouble(fposi))<((cena.partManager.getListaQuadrante().getObbTreePos(i).getRoot().getCentro()[0])*640));
                                else termino=0;
                                valor="";
                                cont++;
                                while(!posi.substring(cont,cont+1).equals(",")){
                                    valor = valor+posi.substring(cont,cont+1);
                                    cont++;
                                }
                                if((Double.parseDouble(valor)+Double.parseDouble(fposi))>((cena.partManager.getListaQuadrante().getObbTreePos(i).getRoot().getCentro()[1]+0.48)*640) && (Double.parseDouble(valor)-Double.parseDouble(fposi))<((cena.partManager.getListaQuadrante().getObbTreePos(i).getRoot().getCentro()[1]+0.48)*640));
                                else termino=0;
                                valor="";
                                cont++;
                                while(!posi.substring(cont,cont+1).equals(" ")){
                                    valor = valor+posi.substring(cont,cont+1);
                                    cont++;
                                    if(cont+1>=posi.length()) break;
                                }
                                if((Double.parseDouble(valor)+Double.parseDouble(fposi))>((cena.partManager.getListaQuadrante().getObbTreePos(i).getRoot().getCentro()[2])*640) && (Double.parseDouble(valor)-Double.parseDouble(fposi))<((cena.partManager.getListaQuadrante().getObbTreePos(i).getRoot().getCentro()[2])*640));
                                else termino=0;
                                valor="";
                                i=cena.jp.getJanelaObj().getNObjetos();
                            }
                            i++;
                        }
                        parte="";
                    }
                    cont++;
                }
                cont=1;
                parte="";
                valor = "";
                double valor2;
                while(cont+1<ori.length()){
                    parte = parte + ori.substring(cont,cont+1);
                    if(ori.substring(cont,cont+1).equals(".")){
                        parte=parte.substring(0, parte.length()-1);
                        cont++;
                        int i=0;
                        while(i<cena.jp.getJanelaObj().getNObjetos()){ //quantidade de objetos
                            if(cena.partManager.getListaNomesObj()[i].equals(parte)){ //nome do objeto for igual a parte
                                while(!ori.substring(cont,cont+1).equals(" ")){
                                    valor = valor+ori.substring(cont,cont+1);
                                    cont++;
                                    if(cont+1>=ori.length()) break;
                                }
                                if(cena.partManager.getListaQuadrante().tipoComponente(i).equals(("class Objetos.Cilindro"))){
                                    valor2 = (cena.partManager.getListaQuadrante().getComponenteCilindro(i).getAnguloY()*57.32484);
                                    while(valor2>90) valor2=valor2-90;
                                    while(valor2<-90) valor2=valor2+90;
                                    if(((Double.parseDouble(valor)+Double.parseDouble(fori))>valor2 && (Double.parseDouble(valor)-Double.parseDouble(fori))<valor2) || (cena.partManager.getListaQuadrante().getComponenteCilindro(i).getAnguloX()==1.57));
                                    else termino=0;
                                }
                                if(cena.partManager.getListaQuadrante().tipoComponente(i).equals(("class Objetos.Paralelepipedo"))){
                                    valor2 = (cena.partManager.getListaQuadrante().getComponenteParalelepipedo(i).getAngulo()*57.32484);
                                    while(valor2>90) valor2=valor2-90;
                                    while(valor2<-90) valor2=valor2+90;
                                    if((Double.parseDouble(valor)+Double.parseDouble(fori))>valor2 && (Double.parseDouble(valor)-Double.parseDouble(fori))<valor2);
                                    else termino=0;
                                }
                                valor="";
                                valor2=0;
                                i=cena.jp.getJanelaObj().getNObjetos();
                            }
                            i++;
                        }
                        parte="";
                    }
                    cont++;
                }
                if(termino==1) entrada.writeBytes(" Tarefa concluida\n\n");
                if(termino==0) entrada.writeBytes(" Tarefa não concluida\n\n");
            }
            //janelaQTeoricas = new JanelsQTeoricas(cena, cena.jp.tamanhoJanela());
            //entrada.writeBytes("Questão teórica: "+janelaQTeoricas.getResposta()+"\n\n");
            if(metricas[11]==1) entrada.writeBytes("Número de manipulações: "+cena.NManipulacoesClick+" Teclado= "+cena.NManipulacoesTeclado+" Mouse= "+(cena.NManipulacoesClick-cena.NManipulacoesTeclado)+"\n\n");
            if(metricas[12]==1) entrada.writeBytes("Número de tentativas de preensão: "+cena.NPreencaoO+" Objetos fixos= "+(cena.NPreencaoOF-cena.NPreencaoOM)+" Objetos moveis= "+cena.NPreencaoOM+"\n\n");
            entrada.writeBytes("Nome do arquivo de objetos gerados: "+nome+"-"+nomeUsuario+".x3d\n\n");
            if(cena.jp.getJanelaPonto()!=null) entrada.writeBytes("Nome do arquivo de pontos gerados: "+nome+"-"+nomeUsuario+".pnt\n\n");
            else   entrada.writeBytes("Nome do arquivo de pontos gerados: -\n\n");
            if(cena.jp.getJanelaProg()!=null) entrada.writeBytes("Nome do arquivo de programa gerado: "+nome+"-"+nomeUsuario+".prg\n\n");
            else   entrada.writeBytes("Nome do arquivo de programa gerado: -\n\n");
            entrada.close();
        } catch (FileNotFoundException e1) {
            System.out.print("Não foi possivel estabelece o arquivo físico");
        }  catch (IOException e2) {
            System.out.print("Não foi associa o arquivo lógico ao arquivo físico");
        }
    }

}
