package Objetos; 

import Colisao.ObbTree;
import virbot4u.CenaX3D;
import virbot4u.JanelaObjetos;

public class ListaQuadrante{

public Object lista[] = new Object[30];
public String nomeLista = new String();
public int fixo[] = new int [30];
int qtdObj = 0;
public double xMax;
public double xMin;
public double zMax;
public double zMin;
public static PartManager obj;
public static JanelaObjetos Jobj;
	
public ListaQuadrante (double xmax,double xmin,double zmax,double zmin ){
	xMax=xmax;
	xMin=xmin;
	zMax=zmax;
	zMin=zmin;
}

public void insereObjeto(Object o,int fixos)
{
    lista[qtdObj] = o;
    fixo[qtdObj] = fixos;
	qtdObj++;
}
public void insereObjeto(Object o,int fixos,int num)
{
    lista[num] = o;
    fixo[num] = fixos;
}

    public void setLista(Cilindro aux, CenaX3D cena,int fixos) {
        insereObjeto(aux,fixos);
        obj = cena.getPartManager();
        int deitado=0;
        if(aux.getAnguloX()==1.57) deitado=1;
        obj.setString(obj.geraStringX3DCilindro(aux, qtdObj,deitado));
        Jobj.setLObjetos(aux);
        if(aux.getPosicao()[0]<=0){
            obj.lista1[obj.numObjL1] = obj.numObj;
            obj.numObjL1++;
        }
        if(aux.getPosicao()[0]>0){
           obj.lista2[obj.numObjL2] = obj.numObj;
           obj.numObjL2++;
        }
        obj.numObj++;
        obj.carregaListasObb();
    }

    public void setLista(Esfera aux, CenaX3D cena,int fixos) {
        insereObjeto(aux,fixos);
        obj = cena.getPartManager();
        obj.setString(obj.geraStringX3DEsfera(aux, qtdObj));
        Jobj.setLObjetos(aux);
        if(aux.getPosicao()[0]<=0){
            obj.lista1[obj.numObjL1] = obj.numObj;
            obj.numObjL1++;
        }
        if(aux.getPosicao()[0]>0){
           obj.lista2[obj.numObjL2] = obj.numObj;
           obj.numObjL2++;
        }
        obj.numObj++;
        obj.carregaListasObb();
    }

    public void setLista(Paralelepipedo aux, CenaX3D cena,int fixos) {
        insereObjeto(aux,fixos);
        obj = cena.getPartManager();
        int deitado=0;
        if(aux.getAnguloX()==1.57) deitado=1;
        obj.setString(obj.geraStringX3DParalelepipedo(aux, qtdObj,deitado));
        Jobj.setLObjetos(aux);
        if(aux.getPosicao()[0]<=0){
            obj.lista1[obj.numObjL1] = obj.numObj;
            obj.numObjL1++;
        }
        if(aux.getPosicao()[0]>0){
           obj.lista2[obj.numObjL2] = obj.numObj;
           obj.numObjL2++;
        }
        obj.numObj++;
        obj.carregaListasObb();
    }

public int tamanho()
{
	return qtdObj;
}

public Paralelepipedo getComponenteParalelepipedo(int pos)
{
	
	return (Paralelepipedo)lista[pos];
}
public Esfera getComponenteEsfera(int pos)
{
	
	return (Esfera)lista[pos];
}
public Cilindro getComponenteCilindro(int pos)
{
	
	return (Cilindro)lista[pos];
}


public  String tipoComponente(int pos)
{
    Object str = lista[pos];
    return str.getClass().toString();
}

public void removeObjetoPos(int pos)
{
	for(int i = pos ; i < this.qtdObj ; i++){
		lista[i]=lista[i+1];
	}
	this.qtdObj--;

}

public String getNomeObjetoPos(int pos)
{
	String nome = new String();
	Esfera esf;
	Cilindro cil;
	Paralelepipedo par;
	if (this.tipoComponente(pos).startsWith("class Objetos.E")==true )
	{
			esf = this.getComponenteEsfera(pos);
			nome = esf.getNome();
			
	}else
	{
		if (this.tipoComponente(pos).startsWith("class Objetos.C")==true )
		{
				cil = this.getComponenteCilindro(pos);
				nome = cil.getNome();
			
		}else
		if (this.tipoComponente(pos).startsWith("class Objetos.P")==true )
		{
					par = this.getComponenteParalelepipedo(pos);
					nome = par.getNome();
		}
		
	}		
 
	
		
	return nome;		 	
}

public float[] getCorObjPos(int pos)
{
	float cor[]=null;
	Esfera esf;
	Cilindro cil;
	Paralelepipedo par;
	if (this.tipoComponente(pos).startsWith("class Objetos.E")==true )
	{
			esf = this.getComponenteEsfera(pos);
			cor = esf.getCor();
			
	}else
	{
		if (this.tipoComponente(pos).startsWith("class Objetos.C")==true )
		{
				cil = this.getComponenteCilindro(pos);
				cor = cil.getCor();
			
		}else
		if (this.tipoComponente(pos).startsWith("class Objetos.P")==true )
		{
					par = this.getComponenteParalelepipedo(pos);
					cor = par.getCor();
		}
		
	}	
	return cor;		 	
}



public void limpaLista()
{
	this.qtdObj = 0;
	for (int i = 0; i<30 ; i++)
		this.lista[i]=null;
}

public ObbTree getObbTreePos(int pos)
{
	ObbTree obbTree = new ObbTree();
	Esfera esf;
	Cilindro cil;
	Paralelepipedo par;
	
	if (this.tipoComponente(pos).startsWith("class Objetos.E")==true )
	{
		esf = this.getComponenteEsfera(pos);
		obbTree = esf.getObbTree();
	
	}else
	{
		if (this.tipoComponente(pos).startsWith("class Objetos.C")==true )
		{
		cil = this.getComponenteCilindro(pos);
		obbTree = cil.getObbTree();
		}else
		{	
			if (this.tipoComponente(pos).startsWith("class Objetos.P")==true )
			{
				par = this.getComponenteParalelepipedo(pos);
				obbTree = par.getObbTree();
			}
		}
	}

	return obbTree;
}
}
