/*
 * @author Gabriel Balestrin
 */
package Commands;

public class InstrCS extends AbstractInstruction {

	private String routineName;

	public InstrCS(String routineName, int line) {
		this.routineName = routineName;
                this.line = line;
	}

	public Instruction execute(BlockContext inThisContext) {
		System.out.println("CS" + routineName);

                /* Execute subrotine*/
                if(inThisContext.executeRoutine(routineName) == false){
                    inThisContext.informError(ErrorMessages.ERROR_SUBROUTINE, line, routineName);      
                }
		return nextInstruction;
	}
}
