/*
 * @author Gabriel Balestrin
 */
package Commands;

public class InstrOG extends AbstractInstruction {

    public InstrOG(int line){
        this.line = line;
    }

    public Instruction execute(BlockContext inThisContext) {
        System.out.println("Executing OG...");

        /* If Scene is null*/
        if(inThisContext.getScene() == null){
            inThisContext.informError(ErrorMessages.ERROR_SCENE,line,"");
        }else{
            /* execute command that close virbot griper*/
            inThisContext.getScene().abrirFecharGarra(4);
        }
        /* Sleep a time while virbot move*/
        try {
            Thread.sleep(500);
        } catch (InterruptedException e) {
            System.out.println(e.getMessage());
            /* Stop compiler cause something is wrong*/
            inThisContext.stop();
        }
        return nextInstruction;
    }

}
