/*
 * @author Gabriel Balestrin
 */
package Commands;

import javax.swing.ImageIcon;
import virbot4u.JanelaDigital;

public class InstrON extends AbstractInstruction {

    private Nodo inOut;

        public InstrON(Nodo inOut, int line){
            this.inOut = inOut;
            this.line = line;
        }

	public Instruction execute(BlockContext inThisContext) {
		System.out.println("ON ");
                float io = inOut.value(inThisContext, line);

                
                if(JanelaDigital.getOutput((int)io) == null){
                    inThisContext.informError(ErrorMessages.ERROR_INPUT,line,""+io);
                }
                else{
                    JanelaDigital.getOutput((int)io).setIcon(new ImageIcon("Figuras/signal_on.gif"));
                }
                
		return nextInstruction;

	}
}
