/*
 * @author Gabriel Balestrin
 */
package Commands;

import Robo.Ponto;
import virbot4u.JanelaPonto;


public class InstrPS extends AbstractInstruction {
    
    private String msg;

    public InstrPS(String msg, int line){
        this.msg = msg;
        this.line = line;
    }


	public Instruction execute(BlockContext inThisContext) {
		String m="", varName;
                System.out.println(msg);
		int i,j,c=1,cont;
                for(i =0; i<msg.length();i++){

                    if(msg.charAt(i) == '#'){
                        varName = "";
                        for(j =i+1; msg.charAt(j)!= '#' ;j++){
                            varName += msg.charAt(j);
                        }
                        if(inThisContext.isVariable(varName.replace(" ", "")) == false){
                             inThisContext.informError(ErrorMessages.ERROR_NOTVARIABLE,line,varName);
                        }
                        m += inThisContext.getVariable(varName.replace(" ", ""))+" ";
                        i = j+1;

                    }
                    else if(msg.charAt(i) == '$'){
                        varName = "";
                        for(j =i+1; msg.charAt(j)!= '$' ;j++){
                            varName += msg.charAt(j);
                        }
                        i = j+1;
                        if(i < msg.length() && msg.charAt(i) == '@'){
                            String atPoint = "";
                            for(j = i+1; msg.charAt(j)!= '@' ;j++){
                                atPoint += msg.charAt(j);
                            }
                            cont = inThisContext.verificaPontos(varName.replace(" ", ""),line);
                            if(cont == -1){
                                 inThisContext.informError(ErrorMessages.ERROR_POINTPOSITION,line,varName);
                            }
                            Ponto pnt = (Ponto) JanelaPonto.getListaDePontos().getObjeto(cont);
                            if(atPoint.replace(" ", "").equals("X")){
                                m += pnt.getX();
                            }
                            else if(atPoint.replace(" ", "").equals("Y")){
                                m += pnt.getY();
                            }
                            else if(atPoint.replace(" ", "").equals("Z")){
                                m += pnt.getZ();
                            }
                            i = j+1;
                        }
                        else{
                            cont = inThisContext.verificaPontos(varName.replace(" ", ""),line);
                            if(cont == -1)
                                inThisContext.informError(ErrorMessages.ERROR_POINTPOSITION,line,varName);
                            Ponto pnt = (Ponto) JanelaPonto.getListaDePontos().getObjeto(cont);
                            m += pnt.getX()+" "+pnt.getY()+" "+pnt.getZ();
                        }
                    }

                    if(i < msg.length())
                        m += msg.charAt(i);
                }
                System.out.println(m);
                inThisContext.printMessageConsole(m);
		return nextInstruction;
	}


}
