/*
 * @author Gabriel Balestrin
 */
package Commands;

import Robo.Ponto;
import virbot4u.JanelaPonto;


public class InstrRP extends AbstractInstruction {

    private String namePoint;
    private JanelaPonto windowPoint;
    

    public InstrRP(String namePoint, int line){
        this.namePoint = namePoint;
        this.line = line;
    }


	public Instruction execute(BlockContext inThisContext) {
		System.out.println("Executing RP...");
                
                if(inThisContext.getScene() == null){
                    inThisContext.informError(ErrorMessages.ERROR_SCENE,line,"");
                }else{
                    
                    Ponto xyz = new Ponto(namePoint,
                                          inThisContext.getScene().getEixo(),
                                          inThisContext.getScene().getAngulos());
                    if(this.windowPoint.getListaDePontos()==null){
                        inThisContext.informError(ErrorMessages.ERROR_POINTLIST,line,"");
                    }
                    else{
                        int posPoint = inThisContext.verificaPontos(namePoint,line);
                        if(posPoint != -1){
                            inThisContext.informWarning(ErrorMessages.WARNING_POINTDEFINED,line,namePoint);
                        }
                        else{
                            this.windowPoint.getListaDePontos().addO(namePoint, xyz);
                        }
                   }
                }
                return nextInstruction;
	}


}
