/*
 * @author Gabriel Balestrin
 */
package Commands;

public class InstrSVS extends AbstractInstruction {

    private String nameVar;
    private float value;

    public InstrSVS(String nameVar,int line){
        this.line = line;
        this.nameVar = nameVar;
    }

    public Instruction execute(BlockContext inThisContext) {
		System.out.println("Executing CG...");

                /* If gripper is open value = 65, else value = 0*/
                value = (inThisContext.getScene().getStateGripper())? 65: 0;
                inThisContext.createVariable(nameVar, value);

		return nextInstruction;
	}


}
