/*
 * This class isn't a compiler's command, It is used to generate the sintatic tree.
 * Too it's used to calculate the variables, SVC
 * @author Gabriel Balestrin
 */
package Commands;


import Robo.Ponto;
import virbot4u.JanelaPonto;


public class Nodo {

    private String data;
    private Nodo left;
    private Nodo right;
    private int line;

    public Nodo(String data){
        this.data = data;
    }

    public String getData() {
        return data;
    }

    public void setData(String data) {
        this.data = data;
    }

    public Nodo getLeft() {
        return left;
    }

    public void setLeft(Nodo left) {
        this.left = left;
    }

    public Nodo getRight() {
        return right;
    }

    public void setRight(Nodo right) {
        this.right = right;
    }


    public float value(BlockContext inThisContext, int line){
        this.line = line;
        return logicalValue(this,inThisContext);
    }

    /* Calculate the Logical Value of the Expressions*/
    private float logicalValue(Nodo no, BlockContext inThisContext){
        
        if(no.getData().equals("&")){
            if(((int)this.logicalValue(no.getLeft(), inThisContext) & (int)this.logicalValue(no.getRight(), inThisContext)) == 0){
                return 0;
            }
            return 1;
        }
        else if(no.getData().equals("|")){
            if(((int)this.logicalValue(no.getLeft(), inThisContext) | (int)this.logicalValue(no.getRight(), inThisContext)) == 0){
                return 0;
            }
            return 1;
        }
        else if(no.getData().equals("^")){
            if((this.logicalValue(no.getLeft(), inThisContext) != 0) && (this.logicalValue(no.getRight(), inThisContext) == 0)
               || (this.logicalValue(no.getLeft(), inThisContext) == 0) && (this.logicalValue(no.getRight(), inThisContext) != 0)){
                return 0;
            }
            return 1;
        }
        return conditionalValue(no, inThisContext);
    }

    /* Calculate the Conditional Value of the Expressions*/
    private float conditionalValue(Nodo no, BlockContext inThisContext){
            System.out.println(no.getData());
            if(no.getData().equals("<")){
                if(this.conditionalValue(no.getLeft(), inThisContext) < this.conditionalValue(no.getRight(), inThisContext))
                    return 1;
                return 0;
            }
            else if(no.getData().equals(">")){
                System.out.println(no.getData());
                if(this.conditionalValue(no.getLeft(), inThisContext) > this.conditionalValue(no.getRight(), inThisContext))
                    return 1;
                return 0;
            }
            else if(no.getData().equals("<=")){
                if(this.conditionalValue(no.getLeft(), inThisContext) <= this.conditionalValue(no.getRight(), inThisContext))
                    return 1;
                return 0;
            }
            else if(no.getData().equals(">=")){
                if(this.conditionalValue(no.getLeft(), inThisContext) >= this.conditionalValue(no.getRight(), inThisContext))
                    return 1;
                return 0;
            }
            else if(no.getData().equals("==")){
                if(this.conditionalValue(no.getLeft(), inThisContext) == this.conditionalValue(no.getRight(), inThisContext))
                    return 1;
                return 0;
            }
            else if(no.getData().equals("<>")){
                if(this.conditionalValue(no.getLeft(), inThisContext) != this.conditionalValue(no.getRight(), inThisContext))
                    return 1;
                return 0;
            }
            return calcValue(no,inThisContext);
     }

    /* Calculate the Basic Value of the Expressions*/
     private Float calcValue(Nodo no, BlockContext inThisContext){

            if(this.isDigit(no.getData())){
                return (float)Integer.parseInt(no.getData());
            }
            else if(no.getData().equals("+")){
                return (calcValue(no.getLeft(), inThisContext) + calcValue(no.getRight(),inThisContext));
            }
            else if(no.getData().equals("-")){
                return (calcValue(no.getLeft(), inThisContext) - calcValue(no.getRight(),inThisContext));
            }
            else if(no.getData().equals("*")){
                return (calcValue(no.getLeft(), inThisContext) * calcValue(no.getRight(),inThisContext));
            }
            else if(no.getData().equals("/")){
                return (calcValue(no.getLeft(), inThisContext) / calcValue(no.getRight(),inThisContext));
            }
            else if(no.getData().equals("**")){
                return (float)Math.pow(calcValue(no.getLeft(), inThisContext), calcValue(no.getRight(),inThisContext));
            }
            else if(no.getData().equals("%")){
                return (calcValue(no.getLeft(), inThisContext) % calcValue(no.getRight(),inThisContext));
            }
            else if(no.getData().equals("NEG")){
                return -(calcValue(no.getRight(), inThisContext));
            }
            else if(no.getData().equals(".")){
                return calcPoint(no.getLeft(), no.getRight(), inThisContext);
            }
            if (inThisContext.getVariable(no.getData()) == null){
                inThisContext.informError(ErrorMessages.ERROR_NOTVARIABLE,line,no.getData());
            }
            return inThisContext.getVariable(no.getData());
            

      }

     /* Get the gripper axis */
     private float calcPoint(Nodo left, Nodo right, BlockContext inThisContext){
         Ponto pnt;
         if(right.getData().equals("X")){
            pnt = (Ponto) JanelaPonto.getListaDePontos().getObjeto(inThisContext.verificaPontos(left.getData(), line));
            return pnt.getX();
         }
         else if(right.getData().equals("Y")){
            pnt = (Ponto) JanelaPonto.getListaDePontos().getObjeto(inThisContext.verificaPontos(left.getData(),line));
            return pnt.getY();
         }
         else if(right.getData().equals("Z")){
            pnt = (Ponto) JanelaPonto.getListaDePontos().getObjeto(inThisContext.verificaPontos(left.getData(),line));
            return pnt.getZ();
         }
         else{
             inThisContext.informError(ErrorMessages.ERROR_POINTOPERATOR,line,"");
         }
         return 0;

     }

     /* If is digit calculate*/
     private boolean isDigit(String digit){
            for(int i=0; i<digit.length();i++){
                if(!Character.isDigit(digit.charAt(i)))
                    return false;
            }
            return true;
     }
}
