/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package virbot4u;

import Preensao.*;
import Colisao.CollisionManager;
import java.awt.event.KeyEvent;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.*;
import java.util.HashMap;
import org.web3d.x3d.sai.*;

import java.util.Date;
import Colisao.Obb;
import Colisao.ObbTree;
import Robo.*;
import Objetos.PartManager;
import virbot4u.JanelaParametros;
import java.util.Vector;
import java.util.ArrayList;

/**
 *
 * @author Alehoss
 */
public class CenaX3D implements X3DFieldEventListener {

    private static final double TAM_BRACO = 220f;
    private static final double ALTURA = 335f;
    private static final double DESVIO = 20f;
    private static final double TAM_GARRA = 150f;
    private X3DScene mainScene;
    private X3DNode root;
    public JanelaPrincipal jp;
    private SFFloat alfa;
    private SFFloat beta;
    private SFFloat gama;
    private SFFloat elevacao;
    private SFFloat rotacao;
    private SFBool abertura;
    private SFVec3f ponto;
    private SFRotation inBase;
    private SFRotation inAntebraco;
    private SFRotation inBraco;
    private SFRotation inElevacao;
    private SFRotation inRotacao;
    private SFFloat inAbertura;
    private SFBool inPosicaoInicial;
    private SFBool inEixosVisivel;
    private SFBool insensoresAtivos;
    private SFBool inPFPVisivel;
    private SFTime inExecutar;
    private MFNode inAddChildrenGarra;
    private MFNode inRemoveChildrenGarra;
    private SFRotation inAlfa;
    private SFRotation inBeta;
    private SFRotation inGama;
    private SFRotation inElev;
    private SFRotation inRota;
    private SFColor color;
    private int objCol1 = -1;
    private int objCol2 = -1;
    private float listaCores[][] = {{(float) .3, (float) .3, (float) .3},
        {(float) 0, (float) 0.7, (float) 0.5},
        {(float) 0, (float) 0.7, (float) 0.5},
        {(float) 0, (float) 0.7, (float) 0.5},
        {(float) .3, (float) .3, (float) .3}};
    private SFVec3f vBaX;
    private SFVec3f vBaY;
    private SFVec3f vBaZ;
    private SFVec3f vBaPtC;
    private SFVec3f vABX;
    private SFVec3f vABY;
    private SFVec3f vABZ;
    private SFVec3f vABPtC;
    private SFVec3f vBX;
    private SFVec3f vBY;
    private SFVec3f vBZ;
    private SFVec3f vBPtC;
    private SFVec3f vGX;
    private SFVec3f vGY;
    private SFVec3f vGZ;
    private SFVec3f vGPtC;
    private SFVec3f vGPtD1;
    private SFVec3f vGPtD2;
    private SFVec3f vGPtSup;
    private SFVec3f vGPtEixo;
    private ObbTree childrenGarra[] = new ObbTree[4];
    private ObbTree treeDedo1 = new ObbTree();
    private ObbTree treeDedo2 = new ObbTree();
    private ObbTree treeSup = new ObbTree();
    private ObbTree treeEixo = new ObbTree();
    public Obb obbBase = new Obb();
    public Obb obbCorpo = new Obb();
    public Obb obbAntBraco = new Obb();
    public Obb obbBraco = new Obb();
    public Obb obbGarra = new Obb();
    private ObbTree treeBase = new ObbTree();
    private ObbTree treeCorpo = new ObbTree();
    private ObbTree treeAntBraco = new ObbTree();
    private ObbTree treeBraco = new ObbTree();
    private ObbTree treeGarra = new ObbTree();
    public Obb obbDedo1 = new Obb();
    public Obb obbDedo2 = new Obb();
    public Obb obbSup = new Obb();
    public Obb obbEixo = new Obb();
    //private static X3DScene scene;
    private ExternalBrowser x3dBrowser;
    public CollisionManager collisionManager;
    public PartManager partManager;
    public Pegar_Soltar Pegar_soltar;
    private boolean posicaoOK = true;
    X3DNode filhoObj[][] = new X3DNode[1][];
    public static Boolean pego = false;
    public int contacolisao = 0;
    int prim = 0;
    public int NManipulacoesClick = 0;
    public int NManipulacoesTeclado = 0;
    public int NPreencaoO = 0;
    public int NPreencaoOF = 0;
    public int NPreencaoOM = 0;
    public int maxFator = 180;
    public String FolgaAb = "50";
    public String FolgaGeom = "18";
    public int TestePreensao = 2;
    public int usoPreensao = 1;
    public int io = 0;
    public boolean ghostGripper = false;
    public boolean elbowOver = true;
    public int granularity = 50;
    public boolean simulateIK = false;
    private boolean stateGripper = false;
    public String ikValidationFeedback;

    public void PrintPonto(Ponto p) {
        System.out.println(p.getNomePonto() + ": " + p.getX() + ", " + p.getY() + ", " + p.getZ() + " # " + p.getAlfa() + ", " + p.getBeta()
                + ", " + p.getGama() + ", " + p.getElevacao() + ", " + p.getRotacao() + " # " + p.radianPitch + " " + p.radianRoll);
    }

    public CenaX3D(String x3dWorld) {

        // Setup browser parameters
        HashMap requestedParameters = new HashMap();
        requestedParameters.put("Antialiased", Boolean.TRUE);
        requestedParameters.put("TextureQuality", "high");
        requestedParameters.put("PrimitiveQuality", "high");

        // Create an SAI component
        X3DComponent x3dComp = BrowserFactory.createX3DComponent(requestedParameters);

        this.jp = new JanelaPrincipal(this, (JComponent) x3dComp.getImplementation());

        // Get an external browser
        x3dBrowser = x3dComp.getBrowser();

        try {
            // Create an X3D scene by loading a file.  Blocks till the world is loaded.
            mainScene = x3dBrowser.createX3DFromURL(new String[]{x3dWorld});
            //scene = mainScene;

            // Replace the current world with the new one
            x3dBrowser.replaceWorld(mainScene);

            // Cria sensores
            carregaSensores(this);
        } catch (org.web3d.vrml.lang.UnsupportedNodeException ex) {
            System.out.println("Erro: " + ex.getMessage());
        } catch (NullPointerException np) {
            System.out.println("Erro: " + np.getMessage());
            np.printStackTrace();
        }
        this.carregaVetores();
        this.montaObbs();

        this.collisionManager = new CollisionManager();
        this.partManager = new PartManager(this);
        this.Pegar_soltar = new Pegar_Soltar(this);
    }

    /**
     *
     * @author Pacheco
     *
     * Método para gerar garras fantasmas e os pontos da trajetória
     * para a lista de todos os pontos ou os pontos de controle.
     *
     * Também efetua validação dos pontos calculando a cinemática inversa em cada um.
     */
    public void generateGhostGripper(boolean allPoints, boolean showGripper, boolean showPFP, boolean validate) {
        // todo
        // para cada item inserido na alllist e controlist, chamar o generateghostgripper
        // otimização futura: inserir os nós com nomes da lista, remover apenas os que não existem mais e inserir apenas os novos
        // renomear ponto, atualiza nome do noh na scena

        // Remove os nós para recriálos de acordo com o tipo da lista
        for (int i = 0; i < mainScene.getNamedNodes().length; i++) {
            if (mainScene.getNamedNodes()[i].contains("CP_ROBOGARRA_") == true) {
                X3DNode node = mainScene.getNamedNode(mainScene.getNamedNodes()[i]);
                mainScene.removeRootNode(node);
                mainScene.removeNamedNode(mainScene.getNamedNodes()[i]);
                --i;
            }
        }

        if (showGripper == false && showPFP == false) {
            return;
        }

        // Se nenhum ponto encontrado na lista, sai da função
        int length;
        if (allPoints == true) {
            length = jp.janelaPonto.lPontos.getItemCount();
        } else {
            length = jp.janelaPonto.lControlPoints.getItemCount();
        }
        if (length <= 0) {
            return;
        }

        for (int i = 0; i < length; i++) {
            Ponto p;
            if (allPoints == true) {
                p = (Ponto) jp.janelaPonto.lPontos.getObjeto(i);
            } else {
                p = (Ponto) jp.janelaPonto.lControlPoints.getObjeto(i);
            }

            String color = "1 1 0";

            if (validate == true) {
                float pitch = this.toRadianos(p.getElevacao() + p.getBeta() + p.getGama()) - (float) Math.PI;
                float roll = this.toRadianos(p.getRotacao());

                this.simulateIK = true;
                this.calcularInversa(-p.getX(), p.getZ(), p.getY(), pitch, roll, this.elbowOver);
                this.simulateIK = false;

                if (this.getPosicaoOK() == false) {
                    color = "1 0 0";
                } else {
                    color = "0.3 1 0";
                }
            }

            String xmlScene = "<X3D profile='Immersive' version='3.0' xmlns:xsd='http://www.w3.org/2001/XMLSchema-instance' xsd:noNamespaceSchemaLocation='http://www.web3d.org/specifications/x3d-3.2.xsd'> <Scene> <Group DEF='ROBOGARRA'> <Transform DEF='FIXACAO' translation='0.0 -0.48 0.0' scale='0.075 0.075 0.075' rotation='0 1 0 #ROT_ALFA_RADIAN#'> <Shape DEF='GEO_FIXACAO' > <Appearance > <Material DEF='COR_0' diffuseColor='0.3 0.3 0.3' transparency='1'/> </Appearance> <Extrusion crossSection='1.0 0.0, 0.92 -0.38, 0.71 -0.71, 0.38 -0.92, 0.0 -1.0, -0.38 -0.92, -0.71 -0.71, -0.92 -0.38, -1.0 -0.0, -0.92 0.38, -0.71 0.71, -0.38 0.92, 0.0 1.0, 0.38 0.92, 0.71 0.71, 0.92 0.38, 1.0 0.0, ' scale='3.2 3.2, 3.2 3.2, 2.5 2.5, 2.45 2.45, 2.4 2.4, 2.35 2.35, 2.3 2.3, 2.25 2.25, 2.2 2.2, 2.15 2.15, 2.1 2.1, ' solid='false' creaseAngle='1.0' spine='0.0 0.0 0.0, 0.0 0.3 0.0, 0.0 0.301 0.0, 0.0 1.4 0.0, 0.0 1.8 0.0, 0.0 2.2 0.0, 0.0 2.6 0.0, 0.0 3.0 0.0, 0.0 3.4 0.0, 0.0 3.8 0.0, 0.0 4.2 0.0, '/> </Shape> <Transform DEF='CONJ_BASE' > <Transform DEF='BASE' scale='3.0 3.0 3.0' translation='-2.25 4.4 2.325' > <Shape DEF='GEO_BASE' > <Appearance > <Material DEF='COR_1' diffuseColor='0.0 0.7 0.5' transparency='1'/> </Appearance> <IndexedFaceSet coordIndex=' 0 1 2 3 4 5 6 7 8 9 -1 10 19 18 17 16 15 14 13 12 11 -1 0 10 11 1 -1 1 11 12 2 -1 2 12 13 3 -1 3 13 14 4 -1 4 14 15 5 -1 5 15 16 6 -1 6 16 17 7 -1 7 17 18 8 -1 8 18 19 9 -1 9 19 20 0 -1 21 22 23 24 25 26 27 28 29 30 -1 31 40 39 38 37 36 35 34 33 32 -1 21 31 32 22 -1 22 32 33 23 -1 23 33 34 24 -1 24 34 35 25 -1 25 35 36 26 -1 26 36 37 27 -1 27 37 38 28 -1 28 38 39 29 -1 29 39 40 30 -1 30 40 41 21 -1 0 21 22 1 -1 42 43 45 44 -1 0 42 44 21 -1 1 22 45 43 -1 1 22 23 2 -1 46 48 49 47 -1 2 23 49 48 -1'> <Coordinate point='0.0 0.0 0.0, 1.5 0.0 0.0, 1.5 0.9 0.0, 1.46 0.97 0.0, 1.4 1.0 0.0, 0.5 1.0 0.0, 0.4 0.95 0.0, 0.35 0.9 0.0, 0.3 0.85 0.0, 0.0 0.3 0.0, 0.0 0.0 -0.05, 1.5 0.0 -0.05, 1.5 0.9 -0.05, 1.46 0.97 -0.05, 1.4 1.0 -0.05, 0.5 1.0 -0.05, 0.4 0.95 -0.05, 0.35 0.9 -0.05, 0.3 0.85 -0.05, 0.0 0.3 -0.05, 0.0 0.0 -0.05, 0.0 0.0 -1.5, 1.5 0.0 -1.5, 1.5 0.9 -1.5, 1.46 0.97 -1.5, 1.4 1.0 -1.5, 0.5 1.0 -1.5, 0.4 0.95 -1.5, 0.35 0.9 -1.5, 0.3 0.85 -1.5, 0.0 0.3 -1.5, 0.0 0.0 -1.55, 1.5 0.0 -1.55, 1.5 0.9 -1.55, 1.46 0.97 -1.55, 1.4 1.0 -1.55, 0.5 1.0 -1.55, 0.4 0.95 -1.55, 0.35 0.9 -1.55, 0.3 0.85 -1.55, 0.0 0.3 -1.55, 0.0 0.0 -1.55, 0.0 0.05 0.0, 1.5 0.05 0.0, 0.0 0.05 -1.5, 1.5 0.05 -1.5, 1.45 0.0 0.0, 1.45 0.0 -1.5, 1.45 0.9 0.0, 1.45 0.9 -1.5, '/> </IndexedFaceSet> </Shape> <Transform DEF='CILINDRO_BASE' translation='0.2 0.2 0.0'> <Transform DEF='GEO_CILINDRO' rotation='1 0 0 1.5708' translation='0 0 -0.775'> <Shape> <Appearance> <Material diffuseColor='0.0 0.7 0.5'/> </Appearance> </Shape> <Transform translation='0 -0.775 0'> <Shape DEF='GEO_CILINDRO_BORDA'> <Appearance> <Material diffuseColor='0.3 0.3 0.3' transparency='1'/> </Appearance> <Cylinder radius='0.14' height='0.05'/> </Shape> </Transform> <Transform translation='0 0.775 0'> <Shape USE='GEO_CILINDRO_BORDA'/> </Transform> </Transform> </Transform> <Transform DEF='CONJ_ANTEBRACO' translation='0.5 0.8 0.0'> <Transform DEF='ANTEBRACO' translation='0 -0.2 -0.1' rotation='0 0 1 #ROT_BETA_RADIAN#' center='0 0.2 0'> <Shape DEF='GEO_ANTEBRACO' > <Appearance > <Material DEF='COR_2' diffuseColor='0.0 0.7 0.5' transparency='1'/> </Appearance> <IndexedFaceSet coordIndex=' 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 -1 22 43 42 41 40 39 38 37 36 35 34 33 32 31 30 29 28 27 26 25 24 23 -1 0 22 23 1 -1 1 23 24 2 -1 2 24 25 3 -1 3 25 26 4 -1 4 26 27 5 -1 5 27 28 6 -1 6 28 29 7 -1 7 29 30 8 -1 8 30 31 9 -1 9 31 32 10 -1 10 32 33 11 -1 11 33 34 12 -1 12 34 35 13 -1 13 35 36 14 -1 14 36 37 15 -1 15 37 38 16 -1 16 38 39 17 -1 17 39 40 18 -1 18 40 41 19 -1 19 41 42 20 -1 20 42 43 21 -1 21 43 44 0 -1 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 -1 67 88 87 86 85 84 83 82 81 80 79 78 77 76 75 74 73 72 71 70 69 68 -1 45 67 68 46 -1 46 68 69 47 -1 47 69 70 48 -1 48 70 71 49 -1 49 71 72 50 -1 51 72 73 52 -1 52 73 74 53 -1 53 74 75 54 -1 54 75 76 55 -1 55 76 77 56 -1 56 77 78 57 -1 57 78 79 58 -1 58 79 80 59 -1 59 81 82 60 -1 60 82 83 61 -1 61 83 84 62 -1 62 84 85 63 -1 63 85 86 64 -1 64 86 87 65 -1 65 87 88 66 -1 66 88 89 45 -1 90 93 92 91 -1 94 95 96 97 -1 91 92 96 95 -1 90 94 97 93 -1'> <Coordinate point='-0.25 0.22 0.0, -0.2 0.13 0.0, -0.15 0.07 0.0, -0.1 0.03 0.0, -0.05 0.01 0.0, 0.0 0.0 0.0, 0.05 0.01 0.0, 0.1 0.03 0.0, 0.15 0.07 0.0, 0.2 0.13 0.0, 0.25 0.22 0.0, 0.25 1.68 0.0, 0.2 1.77 0.0, 0.15 1.83 0.0, 0.1 1.87 0.0, 0.05 1.89 0.0, 0.0 1.9 0.0, -0.05 1.89 0.0, -0.1 1.87 0.0, -0.15 1.83 0.0, -0.2 1.77 0.0, -0.25 1.68 0.0, -0.25 0.22 -0.05, -0.2 0.13 -0.05, -0.15 0.07 -0.05, -0.1 0.03 -0.05, -0.05 0.01 -0.05, 0.0 0.0 -0.05, 0.05 0.01 -0.05, 0.1 0.03 -0.05, 0.15 0.07 -0.05, 0.2 0.13 -0.05, 0.25 0.22 -0.05, 0.25 1.68 -0.05, 0.2 1.77 -0.05, 0.15 1.83 -0.05, 0.1 1.87 -0.05, 0.05 1.89 -0.05, 0.0 1.9 -0.05, -0.05 1.89 -0.05, -0.1 1.87 -0.05, -0.15 1.83 -0.05, -0.2 1.77 -0.05, -0.25 1.68 -0.05, -0.25 0.22 -0.05, -0.25 0.22 -1.3, -0.2 0.13 -1.3, -0.15 0.07 -1.3, -0.1 0.03 -1.3, -0.05 0.01 -1.3, 0.0 0.0 -1.3, 0.05 0.01 -1.3, 0.1 0.03 -1.3, 0.15 0.07 -1.3, 0.2 0.13 -1.3, 0.25 0.22 -1.3, 0.25 1.68 -1.3, 0.2 1.77 -1.3, 0.15 1.83 -1.3, 0.1 1.87 -1.3, 0.05 1.89 -1.3, 0.0 1.9 -1.3, -0.05 1.89 -1.3, -0.1 1.87 -1.3, -0.15 1.83 -1.3, -0.2 1.77 -1.3, -0.25 1.68 -1.3, -0.25 0.22 -1.35, -0.2 0.13 -1.35, -0.15 0.07 -1.35, -0.1 0.03 -1.35, -0.05 0.01 -1.35, 0.0 0.0 -1.35, 0.05 0.01 -1.35, 0.1 0.03 -1.35, 0.15 0.07 -1.35, 0.2 0.13 -1.35, 0.25 0.22 -1.35, 0.25 1.68 -1.35, 0.2 1.77 -1.35, 0.15 1.83 -1.35, 0.1 1.87 -1.35, 0.05 1.89 -1.35, 0.0 1.9 -1.35, -0.05 1.89 -1.35, -0.1 1.87 -1.35, -0.15 1.83 -1.35, -0.2 1.77 -1.35, -0.25 1.68 -1.35, -0.25 0.2 -1.35, 0.25 0.7 0.0, 0.25 1.4 0.0, 0.25 1.4 -1.35, 0.25 0.7 -1.35, 0.2 0.7 0.0, 0.2 1.4 0.0, 0.2 1.4 -1.35, 0.2 0.7 -1.35, '/> </IndexedFaceSet> </Shape> <Transform DEF='CONJ_BRACO' translation='0.0 1.65 0.0'> <Transform DEF='BRACO' translation='0.0 -0.16 -0.07' rotation='0 0 1 #ROT_GAMA_RADIAN#' center='0 0.16 0'> <Shape DEF='GEO_BRACO' > <Appearance > <Material DEF='COR_3' diffuseColor='0.0 0.7 0.5' transparency='1'/> </Appearance> <IndexedFaceSet coordIndex=' 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 -1 22 43 42 41 40 39 38 37 36 35 34 33 32 31 30 29 28 27 26 25 24 23 -1 0 22 23 1 -1 1 23 24 2 -1 2 24 25 3 -1 3 25 26 4 -1 4 26 27 5 -1 5 27 28 6 -1 6 28 29 7 -1 7 29 30 8 -1 8 30 31 9 -1 9 31 32 10 -1 10 32 33 11 -1 11 33 34 12 -1 12 34 35 13 -1 13 35 36 14 -1 14 36 37 15 -1 15 37 38 16 -1 16 38 39 17 -1 17 39 40 18 -1 18 40 41 19 -1 19 41 42 20 -1 20 42 43 21 -1 21 43 44 0 -1 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 -1 67 88 87 86 85 84 83 82 81 80 79 78 77 76 75 74 73 72 71 70 69 68 -1 45 67 68 46 -1 46 68 69 47 -1 47 69 70 48 -1 48 70 71 49 -1 49 71 72 50 -1 51 72 73 52 -1 52 73 74 53 -1 53 74 75 54 -1 54 75 76 55 -1 55 76 77 56 -1 56 77 78 57 -1 57 78 79 58 -1 58 79 80 59 -1 59 81 82 60 -1 60 82 83 61 -1 61 83 84 62 -1 62 84 85 63 -1 63 85 86 64 -1 64 86 87 65 -1 65 87 88 66 -1 66 88 89 45 -1 90 93 92 91 -1 94 95 96 97 -1 91 92 96 95 -1 90 94 97 93 -1'> <Coordinate point='-0.25 0.22 0.0, -0.2 0.13 0.0, -0.15 0.07 0.0, -0.1 0.03 0.0, -0.05 0.01 0.0, 0.0 0.0 0.0, 0.05 0.01 0.0, 0.1 0.03 0.0, 0.15 0.07 0.0, 0.2 0.13 0.0, 0.25 0.22 0.0, 0.25 1.68 0.0, 0.2 1.77 0.0, 0.15 1.83 0.0, 0.1 1.87 0.0, 0.05 1.89 0.0, 0.0 1.9 0.0, -0.05 1.89 0.0, -0.1 1.87 0.0, -0.15 1.83 0.0, -0.2 1.77 0.0, -0.25 1.68 0.0, -0.25 0.22 -0.05, -0.2 0.13 -0.05, -0.15 0.07 -0.05, -0.1 0.03 -0.05, -0.05 0.01 -0.05, 0.0 0.0 -0.05, 0.05 0.01 -0.05, 0.1 0.03 -0.05, 0.15 0.07 -0.05, 0.2 0.13 -0.05, 0.25 0.22 -0.05, 0.25 1.68 -0.05, 0.2 1.77 -0.05, 0.15 1.83 -0.05, 0.1 1.87 -0.05, 0.05 1.89 -0.05, 0.0 1.9 -0.05, -0.05 1.89 -0.05, -0.1 1.87 -0.05, -0.15 1.83 -0.05, -0.2 1.77 -0.05, -0.25 1.68 -0.05, -0.25 0.22 -0.05, -0.25 0.22 -1.15, -0.2 0.13 -1.15, -0.15 0.07 -1.15, -0.1 0.03 -1.15, -0.05 0.01 -1.15, 0.0 0.0 -1.15, 0.05 0.01 -1.15, 0.1 0.03 -1.15, 0.15 0.07 -1.15, 0.2 0.13 -1.15, 0.25 0.22 -1.15, 0.25 1.68 -1.15, 0.2 1.77 -1.15, 0.15 1.83 -1.15, 0.1 1.87 -1.15, 0.05 1.89 -1.15, 0.0 1.9 -1.15, -0.05 1.89 -1.15, -0.1 1.87 -1.15, -0.15 1.83 -1.15, -0.2 1.77 -1.15, -0.25 1.68 -1.15, -0.25 0.22 -1.2, -0.2 0.13 -1.2, -0.15 0.07 -1.2, -0.1 0.03 -1.2, -0.05 0.01 -1.2, 0.0 0.0 -1.2, 0.05 0.01 -1.2, 0.1 0.03 -1.2, 0.15 0.07 -1.2, 0.2 0.13 -1.2, 0.25 0.22 -1.2, 0.25 1.68 -1.2, 0.2 1.77 -1.2, 0.15 1.83 -1.2, 0.1 1.87 -1.2, 0.05 1.89 -1.2, 0.0 1.9 -1.2, -0.05 1.89 -1.2, -0.1 1.87 -1.2, -0.15 1.83 -1.2, -0.2 1.77 -1.2, -0.25 1.68 -1.2, -0.25 0.2 -1.2, 0.25 0.4 0.0, 0.25 0.9 0.0, 0.25 0.9 -1.2, 0.25 0.4 -1.2, 0.2 0.4 0.0, 0.2 0.9 0.0, 0.2 0.9 -1.2, 0.2 0.4 -1.2, '/> </IndexedFaceSet> </Shape> <Transform DEF='CONJ_PUNHO' translation='0.0 1.65 0.0'> <Transform DEF='PUNHO' rotation='0 0 1 #ROT_ELEVACAO_RADIAN#'> <Transform DEF='PUNHO2' rotation='0 1 0 #ROT_ROTATION_RADIAN#' center='0.0 0 -0.6'> <Transform DEF='GEO_CILINDRO_3' rotation='1 0 0 1.5708' translation='0 0 -0.6'> <Shape> <Appearance DEF='COR_Garra' > <Material DEF='COR_4' diffuseColor='0.3 0.3 0.3' transparency='#TRANS_GRIPPER#'/> </Appearance> </Shape> </Transform> <Transform DEF='CONJ_GARRA' scale='1 0.85 1' translation='0.0 -0.2 0.0' center='0.0 0.0 -0.6'> <Transform DEF='GARRA' > <Shape DEF='GEO_EIXO_GARRA' > <Appearance USE='COR_Garra'/> <Extrusion crossSection='1.0 0.0, 0.92 -0.38, 0.71 -0.71, 0.38 -0.92, 0.0 -1.0, -0.38 -0.92, -0.71 -0.71, -0.92 -0.38, -1.0 -0.0, -0.92 0.38, -0.71 0.71, -0.38 0.92, 0.0 1.0, 0.38 0.92, 0.71 0.71, 0.92 0.38, 1.0 0.0, ' scale='0.1 0.1, 0.1 0.1, 0.07 0.07, 0.07 0.07, 0.11 0.11, 0.11 0.11, 0.12 0.12, 0.12 0.12, 0.18 0.18, 0.18 0.18, 0.15 0.15, 0.15 0.15, 0.12 0.12, 0.12 0.12, 0.14 0.14, 0.14 0.14, 0.12 0.12, 0.12 0.12, 0.14 0.14, 0.14 0.14, 0.12 0.12, 0.12 0.12, 0.15 0.15, 0.15 0.15, ' solid='false' creaseAngle='1.87' spine='0.0 -0.5 -0.6, 0.0 -0.12 -0.6, 0.0 -0.12 -0.6, 0.0 -0.08 -0.6, 0.0 -0.08 -0.6, 0.0 0.1 -0.6, 0.0 0.1 -0.6, 0.0 0.3 -0.6, 0.0 0.3 -0.6, 0.0 0.33 -0.6, 0.0 0.33 -0.6, 0.0 0.6 -0.6, 0.0 0.6 -0.6, 0.0 0.65 -0.6, 0.0 0.65 -0.6, 0.0 0.7 -0.6, 0.0 0.7 -0.6, 0.0 0.8 -0.6, 0.0 0.8 -0.6, 0.0 0.85 -0.6, 0.0 0.85 -0.6, 0.0 0.9 -0.6, 0.0 0.9 -0.6, 0.0 1.0 -0.6, '/> </Shape> <Transform DEF='PONTA' translation='0.0 -0.45 -0.6'> <Shape DEF='GEO_SUPORTE_DEDOS' > <Appearance USE='COR_Garra'/> <Box size='0.16 0.16 0.8'/> </Shape> <Transform DEF='DEDO_1' translation='0.0 -0.2 0.075'> <Shape DEF='DEDO' > <Appearance USE='COR_Garra'/> <Box size='0.16 0.6 0.16'/> </Shape> </Transform> <Transform DEF='DEDO_2' translation='0.0 -0.2 -0.075'> <Shape USE='DEDO'/> </Transform> <Transform DEF='TPFP' translation='0.0 -0.5 0.0'> <Shape DEF='PFP'> <Appearance> <Material DEF='mpfp' diffuseColor='#COLOR_PFP#' transparency='#TRANS_PFP#'/> </Appearance> <Sphere radius='0.1'/> </Shape> </Transform> </Transform> </Transform> </Transform> </Transform> </Transform> </Transform> </Transform> </Transform> </Transform> </Transform> </Transform> </Transform> </Transform> </Group> </Scene> </X3D>";
            xmlScene = xmlScene.replace("#ROT_ALFA_RADIAN#", Float.toString(toRadianos(p.getAlfa())));
            xmlScene = xmlScene.replace("#ROT_BETA_RADIAN#", Float.toString(toRadianos(p.getBeta())));
            xmlScene = xmlScene.replace("#ROT_GAMA_RADIAN#", Float.toString(toRadianos(p.getGama())));
            xmlScene = xmlScene.replace("#ROT_ELEVACAO_RADIAN#", Float.toString(toRadianos(p.getElevacao()) + (float) 3.1415927));
            xmlScene = xmlScene.replace("#ROT_ROTATION_RADIAN#", Float.toString(toRadianos(p.getRotacao())));
            xmlScene = xmlScene.replace("#TRANS_PFP#", showPFP == true ? "0.5" : "1");
            xmlScene = xmlScene.replace("#TRANS_GRIPPER#", showGripper == true ? "0.5" : "1");
            xmlScene = xmlScene.replace("#COLOR_PFP#", color);

            X3DScene auxScene = this.getX3DBrowser().createX3DFromString(xmlScene);
            X3DNode mynode = auxScene.getNamedNode("ROBOGARRA");
            mainScene.addRootNode(mynode);
            mainScene.updateNamedNode("CP_ROBOGARRA_" + i, mynode);
        }
    }

    /**
     *
     * @author Pacheco
     *
     * Método para calcular a interpolação de 4 pontos de controle utilizando
     * a curva catmull-rom.
     */
    private Ponto catmullRomSpline(Vector<Ponto> pontos, float u, float t, int index) {
        float M[][] = {{0, 1, 0, 0}, {-t, 0, t, 0}, {2 * t, t - 3, 3 - (2 * t), -t}, {-t, 2 - t, t - 2, t}};

        Vector<Eixo> MG = new Vector<Eixo>();
        for (int i = 0; i < 4; i++) {
            MG.add(new Eixo(0f, 0f, 0f));
        }

        float T[] = {1, u, u * u, u * u * u};

        Ponto p = pontos.elementAt(index);

        for (int i = 0; i < 4; i++) {
            int c = index - 2;
            for (int j = 0; j < 4; j++) {
                MG.elementAt(i).x += (M[i][j] * pontos.elementAt(c).getX());
                MG.elementAt(i).y += (M[i][j] * pontos.elementAt(c).getY());
                MG.elementAt(i).z += (M[i][j] * pontos.elementAt(c).getZ());

                MG.elementAt(i).e += (M[i][j] * pontos.elementAt(c).radianPitch);
                MG.elementAt(i).r += (M[i][j] * pontos.elementAt(c).radianRoll);
                ++c;
            }
        }

        Eixo eixo = new Eixo(0f, 0f, 0f);

        for (int i = 0; i < 4; i++) {
            eixo.x += T[i] * MG.elementAt(i).x;
            eixo.y += T[i] * MG.elementAt(i).y;
            eixo.z += T[i] * MG.elementAt(i).z;

            eixo.e += T[i] * MG.elementAt(i).e;
            eixo.r += T[i] * MG.elementAt(i).r;
        }

        Angulos angs = new Angulos(p.getAlfa(), p.getBeta(), p.getGama(), p.getElevacao(), p.getRotacao());

        Ponto _p = new Ponto("p", eixo.x, eixo.y, eixo.z, angs.getAlfa(), angs.getBeta(), angs.getGama(), angs.getElevacao(), angs.getRotacao());
        _p.radianPitch = eixo.e; // abordagem parametrizada
        _p.radianRoll = eixo.r;

        //Ponto _p = new Ponto("p", eixo.x, eixo.y, eixo.z, angs.getAlfa(), angs.getBeta(), angs.getGama(), angs.getElevacao(), angs.getRotacao());
        //_p.radian = p.radian; // abordagem original

        return _p;
    }

    /**
     *
     * @author Pacheco
     *
     * Método que gera um vetor de pontos suaves a partir de uma lista de pontos de controle.
     * Efetua também a normalização dos pontos para utilizar como coordenadas X3D.
     */
    public Vector<Ponto> getSmoothInterpolation(boolean normalize, Vector<Ponto> controlPoints) {
        // Vetor de pontos normalizados
        Vector<Ponto> pontos = new Vector<Ponto>();

        //int length = jp.janelaPonto.lControlPoints.getItemCount();
        int length = controlPoints.size();
        if (length < 4) {
            JOptionPane.showMessageDialog(null, "São necessários quatro pontos de controle no mínimo.", "Erro", JOptionPane.ERROR_MESSAGE);
            return null;
        }

        // Normalização de pontos
        for (int i = 0; i < length; i++) {
            //float offset = 0.567f;
            float offset = 0.545f;
            //Ponto p = (Ponto)jp.janelaPonto.lControlPoints.getObjeto(i);
            Ponto p = controlPoints.elementAt(i);

            float x = p.getX();
            float y = p.getY();
            float z = p.getZ();

            if (normalize == true) {
                x /= 1000;
                y /= 1000;
                z /= 1000;

                float distX = Math.abs(x) - 0.020f;
                float distY = Math.abs(y) - 0.925f;
                float distZ = Math.abs(z);

                if (x < 0) {
                    x -= offset * distX;
                } else {
                    x += offset * distX;
                }

                if (y < 0) {
                    y -= offset * distY;
                } else {
                    y += offset * distY;
                }

                if (z < 0) {
                    z -= offset * distZ;
                } else {
                    z += offset * distZ;
                }
            }

            Ponto _p = new Ponto("p", new Eixo(x, y, z), p.getAngulos());
            _p.radianPitch = toRadianos(p.getElevacao() + p.getBeta() + p.getGama()) - (float) Math.PI;
            _p.radianRoll = toRadianos(p.getRotacao());
            pontos.add(_p);
            // Duplicação do ponto para interpolar o ponto inicial e final
            if (i == 0 || i == length - 1) {
                pontos.add(_p);
            }
        }

        // Suavização dos pontos utilizando uma catmull-rom spline
        Vector<Ponto> smoothPoints = new Vector<Ponto>();
        float tg = 1f / this.granularity;

        int sleep = (int) (500 / this.granularity);
        if (sleep < 1) {
            sleep = 1;
        }

        for (int i = 2; i < pontos.size() - 1; i++) {
            float t = 0.0f;

            // Linear Interpolation
            float beginRadianPitch = pontos.elementAt(i - 1).radianPitch;
            float endRadianPitch = pontos.elementAt(i).radianPitch;
            float currentRadianPitch = beginRadianPitch;
            float linearStep = (endRadianPitch - beginRadianPitch) / this.granularity;

            while (t <= 1.0f) {
                Ponto p = catmullRomSpline(pontos, t, 0.5f, i);

                //this.simulateIK = true;
                //this.calcularInversa(-p.getX(), p.getZ(), p.getY(), p.radianPitch, p.radianRoll, this.elbowOver);
                //this.simulateIK = false;

                // Linear Interpolation
                //p.radianPitch = currentRadianPitch;

                smoothPoints.add(p);
                t += tg;

                // Linear Interpolation
                //currentRadianPitch += linearStep;

                /*try
                {
                Thread.sleep(sleep);
                }
                catch (InterruptedException e)
                {
                }*/
            }
        }

        smoothPoints.add(pontos.lastElement());

        //if (normalize == false) removeNearDuplicatedPoints(smoothPoints);

        return smoothPoints;
    }

    /**
     *
     * @author Pacheco
     *
     * Método que remove pontos muito próximo ou sobrepostos após a suavização.
     */
    private void removeNearDuplicatedPoints(Vector<Ponto> points) {
        for (int i = 0; i < points.size() - 1; i++) {
            Ponto actual = points.elementAt(i);
            Ponto next = points.elementAt(i + 1);

            //System.out.println(actual.getX() + " DIF: " + (Math.abs(actual.getX()) -  Math.abs(next.getX())));
            if (Math.abs(actual.getX() - next.getX()) <= 0.01) {
                points.remove(i);
                --i;
            }
        }
    }

    /**
     *
     * @author Pacheco
     *
     * Método que remove o nó responsável pela visualização da trajetória suave.
     */
    public void clearTrajectory() {
        try {
            X3DNode node = mainScene.getNamedNode("CURVE");
            mainScene.removeRootNode(node);
            mainScene.removeNamedNode("CURVE");
        } catch (InvalidNodeException ex) {
        }
    }

    /**
     *
     * @author Pacheco
     *
     * Método que gera uma trajetória suave na interface.
     */
    public void generateTrajectory() {
        clearTrajectory();

        Vector<Ponto> controlPoints = new Vector<Ponto>();
        for (int i = 0; i < jp.janelaPonto.lControlPoints.getItemCount(); i++) {
            controlPoints.add((Ponto) jp.janelaPonto.lControlPoints.getObjeto(i));
        }

        int auxGranularity = this.granularity;
        if (this.granularity > 20) {
            this.granularity = 20;
        }
        Vector<Ponto> pontos = getSmoothInterpolation(true, controlPoints);
        this.granularity = auxGranularity;

        if (pontos == null) {
            return;
        }

        String xml = "<Transform DEF='CURVE'><Shape><Appearance  DEF='WHITE' ><Material emissiveColor='1.0 1.0 0.5'/><LineProperties applied='true' linetype='1' linewidthScaleFactor='1.5' containerField='lineProperties' /></Appearance><IndexedLineSet  coordIndex='";
        for (int i = 0; i < pontos.size(); i++) {
            xml += (Integer.toString(i) + " ");
        }
        xml += "-1'><Coordinate  point='";

        for (int i = 0; i < pontos.size(); i++) {
            xml += pontos.elementAt(i).getX() + " " + pontos.elementAt(i).getY() + " " + pontos.elementAt(i).getZ() + ", ";
        }
        xml += "'/></IndexedLineSet></Shape></Transform>";

        String xmlScene = "<X3D profile='Immersive' version='3.0' xmlns:xsd='http://www.w3.org/2001/XMLSchema-instance' xsd:noNamespaceSchemaLocation='http://www.web3d.org/specifications/x3d-3.2.xsd'> <Scene>" + xml + "</Scene> </X3D>";
        X3DScene auxScene = this.getX3DBrowser().createX3DFromString(xmlScene);
        X3DNode mynode = auxScene.getNamedNode("CURVE");
        mainScene.addRootNode(mynode);
        mainScene.updateNamedNode("CURVE", mynode);
    }

    private Vector<Ponto> normalizePoints(Vector<Ponto> pontos) {
        float offset = 0.545f;
        Vector<Ponto> normalPoints = new Vector<Ponto>();

        for (int i = 0; i < pontos.size(); i++) {
            Ponto p = pontos.elementAt(i);

            float x = p.getX();
            float y = p.getY();
            float z = p.getZ();

            x /= 1000;
            y /= 1000;
            z /= 1000;

            float distX = Math.abs(x) - 0.020f;
            float distY = Math.abs(y) - 0.925f;
            float distZ = Math.abs(z);

            if (x < 0) {
                x -= offset * distX;
            } else {
                x += offset * distX;
            }

            if (y < 0) {
                y -= offset * distY;
            } else {
                y += offset * distY;
            }

            if (z < 0) {
                z -= offset * distZ;
            } else {
                z += offset * distZ;
            }

            Ponto _p = new Ponto("p", new Eixo(x, y, z), p.getAngulos());
            normalPoints.add(_p);
        }

        return normalPoints;
    }

    public void generateCustomTrajectory(Vector<Ponto> points) {
        if (points == null) {
            return;
        }
        if (points.size() < 2) {
            return;
        }

        Vector<Ponto> pontos = normalizePoints(points);

        String xml = "<Transform DEF='CURVE'><Shape><Appearance  DEF='WHITE' ><Material emissiveColor='1.0 1.0 0.5'/><LineProperties applied='true' linetype='1' linewidthScaleFactor='1.5' containerField='lineProperties' /></Appearance><IndexedLineSet  coordIndex='";
        for (int i = 0; i < pontos.size(); i++) {
            xml += (Integer.toString(i) + " ");
        }
        xml += "-1'><Coordinate  point='";

        for (int i = 0; i < pontos.size(); i++) {
            xml += pontos.elementAt(i).getX() + " " + pontos.elementAt(i).getY() + " " + pontos.elementAt(i).getZ() + ", ";
        }
        xml += "'/></IndexedLineSet></Shape></Transform>";

        String xmlScene = "<X3D profile='Immersive' version='3.0' xmlns:xsd='http://www.w3.org/2001/XMLSchema-instance' xsd:noNamespaceSchemaLocation='http://www.web3d.org/specifications/x3d-3.2.xsd'> <Scene>" + xml + "</Scene> </X3D>";
        X3DScene auxScene = this.getX3DBrowser().createX3DFromString(xmlScene);
        X3DNode mynode = auxScene.getNamedNode("CURVE");
        mainScene.addRootNode(mynode);
        mainScene.updateNamedNode("CURVE", mynode);
    }

    public String atualizaObbsRobo() {
        float[] vBaXValues = new float[3];
        float[] vBaYValues = new float[3];
        float[] vBaZValues = new float[3];
        float[] vBaPtCValues = new float[3];
        float[] vABXValues = new float[3];
        float[] vABYValues = new float[3];
        float[] vABZValues = new float[3];
        float[] vABPtCValues = new float[3];
        float[] vBXValues = new float[3];
        float[] vBYValues = new float[3];
        float[] vBZValues = new float[3];
        float[] vBPtCValues = new float[3];
        float[] vGXValues = new float[3];
        float[] vGYValues = new float[3];
        float[] vGZValues = new float[3];
        float[] vGPtCValues = new float[3];
        float[] vGPtD1Values = new float[3];
        float[] vGPtD2Values = new float[3];
        float[] vGPtSupValues = new float[3];
        float[] vGPtEixoValues = new float[3];

        this.vBaX.getValue(vBaXValues);
        this.vBaY.getValue(vBaYValues);
        this.vBaZ.getValue(vBaZValues);
        this.vBaPtC.getValue(vBaPtCValues);
        this.vABX.getValue(vABXValues);
        this.vABY.getValue(vABYValues);
        this.vABZ.getValue(vABZValues);
        this.vABPtC.getValue(vABPtCValues);
        this.vBX.getValue(vBXValues);
        this.vBY.getValue(vBYValues);
        this.vBZ.getValue(vBZValues);
        this.vBPtC.getValue(vBPtCValues);
        this.vGX.getValue(vGXValues);
        this.vGY.getValue(vGYValues);
        this.vGZ.getValue(vGZValues);
        this.vGPtC.getValue(vGPtCValues);
        this.vGPtD1.getValue(vGPtD1Values);
        this.vGPtD2.getValue(vGPtD2Values);
        this.vGPtSup.getValue(vGPtSupValues);
        this.vGPtEixo.getValue(vGPtEixoValues);

        obbCorpo.setEixoX(vBaXValues[0], vBaXValues[1], vBaXValues[2]);
        obbCorpo.setEixoY(vBaYValues[0], vBaYValues[1], vBaYValues[2]);
        obbCorpo.setEixoZ(vBaZValues[0], vBaZValues[1], vBaZValues[2]);
        obbCorpo.setCentro(0, 280, 0);
//System.out.println("Corpo x: "+vBaPtCValues[0]+" y: "+vBaPtCValues[1]+" z: "+vBaPtCValues[2]);
        obbBraco.setEixoX(vABXValues[0], vABXValues[1], vABXValues[2]);
        obbBraco.setEixoY(vABYValues[0], vABYValues[1], vABYValues[2]);
        obbBraco.setEixoZ(vABZValues[0], vABZValues[1], vABZValues[2]);
        obbBraco.setCentro((vABPtCValues[0] - 40), (vABPtCValues[1] + 100), (vABPtCValues[2]));
        System.out.println("\nBraço x: " + (vABPtCValues[0] * 1.2) + " y: " + (vABPtCValues[1] * 1.05) + " z: " + vABPtCValues[2]);
        obbAntBraco.setEixoX(vBXValues[0], vBXValues[1], vBXValues[2]);
        obbAntBraco.setEixoY(vBYValues[0], vBYValues[1], vBYValues[2]);
        obbAntBraco.setEixoZ(vBZValues[0], vBZValues[1], vBZValues[2]);
        obbAntBraco.setCentro((vBPtCValues[0] * 1.2), (vBPtCValues[1] * 1.05), (vBPtCValues[2]));
        System.out.println("AnteBraço x: " + (vBPtCValues[0] - 40) + " y: " + (vBPtCValues[1] + 100) + " z: " + vBPtCValues[2]);
        obbGarra.setEixoX(vGXValues[0], vGXValues[1], vGXValues[2]);
        obbGarra.setEixoY(vGYValues[0], vGYValues[1], vGYValues[2]);
        obbGarra.setEixoZ(vGZValues[0], vGZValues[1], vGZValues[2]);

        obbDedo1.setEixoX(vGXValues[0], vGXValues[1], vGXValues[2]);
        obbDedo1.setEixoY(vGYValues[0], vGYValues[1], vGYValues[2]);
        obbDedo1.setEixoZ(vGZValues[0], vGZValues[1], vGZValues[2]);

        obbDedo2.setEixoX(vGXValues[0], vGXValues[1], vGXValues[2]);
        obbDedo2.setEixoY(vGYValues[0], vGYValues[1], vGYValues[2]);
        obbDedo2.setEixoZ(vGZValues[0], vGZValues[1], vGZValues[2]);

        obbSup.setEixoX(vGXValues[0], vGXValues[1], vGXValues[2]);
        obbSup.setEixoY(vGYValues[0], vGYValues[1], vGYValues[2]);
        obbSup.setEixoZ(vGZValues[0], vGZValues[1], vGZValues[2]);

        obbEixo.setEixoX(vGXValues[0], vGXValues[1], vGXValues[2]);
        obbEixo.setEixoY(vGYValues[0], vGYValues[1], vGYValues[2]);
        obbEixo.setEixoZ(vGZValues[0], vGZValues[1], vGZValues[2]);

        obbGarra.setCentro((vGPtCValues[0]), (vGPtCValues[1]), (vGPtCValues[2]));
        // System.out.println("Garra x: "+vGPtCValues[0]+" y: "+vGPtCValues[1]+" z: "+vGPtCValues[2]);
        obbDedo1.setCentro((vGPtD1Values[0]), (vGPtD1Values[1]), (vGPtD1Values[2]));
        // System.out.println("Dedo1 x: "+vGPtD1Values[0]+" y: "+vGPtD1Values[1]+" z: "+vGPtD1Values[2]);
        obbDedo2.setCentro((vGPtD2Values[0]), (vGPtD2Values[1]), (vGPtD2Values[2]));
        // System.out.println("Dedo2 x: "+vGPtD2Values[0]+" y: "+vGPtD2Values[1]+" z: "+vGPtD2Values[2]);
        obbSup.setCentro((vGPtSupValues[0]), (vGPtSupValues[1]), (vGPtSupValues[2]));
        // System.out.println("Superf x: "+vGPtSupValues[0]+" y: "+vGPtSupValues[1]+" z: "+vGPtSupValues[2]);
        obbEixo.setCentro((vGPtEixoValues[0]), (vGPtEixoValues[1]), (vGPtEixoValues[2]));
        // System.out.println("Eixo x: "+vGPtEixoValues[0]+" y: "+vGPtEixoValues[1]+" z: "+vGPtEixoValues[2]);

        if (this.prim == 0) {
            this.abrirFecharGarra(5);
            this.prim++;
        }
        boolean escolha;
        if (jp.getJanelaParam() == null) {
            escolha = true;
        } else {
            escolha = jp.getJanelaParam().cbMostrarColisao.isSelected();
        }
        if (!escolha) {
            partManager.retiraColisao();
            this.retiraColisao();
        }
        Pegar_soltar.TestaPreensao(1);
        if (escolha) {
            if (!Pegar_soltar.mensagem.equals("Nao houve Colisao")) {
                contacolisao++;
            }
        }
        if (pego == true) {
            partManager.getObbTreeObjPego().getRoot().setCentro(getPontoX(), getPontoY(), getPontoZ());
            partManager.getObbTreeObjPego().getRoot().setAnguloX(this.getBeta() + this.getGama() + this.getElevacao());
            partManager.getObbTreeObjPego().getRoot().setAnguloY(this.getAlfa() + this.getRotacao());
        }
        return " ";
    }

    private void montaObbs() {

        obbBase.setXExtensao(200);
        obbBase.setYExtensao(200);
        obbBase.setZExtensao(200);
        obbBase.setEixoX(1, 0, 0);
        obbBase.setEixoY(0, 1, 0);
        obbBase.setEixoZ(0, 0, 1);
        obbBase.setCentro(0, 100, 0);
        this.treeBase.setRoot(obbBase);

        obbCorpo.setXExtensao(200);
        obbCorpo.setYExtensao(135);
        obbCorpo.setZExtensao(200);
        this.treeCorpo.setRoot(obbCorpo);

        obbAntBraco.setXExtensao(40);
        obbAntBraco.setYExtensao(220);
        obbAntBraco.setZExtensao(190);
        this.treeAntBraco.setRoot(obbAntBraco);

        obbBraco.setXExtensao(40);
        obbBraco.setYExtensao(220);
        obbBraco.setZExtensao(190);
        this.treeBraco.setRoot(obbBraco);

        obbGarra.setXExtensao(60);
        obbGarra.setZExtensao(120);
        obbGarra.setYExtensao(400);
        this.treeGarra.setRoot(obbGarra);

        obbDedo1.setXExtensao(20);
        obbDedo1.setZExtensao(20);
        obbDedo1.setYExtensao(100);
        this.treeDedo1.setRoot(obbDedo1);

        obbDedo2.setXExtensao(20);
        obbDedo2.setZExtensao(20);
        obbDedo2.setYExtensao(100);
        this.treeDedo2.setRoot(obbDedo2);

        obbSup.setXExtensao(20);
        obbSup.setZExtensao(120);
        obbSup.setYExtensao(20);
        this.treeSup.setRoot(obbSup);

        obbEixo.setXExtensao(40);
        obbEixo.setZExtensao(40);
        obbEixo.setYExtensao(180);
        this.treeEixo.setRoot(obbEixo);

        this.childrenGarra[0] = this.treeDedo1;
        this.childrenGarra[1] = this.treeDedo2;
        this.childrenGarra[3] = this.treeSup;
        this.childrenGarra[2] = this.treeEixo;

        this.treeGarra.setChildren(this.childrenGarra);
        this.treeGarra.setNumChildren(4);
    }

    public JanelaPrincipal getJanelaPrincipal() {
        return this.jp;
    }

    public ExternalBrowser getX3DBrowser() {
        return x3dBrowser;
    }

    public X3DScene getMainScene() {
        return mainScene;
    }

    public PartManager getPartManager() {
        return this.partManager;
    }

    public void replaceWorld() {
        x3dBrowser.replaceWorld(mainScene);
    }

    public void setTxtFeedback(String feedback) {
        jp.setTxtFeedback(feedback);
    }

    public void carregaSensores(X3DFieldEventListener x3dListener) {
        try {
            root = mainScene.getNamedNode("ROBO");
            this.alfa = (SFFloat) root.getField("alfa");
            this.beta = (SFFloat) root.getField("beta");
            this.gama = (SFFloat) root.getField("gama");
            this.elevacao = (SFFloat) root.getField("elevacao");
            this.rotacao = (SFFloat) root.getField("rotacao");
            this.abertura = (SFBool) root.getField("abertura");

            this.ponto = (SFVec3f) root.getField("ponto");
            //this.pfp = (SFVec3f) root.getField("pfp");
            this.alfa.addX3DEventListener(this);
            this.beta.addX3DEventListener(this);
            this.gama.addX3DEventListener(this);
            this.elevacao.addX3DEventListener(this);
            this.rotacao.addX3DEventListener(this);
            this.abertura.addX3DEventListener(this);
            this.ponto.addX3DEventListener(this);

            this.inBase = (SFRotation) root.getField("inBaseJava");
            this.inAntebraco = (SFRotation) root.getField("inAntebracoJava");
            this.inBraco = (SFRotation) root.getField("inBracoJava");
            this.inRotacao = (SFRotation) root.getField("inRotacaoJava");
            this.inElevacao = (SFRotation) root.getField("inElevacaoJava");
            this.inAbertura = ((SFFloat) root.getField("inAberturaJava"));
            this.inPosicaoInicial = (SFBool) root.getField("inPosicaoInicial");
            this.inEixosVisivel = (SFBool) root.getField("inEixosVisivel");
            this.insensoresAtivos = (SFBool) root.getField("insensoresAtivos");
            this.inPFPVisivel = (SFBool) root.getField("inPFPVisivel2");
            this.inAlfa = (SFRotation) root.getField("inAlfa");
            this.inBeta = (SFRotation) root.getField("inBeta");
            this.inGama = (SFRotation) root.getField("inGama");
            this.inElev = (SFRotation) root.getField("inElevacao");
            this.inRota = (SFRotation) root.getField("inRotacao");
            this.inExecutar = (SFTime) root.getField("inExecutar");
            this.inAddChildrenGarra = (MFNode) root.getField("inAddChildrenGarra");
            this.inRemoveChildrenGarra = (MFNode) root.getField("inRemoveChildrenGarra");
        } catch (InvalidNodeException nex) {
            if (jp.getIdioma().equals("Ingles")) {
                jp.setTxtFeedback("Failed to load sensors!");
            }
            if (jp.getIdioma().equals("Portugues")) {
                jp.setTxtFeedback("Falha no carregamento dos sensores!");
            }
        } catch (InvalidFieldException fex) {
            jp.setTxtFeedback(fex.getLocalizedMessage());
        }
        if (jp.getIdioma().equals("Ingles")) {
            jp.setTxtFeedback("Robot Initialized Successfully!");
        }
        if (jp.getIdioma().equals("Portugues")) {
            jp.setTxtFeedback("Robô Inicializado com Sucesso!");
        }
    }

    public void carregaVetores() {
        try {
            Thread.sleep(4000);
        } catch (InterruptedException ex) {
            Logger.getLogger(CenaX3D.class.getName()).log(Level.SEVERE, null, ex);
        }
        try {
            this.vBaX = (SFVec3f) root.getField("vBaX");
            this.vBaX.addX3DEventListener(this);

            this.vBaY = (SFVec3f) root.getField("vBaY");
            this.vBaY.addX3DEventListener(this);

            this.vBaZ = (SFVec3f) root.getField("vBaZ");
            this.vBaZ.addX3DEventListener(this);

            this.vBaPtC = (SFVec3f) root.getField("vBaPtC");
            this.vBaPtC.addX3DEventListener(this);

            this.vABX = (SFVec3f) root.getField("vABX");
            this.vABX.addX3DEventListener(this);

            this.vABY = (SFVec3f) root.getField("vABY");
            this.vABY.addX3DEventListener(this);

            this.vABZ = (SFVec3f) root.getField("vABZ");
            this.vABZ.addX3DEventListener(this);

            this.vABPtC = (SFVec3f) root.getField("vABPtC");
            this.vABPtC.addX3DEventListener(this);

            this.vBX = (SFVec3f) root.getField("vBX");
            this.vBX.addX3DEventListener(this);

            this.vBY = (SFVec3f) root.getField("vBY");
            this.vBY.addX3DEventListener(this);

            this.vBZ = (SFVec3f) root.getField("vBZ");
            this.vBZ.addX3DEventListener(this);

            this.vBPtC = (SFVec3f) root.getField("vBPtC");
            this.vBPtC.addX3DEventListener(this);

            this.vGX = (SFVec3f) root.getField("vGX");
            this.vGX.addX3DEventListener(this);

            this.vGY = (SFVec3f) root.getField("vGY");
            this.vGY.addX3DEventListener(this);

            this.vGZ = (SFVec3f) root.getField("vGZ");
            this.vGZ.addX3DEventListener(this);

            this.vGPtC = (SFVec3f) root.getField("vGPtC");
            this.vGPtC.addX3DEventListener(this);

            this.vGPtD1 = (SFVec3f) root.getField("vGPtD1");
            this.vGPtD1.addX3DEventListener(this);

            this.vGPtD2 = (SFVec3f) root.getField("vGPtD2");
            this.vGPtD2.addX3DEventListener(this);

            this.vGPtSup = (SFVec3f) root.getField("vGPtSup");
            this.vGPtSup.addX3DEventListener(this);

            this.vGPtEixo = (SFVec3f) root.getField("vGPtEixo");
            this.vGPtEixo.addX3DEventListener(this);
        } catch (InvalidNodeException nex) {
            System.out.println("Falha no carregamento dos sensores!");
        } catch (InvalidFieldException fex) {
            System.out.println(fex.getLocalizedMessage());
        }
    }

    public void setEixosVisivel(boolean visivel) {
        this.inEixosVisivel.setValue(visivel);
    }

    public void setSensoresAtivos(boolean visivel) {
        this.insensoresAtivos.setValue(visivel);
    }

    public void setPFPVisivel(boolean visivel) {
        this.inPFPVisivel.setValue(visivel);
    }

    public void setPosInicial() {
        this.inPosicaoInicial.setValue(true);
    }

    public void setAlfa(float angulo) {
        this.inBase.setValue(new float[]{0, 1, 0, this.toRadianos(angulo)});
    }

    public void setBeta(float angulo) {
        this.inAntebraco.setValue(
                new float[]{0, 0, 1, this.toRadianos(angulo)});
    }

    public void setGama(float angulo) {
        this.inBraco.setValue(new float[]{0, 0, 1, this.toRadianos(angulo)});
    }

    public void setElevacao(float angulo) {
        this.inElevacao.setValue(
                new float[]{0, 0, 1, this.toRadianos(angulo)});
    }

    public void setRotacao(float angulo) {
        this.inRotacao.setValue(
                new float[]{0, 1, 0, this.toRadianos(angulo)});
    }

    public void abrirFecharGarra(float abrir) {
        if (abrir == 4) {
            this.inAbertura.setValue((float) 0.3);
            Pegar_soltar.SoltaObjeto();//verifica solta objeto
        }
        if (abrir == 5) {
            Pegar_soltar.TestaPreensao(0);//teste de preensão
            this.inAbertura.setValue((float) 0.075);
        }
        if (abrir != 5 && abrir != 4) {
            this.inAbertura.setValue((float) (abrir + 0.065));
        }
    }

    public void addAlfa(float angulo) {
        this.inBase.setValue(
                new float[]{
                    0,
                    1,
                    0,
                    (this.alfa.getValue() + this.toRadianos(angulo))});
    }

    public void addBeta(float angulo) {
        this.inAntebraco.setValue(
                new float[]{
                    0,
                    0,
                    1,
                    (this.beta.getValue() + this.toRadianos(angulo))});
    }

    public void addGama(float angulo) {
        this.inBraco.setValue(
                new float[]{
                    0,
                    0,
                    1,
                    (this.gama.getValue() + this.toRadianos(angulo))});
    }

    public void addElevacao(float angulo) {
        this.inElevacao.setValue(
                new float[]{
                    0,
                    0,
                    1,
                    (this.elevacao.getValue() + this.toRadianos(angulo))});
    }

    public void addRotacao(float angulo) {
        this.inRotacao.setValue(
                new float[]{
                    0,
                    1,
                    0,
                    (this.rotacao.getValue() + this.toRadianos(angulo))});
    }

    public void setAngulos(Angulos ang) {
        this.setAlfa(ang.getAlfa().floatValue());
        this.setBeta(ang.getBeta().floatValue());
        this.setGama(ang.getGama().floatValue());
        this.setElevacao(ang.getElevacao().floatValue());
        this.setRotacao(ang.getRotacao().floatValue());
    }

    public Angulos getAngulos() {
        return new Angulos(
                this.getAlfa(),
                this.getBeta(),
                this.getGama(),
                this.getElevacao(),
                this.getRotacao());
    }

    public Eixo getEixo() {
        return new Eixo(this.getPontoX(), this.getPontoY(), this.getPontoZ());
    }

    public Float getAlfa() {
        return new Float(toGraus(this.alfa.getValue()));
    }

    public Float getBeta() {
        return new Float(toGraus(this.beta.getValue()));
    }

    public Float getGama() {
        return new Float(toGraus(this.gama.getValue()));
    }

    public Float getElevacao() {
        return new Float(toGraus(this.elevacao.getValue()));
    }

    public Float getRotacao() {
        return new Float(toGraus(this.rotacao.getValue()));
    }

    public Boolean getAbertura() {
        return this.abertura.getValue();
    }

    public Float getPontoX() {
        float[] data = new float[3];
        this.vGPtC.getValue(data);
        return data[0];
    }

    public Float getPontoY() {
        float[] data = new float[3];
        this.vGPtC.getValue(data);
        return data[1];
    }

    public Float getPontoZ() {
        float[] data = new float[3];
        this.vGPtC.getValue(data);
        return data[2];
    }

    public boolean getStateGripper() {
        return stateGripper;
    }

    public float toRadianos(float graus) {
        return (float) (graus * Math.PI / 180.0);
    }

    public float toGraus(float radianos) {
        return (float) (radianos * 180.0 / Math.PI);
    }
    //Run da janela programa

    public void setMove(Angulos angulos) {
        float[][] temp = angulos.toArray();
        System.out.println("temp[0] = " + temp[0].toString());
        System.out.println("LENGHT = " + temp.length);
        for (int aux = 0; aux < temp.length; aux++) {
            temp[aux][3] = this.toRadianos(temp[aux][3]);
            System.out.println("Temp [" + aux + "] = " + temp[aux][0] + temp[aux][1] + temp[aux][2] + temp[aux][3]);
        }
        //Era inAlfa, inBeta, inGama, inElev, inRota
        this.inAlfa.setValue(temp[0]);
        this.inBeta.setValue(temp[1]);
        this.inGama.setValue(temp[2]);
        this.inElev.setValue(temp[3]);
        this.inRota.setValue(temp[4]);
        this.inExecutar.setValue(new Date().getTime() / 1000.0);
    }
    //calcula a sinematica inversa

    public void calcularInversa(float posX, float posY, float posZ,
            float pitch, float roll, boolean cotovelo) {
        float angBase = (float) Math.atan2(posY, posX);

        float k1 = (float) ((posX * Math.cos(angBase)) + (posY * Math.sin(angBase))
                - DESVIO + (TAM_GARRA * Math.sin(pitch)));

        float k2 = (float) ((-posZ) + ALTURA - (TAM_GARRA * Math.cos(pitch)));

        float angBraco = (float) ((cotovelo ? (1) : (-1)) * Math.acos(
                (Math.pow(k1, 2) + Math.pow(k2, 2) - Math.pow(TAM_BRACO, 2)
                - Math.pow(TAM_BRACO, 2)) / (2 * TAM_BRACO * TAM_BRACO)));

        float c2 = (float) (((k1 * (TAM_BRACO + (TAM_BRACO * Math.cos(angBraco))))
                + (k2 * TAM_BRACO * Math.sin(angBraco)))
                / (2 * Math.pow(TAM_BRACO, 2) + (2 * TAM_BRACO * TAM_BRACO * Math.cos(angBraco))));

        float s2 = (float) ((((-k1) * TAM_BRACO * Math.sin(angBraco))
                + (k2 * (TAM_BRACO + (TAM_BRACO * Math.cos(angBraco)))))
                / (2 * Math.pow(TAM_BRACO, 2) + (2 * TAM_BRACO * TAM_BRACO * Math.cos(angBraco))));

        float angAntebraco = (float) (Math.atan2(s2, c2) + (Math.PI / 2));

        float angElevacao = (float) (pitch - angBraco - angAntebraco + Math.PI);

        //necessário para Z<0 (devido aos limites do robô...
        //não é permitido que ele "volte" no ângulo da base)
        if (angBase < 0) {
            angBase += 2 * Math.PI; //acrescenta 360° pois o valor não pode ser negativo
        }

        if (toGraus(angBase) >= 0 && toGraus(angBase) < 310
                && toGraus(angAntebraco) > -35 && toGraus(angAntebraco) < 130 && toGraus(angAntebraco) != 0
                && toGraus(angBraco) > -130 && toGraus(angBraco) < 130 && toGraus(angBraco) != 0
                && toGraus(angElevacao) > -130 && toGraus(angElevacao) < 130 && toGraus(angElevacao) != 0) {
            this.inBase.setValue(new float[]{0, 1, 0, angBase});
            this.inAntebraco.setValue(new float[]{0, 0, 1, angAntebraco});
            this.inBraco.setValue(new float[]{0, 0, 1, angBraco});
            this.inElevacao.setValue(new float[]{0, 0, 1, angElevacao});
            this.inRotacao.setValue(new float[]{0, 1, 0, roll});
            if (jp.getIdioma().equals("Portugues")) {
                this.setTxtFeedback("Posição alcançada com sucesso!");
            }
            if (jp.getIdioma().equals("Ingles")) {
                this.setTxtFeedback("Position achieved successfully!");
            }
            try {
                Thread.sleep(100);
            } catch (InterruptedException ex2) {
            }
            Pegar_soltar.TestaPreensao(1);
            posicaoOK = true;
        } else {
            if (jp.getIdioma().equals("Portugues")) {
                this.setTxtFeedback("Posição desejada não pode ser "
                        + "alcançada com esta configuração ou está fora do envelope"
                        + "de trabalho do robô!");
            }
            if (jp.getIdioma().equals("ingles")) {
                this.setTxtFeedback("Desired position can not be achieved"
                        + " with this configuration or is outside the working envelope "
                        + "of robot!");
            }
            posicaoOK = false;
        }
        atualizaObbsRobo();
    }

    public ArrayList calcularInversaPontos(float posX, float posY, float posZ,
            float pitch, float roll, boolean cotovelo) {
        //System.out.println("X"+posX+" Y"+posY+" Z"+posZ+" Pitch"+pitch+" Roll"+roll+" C"+cotovelo);
        float angBase = (float) Math.atan2(posY, posX);

        float k1 = (float) ((posX * Math.cos(angBase)) + (posY * Math.sin(angBase))
                - DESVIO + (TAM_GARRA * Math.sin(pitch)));

        float k2 = (float) ((-posZ) + ALTURA - (TAM_GARRA * Math.cos(pitch)));

        float angBraco = (float) ((cotovelo ? (1) : (-1)) * Math.acos(
                (Math.pow(k1, 2) + Math.pow(k2, 2) - Math.pow(TAM_BRACO, 2)
                - Math.pow(TAM_BRACO, 2)) / (2 * TAM_BRACO * TAM_BRACO)));

        float c2 = (float) (((k1 * (TAM_BRACO + (TAM_BRACO * Math.cos(angBraco))))
                + (k2 * TAM_BRACO * Math.sin(angBraco)))
                / (2 * Math.pow(TAM_BRACO, 2) + (2 * TAM_BRACO * TAM_BRACO * Math.cos(angBraco))));

        float s2 = (float) ((((-k1) * TAM_BRACO * Math.sin(angBraco))
                + (k2 * (TAM_BRACO + (TAM_BRACO * Math.cos(angBraco)))))
                / (2 * Math.pow(TAM_BRACO, 2) + (2 * TAM_BRACO * TAM_BRACO * Math.cos(angBraco))));

        float angAntebraco = (float) (Math.atan2(s2, c2) + (Math.PI / 2));

        float angElevacao = (float) (pitch - angBraco - angAntebraco + Math.PI);

        //necessário para Z<0 (devido aos limites do robô...
        //não é permitido que ele "volte" no ângulo da base)
        if (angBase < 0) {
            angBase += 2 * Math.PI; //acrescenta 360° pois o valor não pode ser negativo
        }

        if (toGraus(angBase) >= 0 && toGraus(angBase) < 310
                && toGraus(angAntebraco) > -35 && toGraus(angAntebraco) < 130 && toGraus(angAntebraco) != 0
                && toGraus(angBraco) > -130 && toGraus(angBraco) < 130 && toGraus(angBraco) != 0
                && toGraus(angElevacao) > -130 && toGraus(angElevacao) < 130 && toGraus(angElevacao) != 0) {
            ArrayList ang = new ArrayList();
            ang.add(angBase);
            ang.add(angAntebraco);
            ang.add(angBraco);
            ang.add(angElevacao);
            ang.add(roll);
            return ang;
        }
        return null;
    }

    public boolean getPosicaoOK() {
        return posicaoOK;
    }

    public boolean getPego() {
        return pego;
    }

    public void setPego(boolean p) {
        pego = p;
    }

    public ObbTree getObbTreeAntBraco() {
        return treeAntBraco;
    }

    public ObbTree getObbTreeBase() {
        return treeBase;
    }

    public ObbTree getObbTreeBraco() {
        return treeBraco;
    }

    public ObbTree getObbTreeCorpo() {
        return treeCorpo;
    }

    public ObbTree getObbTreeGarra() {
        return treeGarra;
    }

    public void inAddChildrenGarra(String ChildrenGarra) {
        float A = this.getAlfa();
        float B = this.getBeta();
        float G = this.getGama();
        float E = this.getElevacao();
        float R = this.getRotacao();
        this.addAlfa(-this.getAlfa());
        this.addBeta(-this.getBeta());
        this.addGama(-this.getGama());
        this.addElevacao(-this.getElevacao());
        this.addRotacao(-this.getRotacao());
        try {
            Thread.sleep(20);
        } catch (InterruptedException ex3) {
        }
        filhoObj[0] = getX3DBrowser().createX3DFromString("<X3D profile='Immersive' version='3.2' ><Scene>" + ChildrenGarra + "</Scene></X3D>").getRootNodes();
        inAddChildrenGarra.setValue(1, filhoObj[0]);
        this.addAlfa(A);
        this.addBeta(B);
        this.addGama(G);
        this.addElevacao(E);
        this.addRotacao(R);
        try {
            Thread.sleep(50);
        } catch (InterruptedException ex3) {
        }

    }

    public void inRemoveChildrenGarra() {
        inRemoveChildrenGarra.setValue(1, filhoObj[0]);
    }

    public void indicaColisao1(int id) {
        float colisionColor[] = {1, 0, 0};
        this.color = (SFColor) mainScene.getNamedNode("ROBO").getField("COLOR" + id);
        color.setValue(colisionColor);
        this.objCol1 = id;
    }

    public void indicaColisao2(int id) {
        float colisionColor[] = {1, 0, 0};
        this.color = (SFColor) mainScene.getNamedNode("ROBO").getField("COLOR" + id);
        color.setValue(colisionColor);
        this.objCol2 = id;
    }

    public void retiraColisao() {
        if (this.objCol1 > -1) {
            this.color = (SFColor) mainScene.getNamedNode("ROBO").getField("COLOR" + this.objCol1);
            color.setValue(this.listaCores[this.objCol1]);
            this.objCol1 = -1;
        }

        if (this.objCol2 > -1) {
            this.color = (SFColor) mainScene.getNamedNode("ROBO").getField("COLOR" + this.objCol2);
            color.setValue(this.listaCores[this.objCol2]);
            this.objCol2 = -1;
        }
    }

    public void readableFieldChanged(X3DFieldEvent evt) {
        //jp.getJanelaCD().atualizaTexto();
    }

    public void keyPressed(KeyEvent evt) {
    }

    public void keyReleased(KeyEvent arg0) {
    }

    public void NMClick() {
        NManipulacoesClick++;
    }

    public void NMTeclado() {
        NManipulacoesTeclado++;
    }

    public void NPreencaoO() {
        NPreencaoO++;
    }

    public void NPreencaoO(int num) {
        if (num == 0) {
            NPreencaoOM++;
        }
        if (num == 1) {
            NPreencaoOF++;
        }
    }

    public void NPreencaoOSub(int num) {
        if (num == 0) {
            NPreencaoOM--;
        }
        if (num == 1) {
            NPreencaoOF--;
        }
    }
}
