/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package virbot4u;

/**
 *
 * @author Alehoss
 */
import Robo.Eixo;
import java.awt.event.ActionEvent;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.*;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JRadioButton;
import javax.swing.BorderFactory;

import java.awt.*;
import java.awt.Font;
import java.awt.Rectangle;
import java.awt.Color;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

public class JanelaCI extends JFrame implements KeyListener, ActionListener {

    private static final long serialVersionUID = 1L;
    private JPanel jContentPane = null;
    private JLabel lblFatorCI = null;
    private JButton btEixoXPos = null;
    private JLabel lblEixoX = null;
    private JButton btEixoYPos = null;
    private JButton btEixoZPos = null;
    private JLabel lblEixoY = null;
    private JLabel lblMais = null;
    private JLabel lblMenos = null;
    private JLabel lblEixoZ = null;
    private JButton btEixoXNeg = null;
    private JButton btEixoYNeg = null;
    private JButton btEixoZNeg = null;
    private JButton btPitchPos = null;
    private JButton btPitchNeg = null;
    private JButton btRollPos = null;
    private JButton btRollNeg = null;
    private JTextField txtEixoX = null;
    private JTextField txtEixoY = null;
    private JTextField txtEixoZ = null;
    private JTextField txtFatorCI = null;
    private JTextField txtFatorPitch = null;
    private JTextField txtPitch = null;
    private JTextField txtRoll = null;
    private JPanel pnAbGarra = null;
    private JLabel lblGarra = null;
    private JLabel lblCima = null;
    private JLabel lblFixa = null;
    private JLabel lblFrente = null;
    private JLabel lblTras = null;
    private JButton btAbGarra = null;
    private JButton btFecharGarra = null;
    private JButton btPosIni = null;
    private JPanel pnAbBraco = null;
    private JLabel lblBraco = null;
    private JLabel lblAcima = null;
    private JLabel lblAbaixo = null;
    private JLabel lblLinha = null;
    private JLabel lblLinha1 = null;
    private JLabel lblAbGarra = null;
    private JLabel lblFatorPitch;
    private JLabel lblPitch;
    private JLabel lblRoll;
    private CenaX3D cena;
    private Rectangle tamanhoJanela;
    private boolean cotovelo = true; //true = acima ; false = abaixo
    private static float pitch;
    public static JRadioButton rbCima = null;
    public static JRadioButton rbFrente = null;
    public static JRadioButton rbTras = null;
    public static JRadioButton rbFixa = null;
    public static JRadioButton rbAcima = null;
    public static JRadioButton rbAbaixo = null;
    public static JButton btAtualiza;

    /**
     * This is the default constructor
     */
    public JanelaCI(CenaX3D cena, Rectangle tamanhoJanela) {
        super();
        this.cena = cena;
        this.tamanhoJanela = tamanhoJanela;
        initialize();
    }

    /**
     * This method initializes this
     *
     * @return void
     */
    private void initialize() {
        this.setSize(275, 465);
        this.setLocation(tamanhoJanela.width - 340, tamanhoJanela.height - 522);
        this.setContentPane(getJContentPane());
        this.setIconImage(Toolkit.getDefaultToolkit().getImage("Figuras/larvao2.gif"));
        this.setAlwaysOnTop(true);
        this.setResizable(false);
        this.setVisible(true);
        this.addKeyListener(this);
        this.requestFocus();
    }

    /**
     * This method initializes jContentPane
     *
     * @return javax.swing.JPanel
     */
    private JPanel getJContentPane() {
        if (jContentPane == null) {
            lblEixoZ = new JLabel();
            lblEixoZ.setForeground(new Color(0,255,0));
            lblEixoZ.setBounds(new Rectangle(10, 143, 48, 17));
            lblEixoZ.setFont(new Font("Tahoma", 1, 12));
            lblMais = new JLabel();
            lblMais.setFont(new Font("Tahoma", 1, 24));
            lblMais.setBounds(new Rectangle(76, 50, 20, 20));
            lblMais.setIcon(new ImageIcon("Figuras/Mais.gif"));
            lblMenos = new JLabel();
            lblMenos.setFont(new Font("Tahoma", 1, 24));
            lblMenos.setBounds(new Rectangle(126, 50, 20, 20));
            lblMenos.setIcon(new ImageIcon("Figuras/Menos.gif"));
            lblEixoY = new JLabel();
            lblEixoY.setForeground(new Color(0,0,255));
            lblEixoY.setBounds(new Rectangle(10, 113, 48, 17));
            lblEixoY.setFont(new Font("Tahoma", 1, 12));
            lblEixoX = new JLabel();
            lblEixoX.setForeground(new Color(255,0,0));
            lblEixoX.setBounds(new Rectangle(10, 83, 50, 17));
            lblEixoX.setFont(new Font("Tahoma", 1, 12));
            lblFatorCI = new JLabel();
            lblFatorCI.setBounds(new Rectangle(10, 15, 125, 17));
            lblFatorCI.setFont(new Font("Tahoma", 1, 12));
            lblFatorPitch = new JLabel();
            lblFatorPitch.setBounds(new Rectangle(10, 182, 125, 17));
            lblFatorPitch.setFont(new Font("Tahoma", 1, 12));
            lblPitch = new JLabel();
            lblPitch.setBounds(new Rectangle(10, 217, 50, 17));
            lblPitch.setFont(new Font("Tahoma", 1, 12));
            lblRoll = new JLabel();
            lblRoll.setBounds(new Rectangle(10, 247, 50, 17));
            lblRoll.setFont(new Font("Tahoma", 1, 12));
            lblGarra = new JLabel();
            lblGarra.setFont(new Font("Tahoma", 1, 12));
            lblGarra.setBounds(new Rectangle(10, 277, 60, 16));
            jContentPane = new JPanel();
            jContentPane.setLayout(null);
            jContentPane.add(lblFatorCI, null);
            jContentPane.add(lblFatorPitch, null);
            jContentPane.add(lblPitch, null);
            jContentPane.add(lblRoll, null);
            jContentPane.add(getBtEixoXPos(), null);
            jContentPane.add(lblEixoX, null);
            jContentPane.add(getBtEixoYPos(), null);
            jContentPane.add(getBtEixoZPos(), null);
            jContentPane.add(lblEixoY, null);
            jContentPane.add(lblMais, null);
            jContentPane.add(lblMenos, null);
            jContentPane.add(lblEixoZ, null);
            jContentPane.add(getBtEixoXNeg(), null);
            jContentPane.add(getBtEixoYNeg(), null);
            jContentPane.add(getBtEixoZNeg(), null);
            jContentPane.add(getTxtEixoX(), null);
            jContentPane.add(getTxtEixoY(), null);
            jContentPane.add(getTxtEixoZ(), null);
            jContentPane.add(getTxtPitch(), null);
            jContentPane.add(getTxtRoll(), null);
            jContentPane.add(getTxtFatorCI(), null);
            jContentPane.add(getTxtFatorPitch(), null);
            jContentPane.add(getPnAbGarra(), null);
            jContentPane.add(getBtAbGarra(), null);
            jContentPane.add(getBtFecharGarra(), null);
            jContentPane.add(getBtPitchPos(), null);
            jContentPane.add(getBtPitchNeg(), null);
            jContentPane.add(getBtRollPos(), null);
            jContentPane.add(getBtRollNeg(), null);
            jContentPane.add(getBtPosIni(), null);
            jContentPane.add(geBtAtualiza(), null);
            jContentPane.add(getPnAbBraco(), null);
            jContentPane.add(lblGarra, null);
        }
        return jContentPane;
    }

    /**
     * This method initializes btEixoXPos
     *
     * @return javax.swing.JButton
     */
    private JButton getBtEixoXPos() {
        if (btEixoXPos == null) {
            btEixoXPos = new JButton();
            btEixoXPos.setBounds(new Rectangle(65, 75, 45, 25));
            btEixoXPos.setFont(new Font("Tahoma", 1, 12));
            btEixoXPos.setText("1");
            btEixoXPos.addActionListener(this);
            btEixoXPos.addKeyListener(this);
        }
        return btEixoXPos;
    }

    /**
     * This method initializes btEixoYPos
     *
     * @return javax.swing.JButton
     */
    private JButton getBtEixoYPos() {
        if (btEixoYPos == null) {
            btEixoYPos = new JButton();
            btEixoYPos.setBounds(new Rectangle(65, 105, 45, 25));
            btEixoYPos.setText("2");
            btEixoYPos.setFont(new Font("Tahoma", 1, 12));
            btEixoYPos.addActionListener(this);
            btEixoYPos.addKeyListener(this);
        }
        return btEixoYPos;
    }

    /**
     * This method initializes btEixoZPos
     *
     * @return javax.swing.JButton
     */
    private JButton getBtEixoZPos() {
        if (btEixoZPos == null) {
            btEixoZPos = new JButton();
            btEixoZPos.setBounds(new Rectangle(65, 135, 45, 25));
            btEixoZPos.setText("3");
            btEixoZPos.setFont(new Font("Tahoma", 1, 12));
            btEixoZPos.addActionListener(this);
            btEixoZPos.addKeyListener(this);
        }
        return btEixoZPos;
    }

    /**
     * This method initializes btEixoXNeg
     *
     * @return javax.swing.JButton
     */
    private JButton getBtEixoXNeg() {
        if (btEixoXNeg == null) {
            btEixoXNeg = new JButton();
            btEixoXNeg.setBounds(new Rectangle(115, 75, 45, 25));
            btEixoXNeg.setText("Q");
            btEixoXNeg.setFont(new Font("Tahoma", 1, 12));
            btEixoXNeg.addActionListener(this);
            btEixoXNeg.addKeyListener(this);
        }
        return btEixoXNeg;
    }

    /**
     * This method initializes btEixoYNeg
     *
     * @return javax.swing.JButton
     */
    private JButton getBtEixoYNeg() {
        if (btEixoYNeg == null) {
            btEixoYNeg = new JButton();
            btEixoYNeg.setBounds(new Rectangle(115, 105, 45, 25));
            btEixoYNeg.setText("W");
            btEixoYNeg.setFont(new Font("Tahoma", 1, 11));
            btEixoYNeg.addActionListener(this);
            btEixoYNeg.addKeyListener(this);
        }
        return btEixoYNeg;
    }

    /**
     * This method initializes btEixoZNeg
     *
     * @return javax.swing.JButton
     */
    private JButton getBtEixoZNeg() {
        if (btEixoZNeg == null) {
            btEixoZNeg = new JButton();
            btEixoZNeg.setBounds(new Rectangle(115, 135, 45, 25));
            btEixoZNeg.setText("E");
            btEixoZNeg.setFont(new Font("Tahoma", 1, 12));
            btEixoZNeg.addActionListener(this);
            btEixoZNeg.addKeyListener(this);
        }
        return btEixoZNeg;
    }

    /**
     * This method initializes txtEixoX
     *
     * @return javax.swing.JTextField
     */
    private JTextField getTxtEixoX() {
        if (txtEixoX == null) {
            txtEixoX = new JTextField();
            txtEixoX.setFont(new Font("Tahoma", 1, 12));
            txtEixoX.setBounds(new Rectangle(170, 75, 80, 25));
            txtEixoX.setForeground(Color.RED);
            txtEixoX.setText("0.0");
            txtEixoX.addKeyListener(this);
        }
        return txtEixoX;
    }

    /**
     * This method initializes txtEixoY
     *
     * @return javax.swing.JTextField
     */
    private JTextField getTxtEixoY() {
        if (txtEixoY == null) {
            txtEixoY = new JTextField();
            txtEixoY.setFont(new Font("Tahoma", 1, 12));
            txtEixoY.setBounds(new Rectangle(170, 105, 80, 25));
            txtEixoY.setForeground(Color.BLUE);
            txtEixoY.setText("0.0");
            txtEixoY.addKeyListener(this);
        }
        return txtEixoY;
    }

    /**
     * This method initializes txtEixoZ
     *
     * @return javax.swing.JTextField
     */
    private JTextField getTxtEixoZ() {
        if (txtEixoZ == null) {
            txtEixoZ = new JTextField();
            txtEixoZ.setFont(new Font("Tahoma", 1, 12));
            txtEixoZ.setBounds(new Rectangle(170, 135, 80, 25));
            txtEixoZ.setForeground(Color.GREEN);
            txtEixoZ.setText("0.0");
            txtEixoZ.addKeyListener(this);
        }
        return txtEixoZ;
    }

    private JTextField getTxtPitch() {
        if (txtPitch == null) {
            txtPitch = new JTextField();
            txtPitch.setFont(new Font("Tahoma", 1, 12));
            txtPitch.setBounds(new Rectangle(170, 210, 80, 25));
            txtPitch.setText("-180.0");
            txtPitch.addKeyListener(this);
        }
        return txtPitch;
    }

    private JTextField getTxtRoll() {
        if (txtRoll == null) {
            txtRoll = new JTextField();
            txtRoll.setFont(new Font("Tahoma", 1, 12));
            txtRoll.setBounds(new Rectangle(170, 240, 80, 25));
            txtRoll.setText("0.0");
            txtRoll.addKeyListener(this);
        }
        return txtRoll;
    }

    /**
     * This method initializes txtFatorCI
     *
     * @return javax.swing.JTextField
     */
    private JTextField getTxtFatorCI() {
        if (txtFatorCI == null) {
            txtFatorCI = new JTextField();
            txtFatorCI.setFont(new Font("Tahoma", 1, 12));
            txtFatorCI.setBounds(new Rectangle(100, 10, 45, 25));
            txtFatorCI.setText("5.0");
            txtFatorCI.addKeyListener(this);
        }
        return txtFatorCI;
    }

    private JTextField getTxtFatorPitch() {
        if (txtFatorPitch == null) {
            txtFatorPitch = new JTextField();
            txtFatorPitch.setFont(new Font("Tahoma", 1, 12));
            txtFatorPitch.setBounds(new Rectangle(120, 175, 45, 25));
            txtFatorPitch.setText("5.0");
            txtFatorPitch.addKeyListener(this);
        }
        return txtFatorPitch;
    }

    private JButton getBtPitchPos() {
        if (btPitchPos == null) {
            btPitchPos = new JButton();
            btPitchPos.setBounds(new Rectangle(65, 210, 45, 25));
            btPitchPos.setText("4");
            btPitchPos.setFont(new Font("Tahoma", 1, 12));
            btPitchPos.addActionListener(this);
            btPitchPos.addKeyListener(this);
        }
        return btPitchPos;
    }

    private JButton getBtPitchNeg() {
        if (btPitchNeg == null) {
            btPitchNeg = new JButton();
            btPitchNeg.setBounds(new Rectangle(115, 210, 45, 25));
            btPitchNeg.setText("R");
            btPitchNeg.setFont(new Font("Tahoma", 1, 12));
            btPitchNeg.addActionListener(this);
            btPitchNeg.addKeyListener(this);
        }
        return btPitchNeg;
    }

    private JButton getBtRollPos() {
        if (btRollPos == null) {
            btRollPos = new JButton();
            btRollPos.setBounds(new Rectangle(65, 240, 45, 25));
            btRollPos.setText("5");
            btRollPos.setFont(new Font("Tahoma", 1, 12));
            btRollPos.addActionListener(this);
            btRollPos.addKeyListener(this);
        }
        return btRollPos;
    }

    private JButton getBtRollNeg() {
        if (btRollNeg == null) {
            btRollNeg = new JButton();
            btRollNeg.setBounds(new Rectangle(115, 240, 45, 25));
            btRollNeg.setText("T");
            btRollNeg.setFont(new Font("Tahoma", 1, 12));
            btRollNeg.addActionListener(this);
            btRollNeg.addKeyListener(this);
        }
        return btRollNeg;
    }

    /**
     * This method initializes pnAbGarra
     *
     * @return javax.swing.JPanel
     */
    private JPanel getPnAbGarra() {
        if (pnAbGarra == null) {
            lblAbGarra = new JLabel();
            lblAbGarra.setBounds(new Rectangle(35, 5, 83, 17));
            lblAbGarra.setFont(new Font("Tahoma", 1, 12));
            lblLinha1 = new JLabel();
            lblLinha1.setBounds(new Rectangle(0, 10, 180, 15));
            lblLinha1.setText("______________________");
            lblLinha1.setFont(new Font("Tahoma", 1, 12));
            lblTras = new JLabel();
            lblTras.setBounds(new Rectangle(90, 60, 45, 17));
            lblTras.setFont(new Font("Tahoma", 1, 12));
            lblFrente = new JLabel();
            lblFrente.setBounds(new Rectangle(90, 35, 50, 17));
            lblFrente.setFont(new Font("Tahoma", 1, 12));
            lblCima = new JLabel();
            lblCima.setBounds(new Rectangle(25, 35, 45, 16));
            lblCima.setFont(new Font("Tahoma", 1, 12));
            lblFixa = new JLabel();
            lblFixa.setBounds(new Rectangle(25, 60, 45, 16));
            lblFixa.setFont(new Font("Tahoma", 1, 12));
            pnAbGarra = new JPanel();
            pnAbGarra.setLayout(null);
            pnAbGarra.setBounds(new Rectangle(10, 340, 145, 85));
            pnAbGarra.setBorder(BorderFactory.createLineBorder(new Color(0, 0, 255)));
            pnAbGarra.add(getRbCima(), null);
            pnAbGarra.add(getRbFixa(), null);
            pnAbGarra.add(getRbFrente(), null);
            pnAbGarra.add(getRbTras(), null);
            pnAbGarra.add(lblCima, null);
            pnAbGarra.add(lblFixa, null);
            pnAbGarra.add(lblFrente, null);
            pnAbGarra.add(lblTras, null);
            pnAbGarra.add(lblLinha1, null);
            pnAbGarra.add(lblAbGarra, null);
            ButtonGroup bgGarra = new ButtonGroup();
            bgGarra.add(rbCima);
            bgGarra.add(rbFixa);
            bgGarra.add(rbFrente);
            bgGarra.add(rbTras);
        }
        return pnAbGarra;
    }

    /**
     * This method initializes rbCima
     *
     * @return javax.swing.JRadioButton
     */
    private JRadioButton getRbCima() {
        if (rbCima == null) {
            rbCima = new JRadioButton();
            rbCima.setBounds(new Rectangle(5, 35, 21, 21));
            rbCima.addActionListener(this);
        }
        return rbCima;
    }

    /**
     * This method initializes rbFixa
     *
     * @return javax.swing.JRadioButton
     */
    private JRadioButton getRbFixa() {
        if (rbFixa == null) {
            rbFixa = new JRadioButton();
            rbFixa.setBounds(new Rectangle(5, 60, 21, 21));
            rbFixa.setSelected(true);
            rbFixa.addActionListener(this);
        }
        return rbFixa;
    }

    /**
     * This method initializes rbFrente
     *
     * @return javax.swing.JRadioButton
     */
    private JRadioButton getRbFrente() {
        if (rbFrente == null) {
            rbFrente = new JRadioButton();
            rbFrente.setBounds(new Rectangle(70, 35, 21, 21));
            rbFrente.addActionListener(this);
        }
        return rbFrente;
    }

    /**
     * This method initializes rbTras
     *
     * @return javax.swing.JRadioButton
     */
    private JRadioButton getRbTras() {
        if (rbTras == null) {
            rbTras = new JRadioButton();
            rbTras.setBounds(new Rectangle(70, 60, 21, 21));
            rbTras.addActionListener(this);
        }
        return rbTras;
    }

    /**
     * This method initializes btAbGarra
     *
     * @return javax.swing.JButton
     */
    private JButton getBtAbGarra() {
        if (btAbGarra == null) {
            ImageIcon abre = new ImageIcon("Figuras/abre.gif");
            btAbGarra = new JButton(abre);
            btAbGarra.setBounds(new Rectangle(65, 270, 45, 25));
            btAbGarra.setFont(new Font("Tahoma", 1, 12));
            btAbGarra.setActionCommand("abrirGarra");
            btAbGarra.addActionListener(this);
            btAbGarra.addKeyListener(this);
        }
        return btAbGarra;
    }

    /**
     * This method initializes btFecharGarra
     *
     * @return javax.swing.JButton
     */
    private JButton getBtFecharGarra() {
        if (btFecharGarra == null) {
            ImageIcon fecha = new ImageIcon("Figuras/fecha.gif");
            btFecharGarra = new JButton(fecha);
            btFecharGarra.setBounds(new Rectangle(115, 270, 45, 25));
            btFecharGarra.setFont(new Font("Tahoma", 1, 12));
            btFecharGarra.setActionCommand("fecharGarra");
            btFecharGarra.addActionListener(this);
            btFecharGarra.addKeyListener(this);
        }
        return btFecharGarra;
    }

    /**
     * This method initializes btPosIni
     *
     * @return javax.swing.JButton
     */
    public JButton getBtPosIni() {
        if (btPosIni == null) {
            btPosIni = new JButton();
            btPosIni.setBounds(new Rectangle(160, 10, 80, 25));
            btPosIni.setFont(new Font("Tahoma", 1, 12));
            btPosIni.addActionListener(this);
            btPosIni.addKeyListener(this);
        }
        return btPosIni;
    }

    public JButton geBtAtualiza() {
        if (btAtualiza == null) {
            btAtualiza = new JButton();
            btAtualiza.setBounds(new Rectangle(65, 305, 140, 25));
            btAtualiza.setText("Update");
            btAtualiza.setFont(new Font("Tahoma", 1, 12));
            btAtualiza.addActionListener(this);
            btAtualiza.addKeyListener(this);
        }
        return btAtualiza;
    }

    /**
     * This method initializes pnAbBraco
     *
     * @return javax.swing.JPanel
     */
    private JPanel getPnAbBraco() {
        if (pnAbBraco == null) {
            lblLinha = new JLabel();
            lblLinha.setBounds(new Rectangle(0, 10, 135, 15));
            lblLinha.setFont(new Font("Tahoma", 1, 12));
            lblLinha.setText("________________");
            lblAbaixo = new JLabel();
            lblAbaixo.setBounds(new Rectangle(34, 60, 50, 17));
            lblAbaixo.setFont(new Font("Tahoma", 1, 12));
            lblAcima = new JLabel();
            lblAcima.setBounds(new Rectangle(34, 35, 50, 16));
            lblAcima.setFont(new Font("Tahoma", 1, 12));
            lblBraco = new JLabel();
            lblBraco.setBounds(new Rectangle(30, 5, 46, 16));
            lblBraco.setFont(new Font("Tahoma", 1, 12));
            pnAbBraco = new JPanel();
            pnAbBraco.setLayout(null);
            pnAbBraco.setBounds(new Rectangle(160, 340, 100, 85));
            pnAbBraco.setBorder(BorderFactory.createLineBorder(new Color(0, 0, 255)));
            pnAbBraco.add(lblBraco, null);
            pnAbBraco.add(getRbAcima(), null);
            pnAbBraco.add(getRbAbaixo(), null);
            pnAbBraco.add(lblAcima, null);
            pnAbBraco.add(lblAbaixo, null);
            pnAbBraco.add(lblLinha, null);
            ButtonGroup bgBraco = new ButtonGroup();
            bgBraco.add(rbAcima);
            bgBraco.add(rbAbaixo);
        }
        return pnAbBraco;
    }

    /**
     * This method initializes rbAcima
     *
     * @return javax.swing.JRadioButton
     */
    private JRadioButton getRbAcima() {
        if (rbAcima == null) {
            rbAcima = new JRadioButton();
            rbAcima.setBounds(new Rectangle(8, 35, 21, 21));
            rbAcima.setSelected(true);
            rbAcima.addActionListener(this);
        }
        return rbAcima;
    }

    /**
     * This method initializes rbAbaixo
     *
     * @return javax.swing.JRadioButton
     */
    private JRadioButton getRbAbaixo() {
        if (rbAbaixo == null) {
            rbAbaixo = new JRadioButton();
            rbAbaixo.setBounds(new Rectangle(8, 60, 21, 21));
            rbAbaixo.addActionListener(this);
        }
        return rbAbaixo;
    }

    public void setIdioma(String idioma) {
        if (idioma.equals("Portugues")) {
            this.setTitle("Cinemática Inversa");
            lblEixoZ.setText("Eixo Z:");
            lblEixoY.setText("Eixo Y:");
            lblEixoX.setText("Eixo X:");
            lblFatorCI.setText("Fator (mm):");
            lblFatorPitch.setText("Fator (graus):");
            lblPitch.setText("Pitch:");
            lblRoll.setText("Roll:");
            lblAbGarra.setText("Abordagem");
            lblTras.setText("Trás");
            lblFrente.setText("Frente");
            lblCima.setText("Cima");
            lblFixa.setText("Fixa");
            lblGarra.setText("Garra:");
            btPosIni.setText("Início");
            lblAbaixo.setText("Abaixo");
            lblAcima.setText("Acima");
            lblBraco.setText("Braço");
            btAtualiza.setText("Atualizar");
        }
        if (idioma.equals("Ingles")) {
            this.setTitle("Inverse Kinematics");
            lblEixoZ.setText("Axis Z:");
            lblEixoY.setText("Axis Y:");
            lblEixoX.setText("Axis X:");
            lblFatorCI.setText("Factor (mm):");
            lblFatorPitch.setText("Factor (degrees):");
            lblPitch.setText("Pitch:");
            lblRoll.setText("Roll:");
            lblAbGarra.setText("Approach");
            lblTras.setText("Back");
            lblFrente.setText("Front");
            lblCima.setText("Up");
            lblFixa.setText("Fixed");
            lblGarra.setText("Gripper:");
            btPosIni.setText("Home");
            lblAbaixo.setText("Under");
            lblAcima.setText("Above");
            lblBraco.setText("Arm");
            btAtualiza.setText("Update");
        }
    }

    public void actionPerformed(ActionEvent e) {
        if (Float.parseFloat(this.txtFatorPitch.getText()) > cena.maxFator) {
            txtFatorPitch.setText("" + cena.maxFator);
        }
        if (Float.parseFloat(this.txtFatorCI.getText()) > cena.maxFator) {
            txtFatorCI.setText("" + cena.maxFator);
        }
        float pontoX = cena.getPontoX();
        float pontoY = cena.getPontoY();
        float pontoZ = cena.getPontoZ();
        pitch = cena.toRadianos(cena.getElevacao() + cena.getBeta() + cena.getGama()) - (float) Math.PI;
        float roll = cena.toRadianos(cena.getRotacao());
        if (e.getSource().equals(rbCima)) {
            pitch = 0;
            if (JanelaCD.rbCima != null) {
                JanelaCD.rbCima.setSelected(true);
            }
            cena.NMClick();
        }
        if (e.getSource().equals(rbFixa)) {
            pitch = cena.toRadianos(cena.getElevacao() + cena.getBeta() + cena.getGama()) - (float) Math.PI;
            if (JanelaCD.rbFixa != null) {
                JanelaCD.rbFixa.setSelected(true);
            }
            cena.NMClick();
        }
        if (e.getSource().equals(rbFrente)) {
            pitch = (float) -Math.PI / 2;
            if (JanelaCD.rbFrente != null) {
                JanelaCD.rbFrente.setSelected(true);
            }
            cena.NMClick();
        }
        if (e.getSource().equals(rbTras)) {
            pitch = (float) Math.PI / 2;
            if (JanelaCD.rbTras != null) {
                JanelaCD.rbTras.setSelected(true);
            }
            cena.NMClick();
        }
        if (e.getSource().equals(rbAcima)) {
            cotovelo = true;
            cena.NMClick();
        }
        if (e.getSource().equals(rbAbaixo)) {
            cotovelo = false;
            cena.NMClick();
        }
        if (btPosIni.equals(e.getSource())) {
            cena.setPosInicial();
            cena.NMClick();
        } else {
            if (btAbGarra.equals(e.getSource())) {
                cena.abrirFecharGarra(4);
                cena.NMClick();
            }
            if (btFecharGarra.equals(e.getSource())) {
                if (cena.getPego() == false) {
                    cena.abrirFecharGarra(5);
                }
                cena.NMClick();
            }
            if (btEixoXPos.equals(e.getSource())) {
                pontoX = pontoX + this.getFatorCI();
                cena.NMClick();
            }
            if (btEixoYPos.equals(e.getSource())) {
                pontoY = pontoY + this.getFatorCI();
                cena.NMClick();
            }
            if (btEixoZPos.equals(e.getSource())) {
                pontoZ = pontoZ + this.getFatorCI();
                cena.NMClick();
            }
            if (btEixoXNeg.equals(e.getSource())) {
                pontoX = pontoX - this.getFatorCI();
            }
            if (btEixoYNeg.equals(e.getSource())) {
                pontoY = pontoY - this.getFatorCI();
                cena.NMClick();
            }
            if (btEixoZNeg.equals(e.getSource())) {
                pontoZ = pontoZ - this.getFatorCI();
                cena.NMClick();
            }
            if (btPitchPos.equals(e.getSource())) {
                rbFixa.setSelected(true);
                pitch = pitch + this.getFatorPitch();
                cena.NMClick();
            }
            if (btPitchNeg.equals(e.getSource())) {
                rbFixa.setSelected(true);
                pitch = pitch - this.getFatorPitch();
                cena.NMClick();
            }
            if (btRollPos.equals(e.getSource())) {
                roll = roll + this.getFatorPitch();
                cena.NMClick();
            }
            if (btRollNeg.equals(e.getSource())) {
                roll = roll - this.getFatorPitch();
                cena.NMClick();
            }
            if (!btAbGarra.equals(e.getSource()) && !btFecharGarra.equals(e.getSource())) {
                cena.calcularInversa(-pontoX, pontoZ, pontoY,
                        pitch, roll, cotovelo);
            }
        }
        try {
            Thread.sleep(100);
        } catch (InterruptedException ex) {
            Logger.getLogger(JanelaCI.class.getName()).log(Level.SEVERE, null, ex);
        }
        if (cena.getGama() >= 0) {
            cotovelo = true;
            rbAcima.setSelected(true);
        }
        if (cena.getGama() < 0) {
            cotovelo = false;
            rbAbaixo.setSelected(true);
        }
        if (e.getSource() instanceof JRadioButton) {
            try {
                Thread.sleep(100);
            } catch (InterruptedException ex) {
                Logger.getLogger(JanelaCI.class.getName()).log(Level.SEVERE, null, ex);
            }
            if (cena.getPosicaoOK() == false && !(e.getSource().equals(rbAcima)) && !(e.getSource().equals(rbAbaixo))) {
                pitch = cena.toRadianos(cena.getElevacao() + cena.getBeta() + cena.getGama()) - (float) Math.PI;
                rbFixa.setSelected(true);
            }
            this.requestFocus();
        }
        this.atualizaTexto();

    }

    public float getFatorCI() {
        try {
            return Float.parseFloat(txtFatorCI.getText());
        } catch (NumberFormatException nfe) {
            System.out.println(nfe);
            return 0;
        }
    }

    public float getFatorPitch() {
        try {
            return cena.toRadianos(Float.parseFloat(txtFatorPitch.getText()));
        } catch (NumberFormatException nfe) {
            System.out.println(nfe);
            return 0;
        }
    }

    public void atualizaTexto() {
        this.txtEixoX.setText(String.format("%.1f", cena.getPontoX()).replace(',', '.'));
        this.txtEixoY.setText(String.format("%.1f", cena.getPontoY()).replace(',', '.'));
        this.txtEixoZ.setText(String.format("%.1f", cena.getPontoZ()).replace(',', '.'));
        this.txtPitch.setText(String.format("%.1f", cena.toGraus(pitch)).replace(',', '.'));
        this.txtRoll.setText(String.format("%.1f", cena.getRotacao()).replace(',', '.'));
    }

    public void keyTyped(KeyEvent evt) {
        char charPressionado = evt.getKeyChar();
        if (evt.getSource() instanceof JTextField) {
            if (evt.getSource() == this.txtFatorCI) {
            } else if (charPressionado == KeyEvent.VK_ENTER) {
                this.atualizaGrafico();
                this.requestFocus();
            } else if (charPressionado == KeyEvent.VK_ESCAPE) {
                this.atualizaTexto();
                this.requestFocus();
            } else if (charPressionado != '.' && charPressionado != '-' && (charPressionado < KeyEvent.VK_0 || charPressionado > KeyEvent.VK_9)) {
                evt.setKeyChar('\0');
            }
        } else {
            if (charPressionado == KeyEvent.VK_1) {
                this.btEixoXPos.doClick();
                this.btEixoXPos.requestFocus();
                cena.NMTeclado();
            } else if (charPressionado == KeyEvent.VK_2) {
                this.btEixoYPos.doClick();
                this.btEixoYPos.requestFocus();
                cena.NMTeclado();
            } else if (charPressionado == KeyEvent.VK_3) {
                this.btEixoZPos.doClick();
                this.btEixoZPos.requestFocus();
                cena.NMTeclado();
            } else if (charPressionado == KeyEvent.VK_4) {
                this.btPitchPos.doClick();
                this.btPitchPos.requestFocus();
                cena.NMTeclado();
            } else if (charPressionado == KeyEvent.VK_5) {
                this.btRollPos.doClick();
                this.btRollPos.requestFocus();
                cena.NMTeclado();
            } else if (charPressionado == KeyEvent.VK_6) {
                this.btAbGarra.doClick();
                this.btAbGarra.requestFocus();
                cena.NMTeclado();
            } else if (charPressionado == KeyEvent.VK_Q || charPressionado == Character.toLowerCase(KeyEvent.VK_Q)) {
                this.btEixoXNeg.doClick();
                this.btEixoXNeg.requestFocus();
                cena.NMTeclado();
            } else if (charPressionado == KeyEvent.VK_W || charPressionado == Character.toLowerCase(KeyEvent.VK_W)) {
                this.btEixoYNeg.doClick();
                this.btEixoYNeg.requestFocus();
                cena.NMTeclado();
            } else if (charPressionado == KeyEvent.VK_E || charPressionado == Character.toLowerCase(KeyEvent.VK_E)) {
                this.btEixoZNeg.doClick();
                this.btEixoZNeg.requestFocus();
                cena.NMTeclado();
            } else if (charPressionado == KeyEvent.VK_R || charPressionado == Character.toLowerCase(KeyEvent.VK_R)) {
                this.btPitchNeg.doClick();
                this.btPitchNeg.requestFocus();
                cena.NMTeclado();
            } else if (charPressionado == KeyEvent.VK_T || charPressionado == Character.toLowerCase(KeyEvent.VK_T)) {
                this.btRollNeg.doClick();
                this.btRollNeg.requestFocus();
                cena.NMTeclado();
            } else if (charPressionado == KeyEvent.VK_Y || charPressionado == Character.toLowerCase(KeyEvent.VK_Y)) {
                this.btFecharGarra.doClick();
                this.btFecharGarra.requestFocus();
                cena.NMTeclado();
            }
            this.atualizaTexto();
        }
    }

    public void keyPressed(KeyEvent evt) {
    }

    public void keyReleased(KeyEvent arg0) {
    }

    private void atualizaGrafico() {
        try {

            float pontoX = Float.valueOf(this.txtEixoX.getText()).floatValue();
            float pontoY = Float.valueOf(this.txtEixoY.getText()).floatValue();
            float pontoZ = Float.valueOf(this.txtEixoZ.getText()).floatValue();
            pitch = cena.toRadianos(Float.valueOf(this.txtPitch.getText()).floatValue());
            float roll = cena.toRadianos(Float.valueOf(this.txtRoll.getText()).floatValue());
            //System.out.println("A:" + pontoX + "\nB:" + pontoY + "\nC:" + pontoZ + "\nD:" + pitch);
            cena.calcularInversa(-pontoX, pontoZ, pontoY, pitch, roll, cotovelo);
            if (Float.parseFloat(this.txtFatorPitch.getText()) > cena.maxFator) {
                txtFatorPitch.setText("" + cena.maxFator);
            }
            if (Float.parseFloat(this.txtFatorCI.getText()) > cena.maxFator) {
                txtFatorCI.setText("" + cena.maxFator);
            }
        } catch (NumberFormatException nfe) {
            JOptionPane.showMessageDialog(null, "Formato de Número Inválido!", "Erro", JOptionPane.ERROR_MESSAGE);
        }
        this.requestFocus();
    }

    public static void setRbAcima() {
        rbAcima.setSelected(true);
    }

    public static void setRbAbaixo() {
        rbAbaixo.setSelected(true);
    }

    public static void setAng234(float angulo) {
        pitch = angulo;
    }

    public void bloqueiaTXT() {
        txtEixoX.setEditable(false);
        txtEixoY.setEditable(false);
        txtEixoZ.setEditable(false);
    }

    public void liberaTXT() {
        txtEixoX.setEditable(true);
        txtEixoY.setEditable(true);
        txtEixoZ.setEditable(true);
    }
}  //  @jve:decl-index=0:visual-constraint="10,10"

