/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package virbot4u;

/**
 *
 * @author Alehoss
 */
import javax.swing.*;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.BorderFactory;

import java.awt.*;
import java.awt.Font;
import java.awt.Rectangle;
import java.awt.Color;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import Componentes.RList;
import Objetos.*;
import Colisao.CollisionManager;

public class JanelaObjetos extends JFrame implements ActionListener {

    private static final long serialVersionUID = 1L;
    private JPanel jContentPane = null;
    private JPanel pnAbGarra = null;
    private JButton btGerarObj = null;
    private JButton btRemoveObj = null;
    private JPanel pnAbBraco = null;
    private JLabel lblPropObj = null;
    private JLabel lblObjetos = null;
    private static RList lObjetos = null;
    private RList lObjInfo = null;
    public static PartManager obj;
    public CollisionManager detCol = new CollisionManager();
    private JLabel lblGeraObjeto = null;
    private JLabel lblNomeObjeto = null;
    private JLabel lblTipo = null;
    private JLabel lblCor = null;
    private JLabel lblLocal = null;
    private JLabel lblLocalX = null;
    private JLabel lblLocalY = null;
    private JLabel lblLocalZ = null;
    private JLabel lblTamanho = null;
    private JLabel lblAltura = null;
    private JLabel lblLargura = null;
    private JLabel lblComprimento = null;
    private JLabel lblRaio = null;
    private JLabel lblOrientacao = null;
    private JLabel lblAlinhamento = null;
    private JTextField txtNomeObjeto = null;
    private JSpinner txtLocalX = null;
    private JTextField txtLocalY = null;
    private JSpinner txtLocalZ = null;
    private JTextField txtAltura = null;
    private JTextField txtLargura = null;
    private JTextField txtComprimento = null;
    private JTextField txtRaio = null;
    private JTextField txtAlinhamento = null;
    private JComboBox cbTipo = null;
    private JComboBox cbCor = null;
    private JComboBox cbOrientacao = null;
    private JButton btConfirmaObj = null;
    private int idObjetoEscolhido = -1;
    private String nomeObjetos[] = {"Paralelepipedo", "Esfera", "Cilindro"};
    private String Orientacao[] = {"Em pé", "Deitado"};
    private float cores[][] = {{0, 0, 1}, {(float) 0.5, 0, (float) 0.5}, {0, 1, 0}, {0, 1, 1}, {1, 0, 1,}, {1, 1, 0,}, {1, 1, 1}};
    private String nomeCores[] = {"azul", "violeta", "verde", "ciano", "rosa", "amarelo", "branco"};
    double xp, yp, zp;
    int id2 = 0;
    boolean flagColisao;
    float orientacao = 0;
    static int idObj = 0;
    static int num = 0;
    private Rectangle tamanhoJanela;
    private Label tfeedback;
    private CenaX3D cena;
    public static ListaQuadrante lista = new ListaQuadrante(2.4, 0, 1.2, 0);

    /**
     * This is the default constructor
     */
    public JanelaObjetos(CenaX3D cena, Rectangle tamanhoJanela) {
        super();
        this.cena = cena;
        this.obj = cena.getPartManager();
        this.tamanhoJanela = tamanhoJanela;
        initialize();
    }

    /**
     * This method initializes this
     *
     * @return void
     */
    private void initialize() {
        this.setSize(380, 235);
        this.setLocation(tamanhoJanela.width - 565, 45);
        this.setContentPane(getJContentPane());
        this.setTitle("Objects");
        this.setIconImage(Toolkit.getDefaultToolkit().getImage("Figuras/larvao2.gif"));
        this.setAlwaysOnTop(false);
        this.setResizable(false);
        this.setVisible(true);
    }

    /**
     * This method initializes jContentPane
     *
     * @return javax.swing.JPanel
     */
    private JPanel getJContentPane() {
        if (jContentPane == null) {

            lblGeraObjeto = new JLabel("Gera Objeto");
            lblGeraObjeto.setBounds(new Rectangle(120, 205, 250, 17));
            lblGeraObjeto.setFont(new Font("Tahoma", 1, 12));
            lblNomeObjeto = new JLabel("Nome");
            lblNomeObjeto.setBounds(new Rectangle(5, 230, 85, 17));
            lblNomeObjeto.setFont(new Font("Tahoma", 1, 12));
            lblTipo = new JLabel("Tipo");
            lblTipo.setBounds(new Rectangle(5, 255, 85, 17));
            lblTipo.setFont(new Font("Tahoma", 1, 12));
            lblCor = new JLabel("Cor");
            lblCor.setBounds(new Rectangle(5, 280, 85, 17));
            lblCor.setFont(new Font("Tahoma", 1, 12));
            lblLocal = new JLabel("Posição");
            lblLocal.setBounds(new Rectangle(5, 380, 85, 17));
            lblLocal.setFont(new Font("Tahoma", 1, 12));
            lblLocalX = new JLabel("X");
            lblLocalX.setBounds(new Rectangle(5, 405, 85, 17));
            lblLocalX.setFont(new Font("Tahoma", 1, 12));
            lblLocalY = new JLabel("Y");
            lblLocalY.setBounds(new Rectangle(125, 405, 85, 17));
            lblLocalY.setFont(new Font("Tahoma", 1, 12));
            lblLocalZ = new JLabel("Z");
            lblLocalZ.setBounds(new Rectangle(245, 405, 85, 17));
            lblLocalZ.setFont(new Font("Tahoma", 1, 12));
            lblTamanho = new JLabel("Tamanho");
            lblTamanho.setBounds(new Rectangle(5, 305, 85, 17));
            lblTamanho.setFont(new Font("Tahoma", 1, 12));
            lblAltura = new JLabel("Altura");
            lblAltura.setBounds(new Rectangle(125, 330, 85, 17));
            lblAltura.setFont(new Font("Tahoma", 1, 12));
            lblLargura = new JLabel("Larg.");
            lblLargura.setBounds(new Rectangle(5, 330, 85, 17));
            lblLargura.setFont(new Font("Tahoma", 1, 12));
            lblComprimento = new JLabel("Comp.");
            lblComprimento.setBounds(new Rectangle(245, 330, 85, 17));
            lblComprimento.setFont(new Font("Tahoma", 1, 12));
            lblRaio = new JLabel("Raio");
            lblRaio.setBounds(new Rectangle(5, 355, 85, 17));
            lblRaio.setFont(new Font("Tahoma", 1, 12));
            lblOrientacao = new JLabel("Orientação");
            lblOrientacao.setBounds(new Rectangle(5, 430, 85, 17));
            lblOrientacao.setFont(new Font("Tahoma", 1, 12));
            lblAlinhamento = new JLabel("Alinhamento");
            lblAlinhamento.setBounds(new Rectangle(5, 455, 95, 17));
            lblAlinhamento.setFont(new Font("Tahoma", 1, 12));
            txtNomeObjeto = new JTextField();
            txtNomeObjeto.setBounds(new Rectangle(125, 230, 145, 20));
            txtNomeObjeto.setFont(new Font("Tahoma", 1, 12));
            txtNomeObjeto.setEnabled(false);
            txtLocalX = new JSpinner(new SpinnerNumberModel(0, -12, 12, 0.001));
            txtLocalX.setBounds(new Rectangle(55, 405, 65, 20));
            txtLocalX.setFont(new Font("Tahoma", 1, 12));
            txtLocalX.setEnabled(false);
            txtLocalY = new JTextField();
            txtLocalY.setBounds(new Rectangle(170, 405, 65, 20));
            txtLocalY.setFont(new Font("Tahoma", 1, 12));
            txtLocalY.setEnabled(false);
            txtLocalZ = new JSpinner(new SpinnerNumberModel(0, -12, 12, 0.001));
            txtLocalZ.setBounds(new Rectangle(300, 405, 65, 20));
            txtLocalZ.setFont(new Font("Tahoma", 1, 12));
            txtLocalZ.setEnabled(false);
            txtAltura = new JTextField();
            txtAltura.setBounds(new Rectangle(170, 330, 65, 20));
            txtAltura.setFont(new Font("Tahoma", 1, 12));
            txtAltura.setEnabled(false);
            txtLargura = new JTextField();
            txtLargura.setBounds(new Rectangle(55, 330, 65, 20));
            txtLargura.setFont(new Font("Tahoma", 1, 12));
            txtLargura.setEnabled(false);
            txtComprimento = new JTextField();
            txtComprimento.setBounds(new Rectangle(300, 330, 65, 20));
            txtComprimento.setFont(new Font("Tahoma", 1, 12));
            txtComprimento.setEnabled(false);
            txtRaio = new JTextField();
            txtRaio.setBounds(new Rectangle(55, 355, 65, 19));
            txtRaio.setFont(new Font("Tahoma", 1, 12));
            txtRaio.setEnabled(false);
            txtAlinhamento = new JTextField();
            txtAlinhamento.setBounds(new Rectangle(125, 455, 145, 20));
            txtAlinhamento.setFont(new Font("Tahoma", 1, 12));
            txtAlinhamento.setEnabled(false);
            cbTipo = new JComboBox(nomeObjetos);
            cbTipo.setBounds(new Rectangle(125, 255, 145, 20));
            cbTipo.setFont(new Font("Tahoma", 1, 12));
            cbTipo.setEnabled(false);
            cbTipo.addActionListener(this);
            cbCor = new JComboBox(nomeCores);
            cbCor.setBounds(new Rectangle(125, 280, 145, 20));
            cbCor.setFont(new Font("Tahoma", 1, 12));
            cbCor.setEnabled(false);
            cbOrientacao = new JComboBox(Orientacao);
            cbOrientacao.setBounds(new Rectangle(125, 430, 145, 20));
            cbOrientacao.setFont(new Font("Tahoma", 1, 12));
            cbOrientacao.setEnabled(false);
            cbOrientacao.addActionListener(this);
            jContentPane = new JPanel();
            jContentPane.setLayout(null);
            jContentPane.add(lblGeraObjeto, null);
            jContentPane.add(lblNomeObjeto, null);
            jContentPane.add(lblTipo, null);
            jContentPane.add(lblCor, null);
            jContentPane.add(lblLocal, null);
            jContentPane.add(lblLocalX, null);
            jContentPane.add(lblLocalY, null);
            jContentPane.add(lblLocalZ, null);
            jContentPane.add(lblTamanho, null);
            jContentPane.add(lblAltura, null);
            jContentPane.add(lblLargura, null);
            jContentPane.add(lblComprimento, null);
            jContentPane.add(lblRaio, null);
            jContentPane.add(lblOrientacao, null);
            jContentPane.add(lblAlinhamento, null);
            jContentPane.add(txtNomeObjeto, null);
            jContentPane.add(txtLocalX, null);
            jContentPane.add(txtLocalY, null);
            jContentPane.add(txtLocalZ, null);
            jContentPane.add(txtAltura, null);
            jContentPane.add(txtLargura, null);
            jContentPane.add(txtComprimento, null);
            jContentPane.add(txtAlinhamento, null);
            jContentPane.add(txtRaio, null);
            jContentPane.add(cbTipo, null);
            jContentPane.add(cbCor, null);
            jContentPane.add(cbOrientacao, null);
            jContentPane.add(getBtConfirmaObj(), null);
            jContentPane.add(getPnAbGarra(), null);
            jContentPane.add(getBtGerarObj(), null);
            jContentPane.add(getBtRemoveObj(), null);
            jContentPane.add(getPnAbBraco(), null);
            jContentPane.add(getLObjetos(), null);
            jContentPane.add(getLObjInfo(), null);
        }
        return jContentPane;
    }

    /**
     * This method initializes pnAbGarra
     *
     * @return javax.swing.JPanel
     */
    private JPanel getPnAbGarra() {
        if (pnAbGarra == null) {
            lblObjetos = new JLabel();
            lblObjetos.setBounds(new Rectangle(35, 7, 63, 17));
            lblObjetos.setText("Objects");
            lblObjetos.setFont(new Font("Tahoma", 1, 12));
            pnAbGarra = new JPanel();
            pnAbGarra.setLayout(null);
            pnAbGarra.setBounds(new Rectangle(5, 5, 150, 30));
            pnAbGarra.setBorder(BorderFactory.createLineBorder(new Color(0, 0, 255)));
            pnAbGarra.add(lblObjetos, null);
        }
        return pnAbGarra;
    }

    /**
     * This method initializes btGerarObj
     *
     * @return javax.swing.JButton
     */
    private JButton getBtGerarObj() {
        if (btGerarObj == null) {
            btGerarObj = new JButton();
            btGerarObj.setBounds(new Rectangle(5, 170, 150, 30));
            btGerarObj.setText("Create Objects");
            btGerarObj.setFont(new Font("Tahoma", 1, 12));
            btGerarObj.addActionListener(this);
        }
        return btGerarObj;
    }

    private JButton getBtRemoveObj() {
        if (btRemoveObj == null) {
            btRemoveObj = new JButton();
            btRemoveObj.setBounds(new Rectangle(160, 170, 210, 30));
            btRemoveObj.setText("Remove All Objects");
            btRemoveObj.setFont(new Font("Tahoma", 1, 12));
            btRemoveObj.addActionListener(this);
        }
        return btRemoveObj;
    }

    private JButton getBtConfirmaObj() {
        if (btConfirmaObj == null) {
            btConfirmaObj = new JButton("Confirm");
            btConfirmaObj.setBounds(new Rectangle(125, 480, 145, 30));
            btConfirmaObj.setFont(new Font("Tahoma", 1, 12));
            btConfirmaObj.setEnabled(false);
            btConfirmaObj.addActionListener(this);
        }
        return btConfirmaObj;
    }

    /**
     * This method initializes pnAbBraco
     *
     * @return javax.swing.JPanel
     */
    private JPanel getPnAbBraco() {
        if (pnAbBraco == null) {
            lblPropObj = new JLabel();
            lblPropObj.setBounds(new Rectangle(5, 7, 185, 16));
            lblPropObj.setText("Object Properties");
            lblPropObj.setFont(new Font("Tahoma", 1, 12));
            pnAbBraco = new JPanel();
            pnAbBraco.setLayout(null);
            pnAbBraco.setBounds(new Rectangle(160, 5, 210, 30));
            pnAbBraco.setBorder(BorderFactory.createLineBorder(new Color(0, 0, 255)));
            pnAbBraco.add(lblPropObj, null);
        }
        return pnAbBraco;
    }

    /**
     * This method initializes lObjetos
     *
     * @return javax.swing.JList
     */
    private RList getLObjetos() {
        if (lObjetos == null) {
            lObjetos = new RList(this);
            //.setBorder(BorderFactory.createLineBorder(new Color(0, 0, 255)));
            lObjetos.setBounds(new Rectangle(5, 35, 150, 125));
            lObjetos.setFont(new Font("Tahoma", 1, 12));
        }
        return lObjetos;
    }

    /**
     * This method initializes lObjInfo
     *
     * @return javax.swing.JList
     */
    private RList getLObjInfo() {
        if (lObjInfo == null) {
            lObjInfo = new RList(this);
            //lObjInfo.setBorder(BorderFactory.createLineBorder(new Color(0, 0, 255)));
            lObjInfo.setBounds(new Rectangle(160, 35, 210, 125));
            lObjInfo.setFont(new Font("Tahoma", 1, 12));
        }
        return lObjInfo;
    }

    public static ListaQuadrante getLista() {
        return JanelaObjetos.lista;
    }

    public static int getNObjetos() {
        return num;
    }

    public static void setLObjetos(Esfera aux) {
        JanelaObjetos.lObjetos.addO(aux.getNome(), null);
        idObj++;
        num++;
    }

    public static void setLObjetos(Paralelepipedo aux) {
        JanelaObjetos.lObjetos.addO(aux.getNome(), null);
        idObj++;
        num++;
    }

    public static void setLObjetos(Cilindro aux) {
        JanelaObjetos.lObjetos.addO(aux.getNome(), null);
        idObj++;
        num++;
    }
    /*public static void setLista(Esfera aux) {
    JanelaObjetos.lista.insereObjeto(aux);
    JanelaObjetos.obj.setString(JanelaObjetos.obj.geraStringX3DEsfera(aux, JanelaObjetos.idObj));
    JanelaObjetos.idObj++;
    JanelaObjetos.lObjetos.addO(aux.getNome(), null);
    }
    public static void setLista(Paralelepipedo aux) {
    JanelaObjetos.lista.insereObjeto(aux);
    JanelaObjetos.obj.setString(JanelaObjetos.obj.geraStringX3DParalelepipedo(aux, JanelaObjetos.idObj));
    JanelaObjetos.idObj++;
    JanelaObjetos.lObjetos.addO(aux.getNome(), null);
    }
    public static void setLista(Cilindro aux) {
    JanelaObjetos.lista.insereObjeto(aux);
    JanelaObjetos.obj.setString(JanelaObjetos.obj.geraStringX3DCilindro(aux, JanelaObjetos.idObj));
    JanelaObjetos.idObj++;
    JanelaObjetos.lObjetos.addO(aux.getNome(), null);
    }*/

    public void setIdioma(String idioma) {
        if (idioma.equals("Portugues")) {
            this.setTitle("Objetos");
            this.lblObjetos.setText("Objetos");
            this.btGerarObj.setText("Gerar Objeto");
            this.btRemoveObj.setText("Remover Todos os Objetos");
            this.lblPropObj.setText("Propriedades do Objeto");
            this.lblGeraObjeto.setText("Gera Objeto");
            this.lblNomeObjeto.setText("Nome");
            this.lblTipo.setText("Tipo");
            this.lblCor.setText("Cor");
            this.lblLocal.setText("Posição");
            this.lblTamanho.setText("Tamanho");
            this.lblAltura.setText("Altura");
            this.lblLargura.setText("Larg.");
            this.lblComprimento.setText("Comp.");
            this.lblRaio.setText("Raio");
            this.lblOrientacao.setText("Orientação");
            this.lblAlinhamento.setText("Alinhamento");
            this.btConfirmaObj.setText("Confirma");
            cbTipo.removeAllItems();
            cbTipo.addItem("Paralelepípedo");
            cbTipo.addItem("Esfera");
            cbTipo.addItem("Cilindro");
            cbOrientacao.removeAllItems();
            cbOrientacao.addItem("Em pé");
            cbOrientacao.addItem("Deitado");
            cbCor.removeAllItems();
            cbCor.addItem("azul");
            cbCor.addItem("violeta");
            cbCor.addItem("verde");
            cbCor.addItem("ciano");
            cbCor.addItem("rosa");
            cbCor.addItem("amarelo");
            cbCor.addItem("branco");
        }
        if (idioma.equals("Ingles")) {
            this.setTitle("Objects");
            this.lblObjetos.setText("Objects");
            this.btGerarObj.setText("Create Object");
            this.btRemoveObj.setText("Remove All Objects");
            this.lblPropObj.setText("Object Properties");
            this.lblGeraObjeto.setText("Creating Object");
            this.lblNomeObjeto.setText("Name");
            this.lblTipo.setText("Type");
            this.lblCor.setText("Color");
            this.lblLocal.setText("Position");
            this.lblTamanho.setText("Size");
            this.lblAltura.setText("Height");
            this.lblLargura.setText("width");
            this.lblComprimento.setText("Length");
            this.lblRaio.setText("Radius");
            this.lblOrientacao.setText("Guidance");
            this.lblAlinhamento.setText("Alignment");
            this.btConfirmaObj.setText("Confirm");
            cbTipo.removeAllItems();
            cbTipo.addItem("Box");
            cbTipo.addItem("Sphere");
            cbTipo.addItem("Cylinder");
            cbOrientacao.removeAllItems();
            cbOrientacao.addItem("Standing");
            cbOrientacao.addItem("Lying");
            cbCor.removeAllItems();
            cbCor.addItem("blue");
            cbCor.addItem("violet");
            cbCor.addItem("green");
            cbCor.addItem("cyan");
            cbCor.addItem("pink");
            cbCor.addItem("yellow");
            cbCor.addItem("white");
        }
    }

    public void setDaodosObj() {
        lblGeraObjeto.setText("Geração de Objeto");
        int tipoObj = cbTipo.getSelectedIndex();
        txtAltura.setEnabled(false);
        txtLargura.setEnabled(false);
        txtComprimento.setEnabled(false);
        txtRaio.setEnabled(false);
        int num2 = num;
        for (int i = 0; i < this.lObjetos.getItemCount(); i++) {
            if (lObjetos.getItem(i).equals(cbTipo.getSelectedItem() + "" + num2)) {
                num2 = num2 + 1;
            }
        }
        txtNomeObjeto.setText(cbTipo.getSelectedItem() + "" + num2);
        if (tipoObj == 0) {
            txtAltura.setEnabled(true);
            txtLargura.setEnabled(true);
            txtComprimento.setEnabled(true);
        }
        if (tipoObj == 1) {
            txtRaio.setEnabled(true);
        }
        if (tipoObj == 2) {
            txtAltura.setEnabled(true);
            txtRaio.setEnabled(true);
        }
        txtLargura.setText(String.format("%.3f", obj.randEntreDouble(0.05, 0.1)));
        txtAltura.setText(String.format("%.3f", obj.randEntreDouble(0.05, 0.2)));
        txtComprimento.setText(String.format("%.3f", obj.randEntreDouble(0.05, 0.1)));
        txtRaio.setText(String.format("%.3f", obj.randEntreDouble(0.04, 0.08)));
        txtAlinhamento.setHorizontalAlignment(JTextField.RIGHT);
        txtAlinhamento.setText("0.0");
        if (cbTipo.getSelectedIndex() == 0) {
            xp = obj.randEntreDouble(0.2, 1.2 - Math.max(Double.parseDouble(txtLargura.getText().replace(',', '.')), Double.parseDouble(txtComprimento.getText().replace(',', '.'))));
            if (obj.randEntreInt(0, 1) == 1) {
                xp = -xp;
            }
            zp = obj.randEntreDouble(0.2, 0.6 - Math.max(Double.parseDouble(txtLargura.getText().replace(',', '.')), Double.parseDouble(txtComprimento.getText().replace(',', '.'))));
            if (obj.randEntreInt(0, 1) == 1) {
                zp = -zp;
            }
            if (cbOrientacao.getSelectedIndex() == 0) {
                yp = Double.parseDouble(txtAltura.getText().replace(',', '.')) / 2;
            } else {
                yp = Double.parseDouble(txtLargura.getText().replace(',', '.')) / 2;
            }
        }
        if (cbTipo.getSelectedIndex() == 1) {
            xp = obj.randEntreDouble(0.2, 1.2 - Double.parseDouble(txtLargura.getText().replace(',', '.')));
            if (obj.randEntreInt(0, 1) == 1) {
                xp = -xp;
            }
            zp = obj.randEntreDouble(0.2, 0.6 - Double.parseDouble(txtRaio.getText().replace(',', '.')));
            if (obj.randEntreInt(0, 1) == 1) {
                zp = -zp;
            }
            yp = Double.parseDouble(txtRaio.getText().replace(',', '.'));
        }
        if (cbTipo.getSelectedIndex() == 2) {
            xp = obj.randEntreDouble(0.2, 1.2 - Math.max(Double.parseDouble(txtRaio.getText().replace(',', '.')), Double.parseDouble(txtAltura.getText().replace(',', '.'))));
            if (obj.randEntreInt(0, 1) == 1) {
                xp = -xp;
            }
            zp = obj.randEntreDouble(0.2, 0.6 - Math.max(Double.parseDouble(txtRaio.getText().replace(',', '.')), Double.parseDouble(txtAltura.getText().replace(',', '.'))));
            if (obj.randEntreInt(0, 1) == 1) {
                zp = -zp;
            }
            if (cbOrientacao.getSelectedIndex() == 0) {
                yp = Double.parseDouble(txtAltura.getText().replace(',', '.')) / 2;
            } else {
                yp = Double.parseDouble(txtRaio.getText().replace(',', '.'));
            }
        }
        txtLocalX.setValue(xp);
        txtLocalY.setText(String.format("%.3f", yp));
        txtLocalZ.setValue(zp);
    }

    public void actionPerformed(ActionEvent e) {
        tfeedback = new Label();
        if (e.getSource() == this.btGerarObj) {
            //this.lObjetos.removeAll();
            try {
                flagColisao = true;

                xp = 0;
                yp = 0;
                zp = 0;
                this.setSize(380, 550);
                txtNomeObjeto.setEnabled(true);
                cbTipo.setEnabled(true);
                cbCor.setEnabled(true);
                cbOrientacao.setEnabled(true);
                txtLocalX.setEnabled(true);
                txtLocalY.setEnabled(true);
                txtLocalZ.setEnabled(true);
                txtAlinhamento.setEnabled(true);
                btConfirmaObj.setEnabled(true);
                setDaodosObj();

            } catch (NumberFormatException e2) {
                tfeedback.setText("Favor entrar com valor entre 0-20");
            }
        }
        if (e.getSource() == this.btRemoveObj) {
            RemoveObjetos();
        }
        if (e.getSource() == this.cbTipo) {
            setDaodosObj();
        }
        if (e.getSource() == this.cbOrientacao) {
            if (cbTipo.getSelectedIndex() == 0) {
                if (cbOrientacao.getSelectedIndex() == 0) {
                    yp = Double.parseDouble(txtAltura.getText().replace(',', '.')) / 2;
                } else {
                    yp = Double.parseDouble(txtComprimento.getText().replace(',', '.')) / 2;
                }
            }
            if (cbTipo.getSelectedIndex() == 2) {
                if (cbOrientacao.getSelectedIndex() == 0) {
                    yp = Double.parseDouble(txtAltura.getText().replace(',', '.')) / 2;
                } else {
                    yp = Double.parseDouble(txtRaio.getText().replace(',', '.'));
                }
            }
            txtLocalY.setText(String.format("%.3f", yp));
        }

        if (e.getSource() == this.btConfirmaObj) {
            if (num < 30) {
                int i;
                int deitado = 0;
                for (i = 0; i < this.lObjetos.getItemCount(); i++) {
                    if (lObjetos.getItem(i).equals(txtNomeObjeto.getText())) {
                        JOptionPane.showMessageDialog(null, "Nome do objeto já existe!", "Erro", JOptionPane.ERROR_MESSAGE);
                        return;
                    }
                }
                flagColisao = true;
                id2 = cbCor.getSelectedIndex();
                String tipoGeo = new String("" + cbTipo.getSelectedIndex());
                if (tipoGeo.equals("0")) // Gera Paralelepipedo
                {
                    double xp = Double.parseDouble("" + txtLocalX.getValue());
                    double zp = Double.parseDouble("" + txtLocalZ.getValue());
                    while (flagColisao) {
                        String nome = "Paralelepípedo " + this.nomeCores[id2];
                        Paralelepipedo aux = new Paralelepipedo(
                                Double.parseDouble(txtLargura.getText().replace(',', '.')),
                                Double.parseDouble(txtAltura.getText().replace(',', '.')),
                                Double.parseDouble(txtComprimento.getText().replace(',', '.')), nome);
                        if (Double.parseDouble(txtLocalY.getText().replace(',', '.'))
                                >= Double.parseDouble(txtAltura.getText().replace(',', '.')) / 2) {
                            aux.setPosicao(xp, Double.parseDouble(txtLocalY.getText().replace(',', '.')) - 0.48, zp);
                        } else {
                            aux.setPosicao(xp, Double.parseDouble(txtAltura.getText().replace(',', '.')) / 2 - 0.48, zp);
                        }
                        aux.setAnguloY(Double.parseDouble(txtAlinhamento.getText().replace(',', '.')));
                        if (cbOrientacao.getSelectedIndex() == 0) {
                            aux.setAnguloX(0);
                            deitado = 0;
                        } else {
                            aux.setAnguloX(1.57);
                            deitado = 1;
                        }
                        aux.setCor(this.cores[id2]);
                        int x = 0;
                        if (!(obj.testaObjLista1(aux.getObbTree()))) {
                            this.obj.adicionaLista1(idObj);
                            x++;
                            flagColisao = false;
                        }
                        if (!(obj.testaObjLista2(aux.getObbTree()))) {
                            this.obj.adicionaLista2(idObj);
                            x += 2;
                            flagColisao = false;
                        }
                        if (flagColisao == false) {
                            if (!(detCol.testaColisaoObbRobo(aux.getObbTree(), cena))) {
                                this.obj.getListaQuadrante().insereObjeto(aux, 0);
                                this.obj.setString(obj.geraStringX3DParalelepipedo(aux, idObj, deitado));
                                idObj++;
                            } else {
                                switch (x) {
                                    case (1):
                                        this.obj.retiraLista1();
                                        break;
                                    case (2):
                                        this.obj.retiraLista2();
                                        break;
                                    case (3):
                                        this.obj.retiraLista1();
                                        this.obj.retiraLista2();
                                        break;
                                }
                                flagColisao = true;
                            }
                        }
                        if (flagColisao) {
                            xp = obj.randEntreDouble(0.2, 1.2 - Math.max(
                                    Double.parseDouble(txtLargura.getText().replace(',', '.')),
                                    Double.parseDouble(txtAltura.getText().replace(',', '.'))));
                            if (obj.randEntreInt(0, 1) == 1) {
                                xp -= xp;
                            }
                            zp = obj.randEntreDouble(0.2, 0.6 - Math.max(
                                    Double.parseDouble(txtLargura.getText().replace(',', '.')),
                                    Double.parseDouble(txtAltura.getText().replace(',', '.'))));
                            if (obj.randEntreInt(0, 1) == 1) {
                                zp -= zp;
                            }
                        }
                    }
                } //Fim tipo geometrico paralelepipedo
                else if (tipoGeo.equals("1")) // Gera Esfera
                {
                    double xp = Double.parseDouble("" + txtLocalX.getValue());
                    double zp = Double.parseDouble("" + txtLocalZ.getValue());
                    while (flagColisao) {

                        String nome = "Esfera " + this.nomeCores[id2];
                        Esfera aux = new Esfera(
                                Double.parseDouble(txtRaio.getText().replace(',', '.')), nome);
                        if (Double.parseDouble(txtLocalY.getText().replace(',', '.'))
                                >= Double.parseDouble(txtRaio.getText().replace(',', '.'))) {
                            aux.setPosicao(xp, Double.parseDouble(txtLocalY.getText().replace(',', '.')) - 0.48, zp);
                        } else {
                            aux.setPosicao(xp, Double.parseDouble(txtRaio.getText().replace(',', '.')) - 0.48, zp);
                        }
                        //Obb voltada ao robo
                        //float ang = (float)Math.atan2(aux.getPosicao()[2],-aux.getPosicao()[0]);
                        aux.setAnguloY(Double.parseDouble(txtAlinhamento.getText().replace(',', '.')));
                        aux.setCor(this.cores[id2]);
                        int x = 0;
                        if (!(obj.testaObjLista1(aux.getObbTree()))) {
                            this.obj.adicionaLista1(idObj);
                            x = 1;
                            flagColisao = false;
                        }
                        if (!(obj.testaObjLista2(aux.getObbTree()))) {
                            this.obj.adicionaLista2(idObj);
                            if (x == 1) {
                                x = 3;
                            } else {
                                x = 2;
                            }
                            flagColisao = false;
                        }
                        if (flagColisao == false) {
                            if (!(detCol.testaColisaoObbRobo(aux.getObbTree(), cena))) {
                                this.obj.getListaQuadrante().insereObjeto(aux, 0);
                                this.obj.setString(obj.geraStringX3DEsfera(aux, idObj));
                                idObj++;
                            } else {
                                switch (x) {
                                    case (1):
                                        this.obj.retiraLista1();
                                        break;
                                    case (2):
                                        this.obj.retiraLista2();
                                        break;
                                    case (3):
                                        this.obj.retiraLista1();
                                        this.obj.retiraLista2();
                                        break;
                                }
                                flagColisao = true;
                            }

                        }
                        if (flagColisao) {
                            xp = obj.randEntreDouble(0.2, 1.2 - Double.parseDouble(txtRaio.getText().replace(',', '.')));
                            if (obj.randEntreInt(0, 1) == 1) {
                                xp = -xp;
                            }
                            zp = obj.randEntreDouble(0.2, 0.6 - Double.parseDouble(txtRaio.getText().replace(',', '.')));
                            if (obj.randEntreInt(0, 1) == 1) {
                                zp = -zp;
                            }
                        }
                    }
                } //Fim tipo geometrico Esfera
                else if (tipoGeo.equals("2")) // Gera Cilindro
                {
                    double xp = Double.parseDouble("" + txtLocalX.getValue());
                    double zp = Double.parseDouble("" + txtLocalZ.getValue());
                    while (flagColisao) {
                        String nome = "Cilindro " + this.nomeCores[id2];
                        Cilindro aux = new Cilindro(
                                Double.parseDouble(txtRaio.getText().replace(',', '.')),
                                Double.parseDouble(txtAltura.getText().replace(',', '.')), nome);
                        aux.setCor(this.cores[id2]);
                        if (Double.parseDouble(txtLocalY.getText().replace(',', '.'))
                                >= Double.parseDouble(txtAltura.getText().replace(',', '.')) / 2) {
                            aux.setPosicao(xp, Double.parseDouble(txtLocalY.getText().replace(',', '.')) - 0.48, zp);
                        } else {
                            aux.setPosicao(xp, Double.parseDouble(txtAltura.getText().replace(',', '.')) / 2 - 0.48, zp);
                        }
                        if (cbOrientacao.getSelectedIndex() == 0) {
                            aux.setAnguloX(0);
                            deitado = 0;
                        } else {
                            aux.setAnguloX(1.57);
                            deitado = 1;
                        }
                        aux.setAnguloY(Double.parseDouble(txtAlinhamento.getText().replace(',', '.')));
                        //Obb voltada ao rob�
                        Double.parseDouble(txtAlinhamento.getText().replace(',', '.'));
                        //aux.setAnguloY(ang);
                        int x = 0;
                        if (!(obj.testaObjLista1(aux.getObbTree()))) {
                            this.obj.adicionaLista1(idObj);
                            x = 1;
                            flagColisao = false;
                        }
                        if (!(obj.testaObjLista2(aux.getObbTree()))) {
                            this.obj.adicionaLista2(idObj);
                            if (x == 1) {
                                x = 3;
                            } else {
                                x = 2;
                            }
                            flagColisao = false;
                        }
                        if (flagColisao == false) {
                            if (!(detCol.testaColisaoObbRobo(aux.getObbTree(), cena))) {
                                this.obj.getListaQuadrante().insereObjeto(aux, 0);
                                this.obj.setString(obj.geraStringX3DCilindro(aux, idObj, deitado));
                                idObj++;
                            } else {
                                switch (x) {
                                    case (1):
                                        this.obj.retiraLista1();
                                        break;
                                    case (2):
                                        this.obj.retiraLista2();
                                        break;
                                    case (3):
                                        this.obj.retiraLista1();
                                        this.obj.retiraLista2();
                                        break;
                                }
                                flagColisao = true;
                            }

                        }
                        if (flagColisao) {
                            xp = obj.randEntreDouble(0.2, 1.2 - Math.max(
                                    Double.parseDouble(txtRaio.getText().replace(',', '.')),
                                    Double.parseDouble(txtAltura.getText().replace(',', '.'))));
                            if (obj.randEntreInt(0, 1) == 1) {
                                xp = -xp;
                            }
                            zp = obj.randEntreDouble(0.2, 0.6 - Math.max(
                                    Double.parseDouble(txtRaio.getText().replace(',', '.')),
                                    Double.parseDouble(txtAltura.getText().replace(',', '.'))));
                            if (obj.randEntreInt(0, 1) == 1) {
                                zp = -zp;
                            }
                        }
                    }
                } //Fim tipo geometrico Cilindro
                obj.carregaListasObb();
                //tfeedback.setText(this.obj.gerador1(this.cena, num));

                //String nomes[] = this.obj.getListaNomesObj();

                //for (int i = 0; i<this.obj.getNumeroObjetosGerados(); i++)
                //{
                this.lObjetos.addO(txtNomeObjeto.getText(), null);
                num++;
                //this.lObjetos.addO(nomes[i], null);
                //}
            } else {
                JOptionPane.showMessageDialog(null, "Número máximo de 30 objetos alcançado");
            }
            idObjetoEscolhido = -1;
            this.setSize(380, 235);
            txtNomeObjeto.setEnabled(false);
            cbTipo.setEnabled(false);
            cbCor.setEnabled(false);
            cbOrientacao.setEnabled(false);
            txtLocalX.setEnabled(false);
            txtLocalY.setEnabled(false);
            txtLocalZ.setEnabled(false);
            txtAltura.setEnabled(false);
            txtLargura.setEnabled(false);
            txtComprimento.setEnabled(false);
            txtRaio.setEnabled(false);
            txtAlinhamento.setEnabled(false);
            btConfirmaObj.setEnabled(false);
            lObjInfo.removeAll();
        }
        if (e.getSource() == this.lObjetos) {
            this.lObjInfo.removeAll();
            idObjetoEscolhido = this.lObjetos.getSelectedIndex();
            String texto[] = this.obj.getTextoPosicao(idObjetoEscolhido, this.obj.getListaQuadrante());

            if (texto != null) {
                //this.lObjInfo.addO("Objeto ", this.lObjetos.getSelectedItem());
                //this.lObjInfo.addO("", "");
                for (int i = 0; i < 7; i++) {
                    if (texto[i].charAt(0) == 'x') {
                        this.lObjInfo.addO("x " + (Double.parseDouble(texto[i].substring(2).replace(',', '.')) * 640), texto[i]);
                    }
                    if (texto[i].charAt(0) == 'z') {
                        this.lObjInfo.addO("z " + (Double.parseDouble(texto[i].substring(2).replace(',', '.')) * 640), texto[i]);
                    }
                    if (texto[i].charAt(0) == 'y') {
                        this.lObjInfo.addO("y " + (Double.parseDouble(texto[i].substring(2).replace(',', '.')) * 640), texto[i]);
                    }
                    if (texto[i].charAt(0) != 'x' && texto[i].charAt(0) != 'y' && texto[i].charAt(0) != 'z') {
                        this.lObjInfo.addO(texto[i], texto[i]);
                    }
                }
            }
        }
    }

    public void RemoveObjetos() {
        this.lObjetos.removeAll();
        this.lObjInfo.removeAll();
        this.obj.limpaMesa(idObj);
        this.obj.getListaQuadrante().limpaLista();
        idObj = 0;
        num = 0;
    }
}  //  @jve:decl-index=0:visual-constraint="10,10"

