/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package virbot4u;

/**
 *
 * @author Cleber
 */
import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.*;
import Componentes.RList;
import Robo.*;
import Objetos.*;

public class SalvaArquivo extends JFrame implements ActionListener {

    private Rectangle tamanhoJanela;
    private JanelaPrincipal janelaPrincipal;
    private CenaX3D cena;
    private JPanel jContentPane = null;
    private JButton btSalvar = null;
    private JButton btCarregar = null;
    private JButton btCancelar = null;
    private JLabel lblNome = null;
    private JLabel lblNome2 = null;
    private JLabel lblNome3 = null;
    private JTextField txtNome = null;
    private JTextField txtNome2 = null;
    private JTextField txtNome3 = null;
    private JComboBox cbNome = null;
    private JComboBox cbNome2 = null;
    private JComboBox cbNome3 = null;
    public static PartManager obj;
    private String tipo = null;
    public static JanelaObjetos Jobj;

    public SalvaArquivo(CenaX3D cena, Rectangle tamanhoJanela, String tipo) {
        super();
        this.cena = cena;
        this.janelaPrincipal = cena.getJanelaPrincipal();
        this.obj = cena.getPartManager();
        this.tamanhoJanela = tamanhoJanela;
        this.tipo = tipo;
        initialize();
    }

    private void initialize() {
        this.setSize(310, 200);
        this.setLocation(tamanhoJanela.width - 365, tamanhoJanela.height - 465);
        this.setContentPane(getJContentPane());
        this.setIconImage(Toolkit.getDefaultToolkit().getImage("Figuras/larvao2.gif"));
        this.setAlwaysOnTop(true);
        this.setResizable(false);
        this.setVisible(true);
    }

    private JPanel getJContentPane() {
        if (jContentPane == null) {
            btSalvar = new JButton("Salvar");
            btSalvar.setBounds(new Rectangle(5, 130, 145, 30));
            btSalvar.setFont(new Font("Tahoma", 1, 14));
            btSalvar.addActionListener(this);
            btCarregar = new JButton("Carregar");
            btCarregar.setBounds(new Rectangle(5, 130, 145, 30));
            btCarregar.setFont(new Font("Tahoma", 1, 14));
            btCarregar.addActionListener(this);
            btCancelar = new JButton("Cancelar");
            btCancelar.setBounds(new Rectangle(155, 130, 145, 30));
            btCancelar.setFont(new Font("Tahoma", 1, 14));
            btCancelar.addActionListener(this);
            lblNome = new JLabel("Nome");
            lblNome.setBounds(new Rectangle(5, 50, 65, 20));
            lblNome.setFont(new Font("Tahoma", 1, 14));
            lblNome2 = new JLabel("Pontos");
            lblNome2.setBounds(new Rectangle(5, 100, 75, 20));
            lblNome2.setFont(new Font("Tahoma", 1, 14));
            lblNome3 = new JLabel("Programa");
            lblNome3.setBounds(new Rectangle(5, 150, 75, 20));
            lblNome3.setFont(new Font("Tahoma", 1, 14));
            txtNome = new JTextField();
            txtNome.setBounds(new Rectangle(80, 50, 220, 30));
            txtNome.setFont(new Font("Tahoma", 1, 14));
            jContentPane = new JPanel();
            jContentPane.setLayout(null);
            if (tipo.substring(0).equals("S Projeto") || tipo.substring(0).equals("C Projeto")) {
                this.setSize(310, 300);
                btSalvar.setBounds(new Rectangle(5, 230, 145, 30));
                btCarregar.setBounds(new Rectangle(5, 230, 145, 30));
                btCancelar.setBounds(new Rectangle(155, 230, 145, 30));
                lblNome.setText("Objetos");
                lblNome.setBounds(new Rectangle(5, 50, 75, 20));
                txtNome.setBounds(new Rectangle(80, 50, 220, 30));
                txtNome2 = new JTextField();
                txtNome2.setBounds(new Rectangle(80, 100, 220, 30));
                txtNome2.setFont(new Font("Tahoma", 1, 14));
                txtNome3 = new JTextField();
                txtNome3.setBounds(new Rectangle(80, 150, 220, 30));
                txtNome3.setFont(new Font("Tahoma", 1, 14));
                jContentPane.add(lblNome2, null);
                jContentPane.add(lblNome3, null);
                if (tipo.substring(0, 1).equals("S")) {
                    jContentPane.add(txtNome2, null);
                    jContentPane.add(txtNome3, null);
                }
                if (!tipo.substring(0, 1).equals("S")) {
                    jContentPane.add(getcbNome2(), null);
                    jContentPane.add(getcbNome3(), null);
                }
            }
            jContentPane.add(lblNome, null);
            if (tipo.substring(0, 1).equals("S")) {
                jContentPane.add(btSalvar, null);
                jContentPane.add(txtNome, null);
            }
            if (!tipo.substring(0, 1).equals("S")) {
                jContentPane.add(btCarregar, null);
                jContentPane.add(getcbNome(), null);
            }
            jContentPane.add(btCancelar, null);
        }
        return jContentPane;
    }

    private JComboBox getcbNome() {
        if (cbNome == null) {
            cbNome = new JComboBox();
            cbNome.setBounds(new Rectangle(80, 50, 220, 20));
            cbNome.setFont(new Font("Tahoma", 1, 14));
            if (tipo.equals("Carregar Objetos") || tipo.equals("C Projeto")) {
                File f = new File("Objetos");
                String[] files = f.list(new FilenameFilter() {

                    public boolean accept(File dir, String name) {
                        return name.endsWith(".x3d");
                    }
                });
                for (int i = 0; i < files.length; ++i) {
                    cbNome.addItem(files[i]);
                }
            }
            if (tipo.equals("Carregar Pontos")) {
                File f = new File("Pontos");
                String[] files = f.list(new FilenameFilter() {

                    public boolean accept(File dir, String name) {
                        return name.endsWith(".pnt");
                    }
                });
                for (int i = 0; i < files.length; ++i) {
                    cbNome.addItem(files[i]);
                }
            }
            if (tipo.equals("Carregar Programas")) {
                File f = new File("Programas");
                String[] files = f.list(new FilenameFilter() {

                    public boolean accept(File dir, String name) {
                        return name.endsWith(".prj");
                    }
                });
                for (int i = 0; i < files.length; ++i) {
                    cbNome.addItem(files[i]);
                }
            }
            cbNome.addActionListener(this);
        }
        return cbNome;
    }

    private JComboBox getcbNome2() {
        if (cbNome2 == null) {
            cbNome2 = new JComboBox();
            cbNome2.setBounds(new Rectangle(80, 100, 220, 20));
            cbNome2.setFont(new Font("Tahoma", 1, 14));
            File f = new File("Pontos");
            String[] files = f.list(new FilenameFilter() {

                public boolean accept(File dir, String name) {
                    return name.endsWith(".pnt");
                }
            });
            for (int i = 0; i < files.length; ++i) {
                cbNome2.addItem(files[i]);
            }
            cbNome2.addActionListener(this);
        }
        return cbNome2;
    }

    private JComboBox getcbNome3() {
        if (cbNome3 == null) {
            cbNome3 = new JComboBox();
            cbNome3.setBounds(new Rectangle(80, 150, 220, 20));
            cbNome3.setFont(new Font("Tahoma", 1, 14));
            File f = new File("Programas");
            String[] files = f.list(new FilenameFilter() {

                public boolean accept(File dir, String name) {
                    return name.endsWith(".prj");
                }
            });
            for (int i = 0; i < files.length; ++i) {
                cbNome3.addItem(files[i]);
            }
            cbNome3.addActionListener(this);
        }
        return cbNome3;
    }

    public void setIdioma(String idioma) {
        if (idioma.equals("Portugues")) {
            if (tipo.equals("Salvar Objetos")) {
                this.setTitle("Salvar Objetos");
            }
            if (tipo.equals("Salvar Pontos")) {
                this.setTitle("Salvar Pontos");
            }
            if (tipo.equals("Salvar Programas")) {
                this.setTitle("Salvar Programas");
            }
            if (tipo.equals("S Projeto")) {
                this.setTitle("Salvar Projeto");
            }
            if (tipo.equals("Carregar Objetos")) {
                this.setTitle("Carregar Objetos");
            }
            if (tipo.equals("Carregar Pontos")) {
                this.setTitle("Carregar Pontos");
            }
            if (tipo.equals("Carregar Programas")) {
                this.setTitle("Carregar Programas");
            }
            if (tipo.equals("C Projeto")) {
                this.setTitle("Carregar Projeto");
            }
            if (tipo.substring(0).equals("S Projeto") || tipo.substring(0).equals("C Projeto")) {
                lblNome.setText("Objetos");
            } else {
                lblNome.setText("Nome");
            }
            btSalvar.setText("Salvar");
            btCarregar.setText("Carregar");
            btCancelar.setText("Cancelar");
            lblNome2.setText("Pontos");
            lblNome3.setText("Programas");

        }
        if (idioma.equals("Ingles")) {
            if (tipo.equals("Salvar Objetos")) {
                this.setTitle("Save Objects");
            }
            if (tipo.equals("Salvar Pontos")) {
                this.setTitle("Save Ponts");
            }
            if (tipo.equals("Salvar Programas")) {
                this.setTitle("Save Programs");
            }
            if (tipo.equals("S Projeto")) {
                this.setTitle("Save Project");
            }
            if (tipo.equals("Carregar Objetos")) {
                this.setTitle("Load Objects");
            }
            if (tipo.equals("Carregar Pontos")) {
                this.setTitle("Load Ponts");
            }
            if (tipo.equals("Carregar Programas")) {
                this.setTitle("Load Programs");
            }
            if (tipo.equals("C Projeto")) {
                this.setTitle("Load Project");
            }
            if (tipo.substring(0).equals("S Projeto") || tipo.substring(0).equals("C Projeto")) {
                lblNome.setText("Objects");
            } else {
                lblNome.setText("Name");
            }
            btSalvar.setText("Save");
            btCarregar.setText("Load");
            btCancelar.setText("Cancel");
            lblNome2.setText("Points");
            lblNome3.setText("Programs");
        }
    }

    public void salvaObjetos(JTextField txtArquivo) {
        File f = new File("Objetos\\" + txtArquivo.getText() + ".x3d");
        try {
            ListaQuadrante lista;
            lista = obj.getListaQuadrante();
            String linha = new String("");
            for (int i = 0; i < lista.tamanho(); i++) {
                String texto = lista.getNomeObjetoPos(i);
                float cor[] = lista.getCorObjPos(i);
                String tipo2 = lista.tipoComponente(i).substring(14);

                if (tipo2.equals("Paralelepipedo")) {
                    Paralelepipedo p = lista.getComponenteParalelepipedo(i);
                    double[] centro = p.getPosicao();
                    String rotacao;
                    if (p.getAnguloX() == 1.57) {
                        rotacao = new String("rotation ='0.0 0.0 1.0 ");
                    } else {
                        rotacao = new String("rotation ='0.0 1.0 0.0 ");
                    }
                    linha = linha
                            + "#Box\r\n"
                            + "<Transform translation ='"
                            + (centro[0])
                            + " "
                            + (centro[1])
                            + " "
                            + (centro[2])
                            + "' rotation ='1.0 0.0 0.0 "
                            + p.getAnguloX()
                            + "'>\r\n"
                            + " <Transform "
                            + rotacao
                            + p.getAngulo()
                            + "'>\r\n <Shape>\r\n"
                            + " <Appearance>\r\n"
                            + "<Material DEF='" + texto + "' diffuseColor='"
                            + cor[0]
                            + " "
                            + cor[1]
                            + " "
                            + cor[2]
                            + "'/> </Appearance>\r\n"
                            + " <Box size='"
                            + p.getLargura()
                            + " "
                            + p.getAltura()
                            + " "
                            + p.getComprimento()
                            + "'/>\r\n"
                            + " </Shape>\r\n"
                            + " </Transform>\r\n"
                            + " </Transform>\r\n";
                }
                if (tipo2.equals("Esfera")) {
                    Esfera es = lista.getComponenteEsfera(i);
                    double[] centro = es.getPosicao();
                    linha = linha
                            + "#Sphere\r\n"
                            + "<Transform translation ='"
                            + (centro[0])
                            + " "
                            + (centro[1])
                            + " "
                            + (centro[2])
                            + "'>\r\n <Shape>\r\n"
                            + " <Appearance>\r\n"
                            + "<Material DEF='" + texto + "' diffuseColor='"
                            + cor[0]
                            + " "
                            + cor[1]
                            + " "
                            + cor[2]
                            + "'/> </Appearance>\r\n"
                            + " <Sphere radius='"
                            + es.getRaio()
                            + "'/>\r\n"
                            + " </Shape>\r\n"
                            + " </Transform>\r\n";
                }
                if (tipo2.equals("Cilindro")) {
                    Cilindro c = lista.getComponenteCilindro(i);
                    double[] centro = c.getPosicao();
                    String rotacao;
                    if (c.getAnguloX() == 1.57) {
                        rotacao = new String("rotation ='0.0 0.0 1.0 ");
                    } else {
                        rotacao = new String("rotation ='0.0 1.0 0.0 ");
                    }
                    linha = linha
                            + "#Cylinder\r\n"
                            + "<Transform translation ='"
                            + (centro[0])
                            + " "
                            + (centro[1])
                            + " "
                            + (centro[2])
                            + "' rotation ='1.0 0.0 0.0 "
                            + c.getAnguloX()
                            + "'>\r\n"
                            + " <Transform "
                            + rotacao
                            + c.getAnguloY()
                            + "'>\r\n  <Shape>\r\n"
                            + " <Appearance>\r\n"
                            + "<Material DEF='" + texto + "' diffuseColor='"
                            + cor[0]
                            + " "
                            + cor[1]
                            + " "
                            + cor[2]
                            + "'/> </Appearance>\r\n"
                            + " <Cylinder height ='"
                            + c.getAltura()
                            + "' "
                            + " radius ='"
                            + c.getRaio()
                            + "'/>\r\n"
                            + " </Shape>\r\n"
                            + " </Transform>\r\n"
                            + " </Transform>\r\n";
                }
            }
            if (linha.equals("")) {
                JOptionPane.showMessageDialog(null, "Arquivo em branco!", "Erro", JOptionPane.ERROR_MESSAGE);
                this.lblNome.setText("");
                this.setVisible(false);
                return;
                //s1= "Aquivo tera conteúdo em branco, manter conteudo?";
                //new Alertas(s1);
            } else {
                linha = "<?xml version='1.0' encoding='UTF-8'?>\r\n"
                        + "<!--DOCTYPE X3D PUBLIC 'ISO//Web3D//DTD X3D 3.2//EN' 'http://www.web3d.org/specifications/x3d-3.2.dtd'-->\r\n"
                        + "<X3D profile='Immersive' version='3.0' xmlns:xsd='http://www.w3.org/2001/XMLSchema-instance' xsd:noNamespaceSchemaLocation='http://www.web3d.org/specifications/x3d-3.2.xsd'>\r\n"
                        + "<Scene>\r\n"
                        + linha
                        + " </Scene>\r\n"
                        + "</X3D>";
            }
            FileOutputStream arq = new FileOutputStream(f);
            // estabelece o arquivo físico
            DataOutputStream entrada = new DataOutputStream(arq);
            // associa o arquivo lógico ao arquivo físico
            entrada.writeBytes(linha);

            this.lblNome.setText("");
            this.setVisible(false);
            // a classe DataOutputStream fornece várias outras formas de escrever em arquivo

            entrada.close();
        } catch (FileNotFoundException e1) {
            System.out.print("Não foi possivel estabelece o arquivo físico");
        } catch (IOException e2) {
            System.out.print("Não foi associa o arquivo lógico ao arquivo físico");
        }
    }

    public void salvaPontos(JTextField txtArquivo) {
        File f = new File("Pontos\\" + txtArquivo.getText() + ".pnt");
        try {
            int id = 0;
            RList lComandos = null;
            lComandos = JanelaPonto.getListaDePontos();
            String linha = new String();
            if (lComandos != null) {
                while (lComandos.getObjeto(id) != null) {
                    Ponto aa = (Ponto) lComandos.getObjeto(id);
                    linha = new String(linha + "Nome: " + aa.getNomePonto() + "\r\nX: " + aa.getX() + "\r\nY: " + aa.getY() + "\r\nZ: " + aa.getZ() + "\r\nAlfa: " + aa.getAlfa() + "\r\nBeta: " + aa.getBeta() + "\r\nGama: " + aa.getGama() + "\r\nElevacao: " + aa.getElevacao() + "\r\nRotacao: " + aa.getRotacao() + "\r\n\r\n");
                    id++;
                }//String linha = new String(obj.filhoObj[id].getText());
            }
            if (linha.equals("")) {
                JOptionPane.showMessageDialog(null, "Arquivo em branco!", "Erro", JOptionPane.ERROR_MESSAGE);
                this.lblNome.setText("");
                this.setVisible(false);
                return;
                //s1= "Aquivo tera conteúdo em branco, manter conteudo?";
                //new Alertas(s1);
            }
            FileOutputStream arq = new FileOutputStream(f);
            // estabelece o arquivo físico
            DataOutputStream entrada = new DataOutputStream(arq);
            // associa o arquivo lógico ao arquivo físico
            entrada.writeBytes(linha);
            this.lblNome.setText("");
            this.setVisible(false);
            // a classe DataOutputStream fornece várias outras formas de escrever em arquivo

            entrada.close();
        } catch (FileNotFoundException e1) {
            System.out.print("Não foi possivel estabelece o arquivo físico");
        } catch (IOException e2) {
            System.out.print("Não foi associa o arquivo lógico ao arquivo físico");
        }
    }

    public void salvaPrograma(JTextField txtArquivo) {
        File f = new File("Programas\\" + txtArquivo.getText() + ".prj");
        try {
            int id = 0;
            JTextArea programa = JanelaPrograma.getTxtProgSave();
            String linha = new String("");
            if (programa != null) {
                linha = programa.getText();
            }
            //String linha = new String(obj.filhoObj[id].getText());
            if (linha.equals("")) {
                JOptionPane.showMessageDialog(null, "Arquivo em branco!", "Erro", JOptionPane.ERROR_MESSAGE);
                this.lblNome.setText("");
                this.setVisible(false);
                return;
                //s1= "Aquivo tera conteúdo em branco, manter conteudo?";
                //new Alertas(s1);
            }
            FileOutputStream arq = new FileOutputStream(f);
            // estabelece o arquivo físico
            DataOutputStream entrada = new DataOutputStream(arq);
            // associa o arquivo lógico ao arquivo físico
            entrada.writeBytes(linha);
            this.lblNome.setText("");
            this.setVisible(false);
            // a classe DataOutputStream fornece várias outras formas de escrever em arquivo

            entrada.close();
        } catch (FileNotFoundException e1) {
            System.out.print("Não foi possivel estabelece o arquivo físico");
        } catch (IOException e2) {
            System.out.print("Não foi associa o arquivo lógico ao arquivo físico");
        }
    }

    public void carregarObjetos(String Arquivo, int fixos, String novoNome) {
        try {
            BufferedReader in = new BufferedReader(new FileReader("Objetos\\" + Arquivo));
            String tipoN = new String("    ");
            String nome = new String("");
            double rotacoes = 0;
            float[] cor = new float[3];
            double[] centro = new double[3];
            double[] rotacoes2 = new double[4];
            double[] size = new double[3];
            double raio = 0, altura = 0;
            String translacao = new String("");
            String str;
            janelaPrincipal.testaJanelaObj();
            while (in.ready()) {
                str = in.readLine();
                translacao = "";
                if (str.substring(0, 1).equals("#") || str.substring(0, 4).equals("</X3")) {
                    if (Jobj.getNObjetos() >= 30) {
                        JOptionPane.showMessageDialog(null, "Número máximo de 30 objetos alcançado");
                        break;
                    }
                    if (tipoN.equals("Box")) {
                        //mandar objeto
                        Paralelepipedo aux = new Paralelepipedo(size[0], size[1], size[2], nome);
                        aux.setCor(cor);
                        aux.setAnguloX(rotacoes);
                        aux.setAnguloY(rotacoes2[3]);
                        aux.setPosicao(centro[0], centro[1], centro[2]);
                        cena.getPartManager().getListaQuadrante().setLista(aux, cena, fixos);
                    }
                    if (tipoN.equals("Sphere")) {
                        //mandar objeto
                        Esfera aux = new Esfera(raio, nome);
                        aux.setCor(cor);
                        aux.setAnguloY(rotacoes2[3]);
                        aux.setPosicao(centro[0], centro[1], centro[2]);
                        cena.getPartManager().getListaQuadrante().setLista(aux, cena, fixos);
                    }
                    if (tipoN.equals("Cylinder")) {
                        //mandar objeto
                        Cilindro aux = new Cilindro(raio, altura, nome);
                        aux.setCor(cor);
                        aux.setAnguloX(rotacoes);
                        aux.setAnguloY(rotacoes2[3]);
                        aux.setPosicao(centro[0], centro[1], centro[2]);
                        cena.getPartManager().getListaQuadrante().setLista(aux, cena, fixos);
                    }
                    tipoN = str.substring(1);
                    if (str.substring(0, 4).equals("</X3")) {
                        break;
                    }
                    str = in.readLine();
                }
                if (str.substring(0, 5).equals("<Tran")) {
                    str = str.substring(25);
                    int i = 0, cont = 0;
                    while (!str.substring(i, i + 1).equals("'")) {
                        if (str.substring(i, i + 1).equals(" ")) {
                            i++;
                        }
                        while ((!str.substring(i, i + 1).equals(" ")) && (!str.substring(i, i + 1).equals("'"))) {
                            translacao = translacao + str.substring(i, i + 1);
                            i++;
                        }
                        if (cont == 0) {
                            centro[0] = Double.parseDouble(translacao);
                        }
                        if (cont == 1) {
                            centro[1] = Double.parseDouble(translacao);
                        }
                        if (cont == 2) {
                            centro[2] = Double.parseDouble(translacao);
                        }
                        translacao = "";
                        cont++;
                    }
                    if (tipoN.equals("Box") || tipoN.equals("Cylinder")) {
                        cont = 0;
                        i++;
                        while (!str.substring(i, i + 1).equals("'")) {
                            i++;
                        }
                        i++;
                        while (!str.substring(i, i + 1).equals("'")) {
                            if (str.substring(i, i + 1).equals(" ")) {
                                i++;
                            }
                            while ((!str.substring(i, i + 1).equals(" ")) && (!str.substring(i, i + 1).equals("'"))) {
                                translacao = translacao + str.substring(i, i + 1);
                                i++;
                            }
                            if (cont == 3) {
                                rotacoes = Double.parseDouble(translacao);
                            }
                            translacao = "";
                            cont++;
                        }
                        in.ready();
                        str = in.readLine();
                        cont = 0;
                        i = 0;
                        while (!str.substring(i, i + 1).equals("'")) {
                            i++;
                        }
                        i++;
                        while (!str.substring(i, i + 1).equals("'")) {
                            if (str.substring(i, i + 1).equals(" ")) {
                                i++;
                            }
                            while ((!str.substring(i, i + 1).equals(" ")) && (!str.substring(i, i + 1).equals("'"))) {
                                translacao = translacao + str.substring(i, i + 1);
                                i++;
                            }
                            if (cont == 0) {
                                rotacoes2[0] = Double.parseDouble(translacao);
                            }
                            if (cont == 1) {
                                rotacoes2[1] = Double.parseDouble(translacao);
                            }
                            if (cont == 2) {
                                rotacoes2[2] = Double.parseDouble(translacao);
                            }
                            if (cont == 3) {
                                rotacoes2[3] = Double.parseDouble(translacao);
                            }
                            translacao = "";
                            cont++;
                        }
                    }
                }
                if (str.substring(0, 5).equals("<Mate")) {
                    //nome, cor
                    int i = 0, cont = 0;
                    while (!str.substring(i, i + 1).equals("'")) {
                        i++;
                    }
                    i++;
                    while (!str.substring(i, i + 1).equals("'")) {
                        if (str.substring(i, i + 1).equals(" ")) {
                            i++;
                        }
                        while ((!str.substring(i, i + 1).equals(" ")) && (!str.substring(i, i + 1).equals("'"))) {
                            translacao = translacao + str.substring(i, i + 1);
                            i++;
                        }
                        if (cont == 0) {
                            nome = translacao;
                        }
                    }
                    if (novoNome != null) {
                        nome = novoNome;
                    }
                    translacao = "";
                    cont = 0;
                    i++;
                    while (!str.substring(i, i + 1).equals("'")) {
                        i++;
                    }
                    i++;
                    while (!str.substring(i, i + 1).equals("'")) {
                        if (str.substring(i, i + 1).equals(" ")) {
                            i++;
                        }
                        while ((!str.substring(i, i + 1).equals(" ")) && (!str.substring(i, i + 1).equals("'"))) {
                            translacao = translacao + str.substring(i, i + 1);
                            i++;
                        }
                        if (cont == 0) {
                            cor[0] = Float.parseFloat(translacao.replace(',', '.'));
                        }
                        if (cont == 1) {
                            cor[1] = Float.parseFloat(translacao.replace(',', '.'));
                        }
                        if (cont == 2) {
                            cor[2] = Float.parseFloat(translacao.replace(',', '.'));
                        }
                        translacao = "";
                        cont++;
                    }
                }
                if (str.substring(2, 5).equals(tipoN.substring(0, 3))) {
                    int i = 0, cont = 0;
                    translacao = "";
                    //marcas do objeto
                    if (tipoN.endsWith("Box")) {
                        i = 0;
                        cont = 0;
                        while (!str.substring(i, i + 1).equals("'")) {
                            i++;
                        }
                        i++;
                        while (!str.substring(i, i + 1).equals("'")) {
                            if (str.substring(i, i + 1).equals(" ")) {
                                i++;
                            }
                            while ((!str.substring(i, i + 1).equals(" ")) && (!str.substring(i, i + 1).equals("'"))) {
                                translacao = translacao + str.substring(i, i + 1);
                                i++;
                            }
                            if (cont == 0) {
                                size[0] = Double.parseDouble(translacao.replace(',', '.'));
                            }
                            if (cont == 1) {
                                size[1] = Double.parseDouble(translacao.replace(',', '.'));
                            }
                            if (cont == 2) {
                                size[2] = Double.parseDouble(translacao.replace(',', '.'));
                            }
                            translacao = "";
                            cont++;
                        }
                    }
                    if (tipoN.endsWith("Sphere")) {
                        i = 0;
                        while (!str.substring(i, i + 1).equals("'")) {
                            i++;
                        }
                        i++;
                        while (!str.substring(i, i + 1).equals("'")) {
                            if (str.substring(i, i + 1).equals(" ")) {
                                i++;
                            }
                            while ((!str.substring(i, i + 1).equals(" ")) && (!str.substring(i, i + 1).equals("'"))) {
                                translacao = translacao + str.substring(i, i + 1);
                                i++;
                            }
                            raio = Double.parseDouble(translacao.replace(',', '.'));
                        }
                    }
                    if (tipoN.endsWith("Cylinder")) {
                        i = 0;
                        while (!str.substring(i, i + 1).equals("'")) {
                            i++;
                        }
                        i++;
                        while (!str.substring(i, i + 1).equals("'")) {
                            if (str.substring(i, i + 1).equals(" ")) {
                                i++;
                            }
                            while ((!str.substring(i, i + 1).equals(" ")) && (!str.substring(i, i + 1).equals("'"))) {
                                translacao = translacao + str.substring(i, i + 1);
                                i++;
                            }
                            altura = Double.parseDouble(translacao.replace(',', '.'));
                        }
                        translacao = "";
                        i++;
                        while (!str.substring(i, i + 1).equals("'")) {
                            i++;
                        }
                        i++;
                        while (!str.substring(i, i + 1).equals("'")) {
                            if (str.substring(i, i + 1).equals(" ")) {
                                i++;
                            }
                            while ((!str.substring(i, i + 1).equals(" ")) && (!str.substring(i, i + 1).equals("'"))) {
                                translacao = translacao + str.substring(i, i + 1);
                                i++;
                            }
                            raio = Double.parseDouble(translacao.replace(',', '.'));
                        }
                    }
                }
            }
            in.close();
        } catch (IOException e3) {
        }
    }

    public void carregarPontos(String Arquivo) {
        try {
            BufferedReader in = new BufferedReader(new FileReader("Pontos\\" + Arquivo));
            String str;
            String nome = new String();
            float[] xyz2 = new float[3];
            float[] angul = new float[5];
            Ponto xyz = null;
            janelaPrincipal.testaJanelaPonto();
            while (in.ready()) {
                str = in.readLine();
                if (str.equals("")) {
                    xyz = new Ponto(
                            nome,
                            xyz2[0], xyz2[1], xyz2[2],
                            angul[0], angul[1], angul[2], angul[3], angul[4]);
                    JanelaPonto.setListaDePontos(xyz);
                } else {
                    if (str.substring(0, 1).equals("N")) {
                        nome = str.substring(6);
                    }
                    if (str.substring(0, 1).equals("X")) {
                        xyz2[0] = Float.parseFloat(str.substring(3));
                    }
                    if (str.substring(0, 1).equals("Y")) {
                        xyz2[1] = Float.parseFloat(str.substring(3));
                    }
                    if (str.substring(0, 1).equals("Z")) {
                        xyz2[2] = Float.parseFloat(str.substring(3));
                    }
                    if (str.substring(0, 1).equals("A")) {
                        angul[0] = Float.parseFloat(str.substring(5));
                    }
                    if (str.substring(0, 1).equals("B")) {
                        angul[1] = Float.parseFloat(str.substring(5));
                    }
                    if (str.substring(0, 1).equals("G")) {
                        angul[2] = Float.parseFloat(str.substring(5));
                    }
                    if (str.substring(0, 1).equals("E")) {
                        angul[3] = Float.parseFloat(str.substring(9));
                    }
                    if (str.substring(0, 1).equals("R")) {
                        angul[4] = Float.parseFloat(str.substring(8));
                    }
                }
            }
            in.close();
        } catch (IOException e3) {
        }
    }

    public void carregarPrograma(String Arquivo) {
        try {
            BufferedReader in = new BufferedReader(new FileReader("Programas\\" + Arquivo));
            String str = new String();
            while (in.ready()) {
                str = str + in.readLine() + "\n";
            }
            janelaPrincipal.testaJanelaProg();
            JanelaPrograma.setTxtProgSave(str);
            in.close();
        } catch (IOException e3) {
        }
    }

    public void actionPerformed(ActionEvent e) {
        if (e.getSource() == this.btSalvar) {
            if (tipo.equals("Salvar Objetos")) {
                salvaObjetos(txtNome);
                //float angulo = Float.valueOf(this.txtBase.getText()).floatValue();
            }
            if (tipo.equals("Salvar Pontos")) {
                salvaPontos(txtNome);
                //float angulo = Float.valueOf(this.txtBase.getText()).floatValue();
            }
            if (tipo.equals("Salvar Programas")) {
                salvaPrograma(txtNome);
                //float angulo = Float.valueOf(this.txtBase.getText()).floatValue();
            }
            if (tipo.equals("S Projeto")) {
                salvaObjetos(txtNome);
                salvaPontos(txtNome2);
                salvaPrograma(txtNome3);
            }

        } else if (e.getSource() == this.btCancelar) {
            this.lblNome.setText("");
            this.setVisible(false);
        }
        if (e.getSource() == this.btCarregar) {
            if (tipo.equals("Carregar Objetos")) {
                String novoNome = null;
                carregarObjetos(cbNome.getSelectedItem().toString(), 0, novoNome);
            }
            if (tipo.equals("Carregar Pontos")) {
                carregarPontos(cbNome.getSelectedItem().toString());
            }
            if (tipo.equals("Carregar Programas")) {
                carregarPrograma(cbNome.getSelectedItem().toString());
            }
            if (tipo.equals("C Projeto")) {
                String novoNome = null;
                carregarObjetos(cbNome.getSelectedItem().toString(), 0, novoNome);
                carregarPontos(cbNome2.getSelectedItem().toString());
                carregarPrograma(cbNome3.getSelectedItem().toString());

            }
            this.lblNome.setText("");
            this.setVisible(false);
        }
    }
}
